(function () {
    'use strict';

    var app = angular.module('app', [
        // Angular modules 
        'ngAnimate',        // animations
        'ngRoute',          // routing
        'ngSanitize',       // sanitizes html bindings (ex: sidebar.js)
        'ngResource',
        // Custom modules 
        'common',           // common functions, logger, spinner
        //'common.bootstrap', // bootstrap dialog wrapper functions
       // 'ngGrid',
         'ngTouch',
        // 3rd Party Modules
     
        'ui.bootstrap',
             // ui-bootstrap (ex: carousel, pagination, dialog)
        //'n3-charts.linechart',//n3 graph
        'infinite-scroll', //infinite scroll
        'placeholderShim',
        'LocalStorageModule'
  

    ]);

    // Handle routing errors and success events
    app.run(['$route', '$window', '$rootScope','$animate', 'routeMediator', 'datacontext', 'userService', function ($route, $window, $rootScope,$animate,
        routeMediator, datacontext, userService) {
        //The moment you load, first check if the user is logged in or not at the server
        //Required because the user might refresh his/her browser
        userService.getLoggedInUser();
        $rootScope.online = true;

        if (!window.cordova) {
            $rootScope.online = navigator.onLine;
            $window.addEventListener("offline", function () {
                $rootScope.$apply(function () {
                    $rootScope.online = false;
                });
            }, false);
            $window.addEventListener("online", function () {
                $rootScope.$apply(function () {
                    $rootScope.online = true;
                });
            }, false);
        }

        document.addEventListener("deviceready", onDeviceReady, false);

        function onOnline() {
            $rootScope.$apply(function () {
                $rootScope.online = true;
            });
        }
        function onOffline() {
            $rootScope.$apply(function () {
                $rootScope.online = false;
            });
        }

        function onDeviceReady() {

            document.addEventListener("online", onOnline, false);
            document.addEventListener("offline", onOffline, false);

        }

        ////$window.addEventListener("offline", function () {
        ////    $rootScope.$apply(function () {
        ////        $rootScope.online = false;
        ////    });
        ////}, false);
        ////$window.addEventListener("online", function () {
        ////    $rootScope.$apply(function () {
        ////        $rootScope.online = true;
        ////    });
        ////}, false);

        routeMediator.setRoutingHandlers();
                
        //Retrieve user agent string
        var ua = navigator.userAgent;
        //Retrieve android version
        if (ua.indexOf("Android") >= 0) {
            var androidVersion = parseFloat(ua.slice(ua.indexOf("Android") + 8));
        // Check if the version is less than 4.0
            if (androidVersion < 4.0) {
        //Disable the animations
                $animate.enabled(false);
                $rootScope.isLowEndPhone = true;
            }
        }
        
    }]);
})();