(function () {
    'use strict';
    var controllerId = 'appointment';
    angular.module('app').controller(controllerId, ['common', '$scope', '$location', '$rootScope', 'datacontext', 'datarepo', appointment]);

    function appointment(common, $scope, $location, $rootScope, datacontext, datarepo) {
        var vm = this;
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        $scope.share = false;
        $scope.upcomingAppointmentsData = [];
        $scope.pastAppointmentsData = [];
        $scope.selectedDoctorName = "";
        $scope.selectedDoctorID = "";
        $scope.selectedDocName = '';
        $scope.selectedDocId = '';
        $scope.selectedApptId = '';
        $scope.upcomingEmpty = false;
        $scope.pastEmpty = false;
        $scope.selectedApptHospital = '';
        $scope.selectedApptDate = '';

        // $scope.doctorRatingByIndividualUser = '0';
        vm.ratingDoctorByIndividualUser = '0';
        vm.max = 5;

        $scope.shareUpcomingDoctorConfirm = function () {
            $scope.share = confirm("Do you wish to share this doctor ?");
            if ($scope.share == true) {
                common.shareSocially("Dr." + $scope.selectedDoctorName + " will be available in " + $scope.selectedApptHospital + " on " + $scope.selectedApptDate + " .");
                logSuccess("Successfully shared with friends", '', true);
            }
        }
        $scope.sharePastDoctorConfirm = function () {
            $scope.share = confirm("Do you wish to share this doctor ?");
            if ($scope.share == true) {
                common.shareSocially("Dr." + $scope.selectedDoctorName + " will be available in " + $scope.selectedApptHospital + " on " + $scope.selectedApptDate + " .");
                logSuccess("Successfully shared with friends", '', true);
            }
        }

        //-START-Toggle card content event handling
        $scope.toggleDetail = function ($index, ApptProviderName, ProviderID, id, hospital, date) {
            $scope.activePosition = $scope.activePosition == $index ? -1 : $index;
            $scope.selectedDoctorName = ApptProviderName;
            vm.rateDoctorName = ApptProviderName;
            $scope.selectedDoctorID = ProviderID;
            $scope.selectedApptId = id;
            $scope.selectedApptHospital = hospital;
            $scope.selectedApptDate = date;
        };
        //-END-Toggle card content event handling

        //Ratings configuration
        vm.openRatingModal = function () {
            $('#doctorRatingModal').modal('show');
        }
        vm.closeRatingModal = function () {
            vm.myRating = 0;
            $('#doctorRatingModal').modal('hide');
        }
        vm.myRating = 0;
        vm.max = 5;

        vm.saveRating = function () {
            return datacontext.appointment.saveMyFavouriteDoctorRating($scope.selectedDoctorID, vm.myRating).then(function (response) {
                logSuccess("Rating successfully added", '', true);
                $('#doctorRatingModal').modal('hide');
            }, function (response) {
                logError(response.message, '', true);
                $('#doctorRatingModal').modal('hide');
                vm.myRating = 0;
            });
        }
        //Rating cofiguration ends

        function getUpcomingAppointments() {
            return datacontext.appointment.getUpcomingAppointments().then(function (data) {
                if (data.length == 0) {
                    $scope.upcomingEmpty = true;
                }
                else {
                    $scope.upcomingEmpty = false;
                }
                return $scope.upcomingAppointmentsData = data;

            });
        }

        function getPastAppointments() {
            return datacontext.appointment.getPastAppointments().then(function (data) {
                if (data.length == 0) {
                    $scope.pastEmpty = true;
                }
                else {
                    $scope.pastEmpty = false;
                }
                return $scope.pastAppointmentsData = data;
            });
        }

        $scope.rateDoctor = function (upcomingAppt) {
            datacontext.appointment.setSelectedAppointment(upcomingAppt);
        };



        $scope.cancelAppointment = function (ApptId, $index) {

            var cancel = confirm("Do you wish to cancel this appointment ?");
            if (cancel == true) {
                $scope.upcomingAppointmentsData.splice($scope.upcomingAppointmentsData.indexOf($scope.upcomingAppointmentsData[$index]), 1);
                return datacontext.appointment.cancelSelectedAppointment(ApptId).then(function (response) {
                    logSuccess(response.message, '', true);
                    if ($scope.upcomingAppointmentsData.length == 0) {
                        $scope.upcomingEmpty = true;
                    }
                    else {
                        $scope.upcomingEmpty = false;
                    }
                    //getUpcomingAppointments();
                });
            }
        }
        //$scope.cancelAppointment = function () {
        //    var cancel = confirm("Do you wish to cancel this appointment ?");
        //    if (cancel == true) {
        //        return datacontext.appointment.cancelSelectedAppointment($scope.selectedApptId).then(function (response) {
        //            logSuccess(response.message, '', true);
        //            getUpcomingAppointments();
        //        });
        //    }
        //}

        //function onConfirm(buttonIndex) {
        //    alert('You selected button ' + buttonIndex);
        //    if (buttonIndex == 1) {
        //        return datacontext.appointment.cancelSelectedAppointment($scope.selectedApptId).then(function (response) {
        //            //alert(response.message);

        //            logSuccess(response.message, '', true);
        //            // alert("Your appointment has been cancelled successfully");
        //            getUpcomingAppointments();
        //        });
        //    }
        //}

        //$scope.cancelAppointment = function () {
        //    alert("sz");

        //    //  var cancel = confirm("Do you wish to cancel this appointment ?");
        //    navigator.notification.confirm(
        //       'Do you wish to cancel this appointment ?',  // message
        //        onConfirm,              // callback to invoke with index of button pressed
        //        'Cancel appointment',   // title
        //        'Yes,No'          // buttonLabels
        //     );
        //    return false;
        //    //onConfirm(1)
        //}






        // document.addEventListener('deviceready', deviceready, false);

        //function deviceready() {

        //    document.querySelector("#nConfirm").addEventListener("touchstart", function () {
        //        navigator.notification.confirm("Do you wish to cancel this appointment ?", onConfirm, "Cancel appointment", "Yes,No");
        //    }, false);

        //    function onConfirm(buttonIndex) {
        //        alert("Selected appointment id is: " + selectedApptId);
        //        alert('You selected button ' + buttonIndex);
        //    }

        //}
        // Show a custom confirmation dialog
        //var status = common.showConfirm('Do you wish to cancel this appointment ?', 'Cancel appointment', 'Yes,No');
        //alert(status);

        //function showConfirm() {
        //    navigator.notification.confirm(
        //        'Do you wish to cancel this appointment ?',  // message
        //         onConfirm,              // callback to invoke with index of button pressed
        //        'Cancel appointment',   // title
        //        'Yes,No'          // buttonLabels
        //    );

        //if (status == 1) {
        //    return datacontext.appointment.cancelSelectedAppointment(upcomingApptid).then(function (response) {
        //        logSuccess(response.message, '', true);
        //        // alert("Your appointment has been cancelled successfully");
        //        getUpcomingAppointments();
        //    });
        //}

        $scope.rebookAppointment = function (providerID, providerName, hospitalName) {
            $scope.selectedDocName = providerName
            $scope.selectedDocId = providerID;
            $scope.hosName = hospitalName;
            var date = new Date();
            var date = date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
            datarepo.commonrepo.saveProviderID(providerID, providerName);
            $location.path('/book_appointment');
            //getListOfTimeSlot(date, $scope.selectedDocId);
            // $('#re-book-modal').modal('show');
        }

        vm.loadPastAppointments = function () {
            getPastAppointments();

        }

        vm.loadUpcomingAppointments = function () {
            getUpcomingAppointments();
        }

        activate();

        function activate() {
            $rootScope.busyMessage = 'Please wait...';
            var promises = [getUpcomingAppointments()];
            common.activateController(promises, controllerId);
            //.then(function () { log('Activated Appointment View'); });
        }
    }

})();