﻿(function () {
    'use strict';
    var controllerId = 'bookAppointment';
    angular.module('app').controller(controllerId, ['common', '$scope','$rootScope', 'datacontext','$location','datarepo', bookAppointment]);

    function bookAppointment(common, $scope, $rootScope, datacontext, $location, datarepo) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');

        var vm = this;
        vm.title = 'Book Appointment';
        vm.notifications = [];
        vm.doctorDetailsData1 = "";
        vm.self = true;
        vm.family = false;
        var slotclick = 1;
        vm.slotinfo = [];
        vm.slottime = '';
        vm.slotdate = '';
        vm.childConsumerID = '';
        vm.noSchduleAvail = false;
        vm.loadingSchdule = false;
        vm.parentSchduleAvail = false;
        vm.selectedproviderId = '';
        var date = new Date();
        var date = date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
        vm.slotdate = moment(date).format("DD MMM, YYYY");
        //vm.slotdate = date;
        vm.otpbtn = true;
        vm.otptext = true;
        vm.loadingHospital = false;
        vm.parentbookAppPage = false;
        $scope.slotempty = false;
        vm.hospitalwithslot = true;
        vm.loadingHospital = false;
        vm.selectedFamilyMember = "";
        vm.selectedFamilyMemberId = "";
        vm.commonDropDownFilterDisplay = false;
        vm.commonDropDownFilteredValue = "";
        vm.commonDropDownPlaceHoldertext = "Fiter Relations";
        vm.isConfirmButtonDisabled = false;
        vm.confirmAppointmentLoader = false;


        $scope.toggleSelectedDoctorDetail = function ($index, cardDoctorName, providerid) {
            vm.loadingSchdule = true;
            $scope.activePosition = $scope.activePosition == $index ? -1 : $index;
            $scope.selectedDoctorName = cardDoctorName;
            if ($scope.activePosition != -1) {
                vm.parentSchduleAvail = false;
                return datacontext.appointment.GetScheduleForProvider(providerid).then(function (result) {
                    if (result[0].scheduleForMobile.length == 0) {

                        vm.noSchduleAvail = true;
                    }
                    else {
                        vm.noSchduleAvail = false;
                    }
                    vm.loadingSchdule = false;
                    vm.parentSchduleAvail = true;
                    return vm.doctorDetails = result;
                });
            }
        }; 
        $scope.activeHosPosition = 0;
        $scope.toggleSelectedHospitalDetail = function ($index) {
            $scope.activeHosPosition = $scope.activeHosPosition == $index ? -1 : $index;
            //$scope.activeHosPosition = $scope.activeHosPosition == $index ? -1 : $index;
        };
        $scope.activeTimeslotPosition = 0;
        $scope.toggleSelectedTimeslotDetail = function ($index) {
            vm.loadingSchdule = true;
            $scope.activeTimeslotPosition = $scope.activeTimeslotPosition == $index ? -1 : $index;
        };

        $scope.slotClick = function (slottimevalue, hosname) {

            vm.slottime = slottimevalue;
            vm.doctorName = vm.selecteddoctorsInfo[0].name;
            vm.hosName = hosname;
            vm.commonDropDownHeader = "Choose Family Member"
            GetFamilyListForDropDown();
            $('#confirmappointmentmodal').modal('show');
        };
        vm.toSelectFamilyMember = function () {
            $('#common-drop-down-modal').modal('show');
        }
        vm.bookAppointment = function () {
            //var currentSelectId = $('#familySelect').val();
            //var currentSelectText = $('#familySelect :selected').text();
            // vm.selectedFamilyMemberId
           
            vm.confirmAppointmentLoader = true;
            if (vm.selectedFamilyMemberId == 0) {
             //if (currentSelectId == 0) {
                var slotinfo = {
                    ProviderID: '',
                    TimeSlot: '',
                    Date: ''

                }
                slotinfo.ProviderID = vm.selectedproviderId;
                slotinfo.TimeSlot = vm.slottime;

                slotinfo.Date = vm.slotdate;
                //return datacontext.appointment.setBookAppointment(slotinfo).$promise.then(function (response) {
                return datacontext.appointment.setBookAppointment(slotinfo).then(function (response) {
                    vm.confirmAppointmentLoader = false;
                    verifyOtpFirstTimeUser(response);
                    getListOfTimeSlot(vm.slotdate, vm.selectedproviderId);
                }, function (response) { });
            }
            //else if (vm.selectedFamilyMemberId == -1) {
            //    alert("Please Select a Member");
            //}
            else {
                var slotinfo = {
                    ProviderID: '',
                    TimeSlot: '',
                    Date: '',
                    ChildConsumerID: ''
                }
                slotinfo.ProviderID = vm.selectedproviderId;
                slotinfo.TimeSlot = vm.slottime;
                slotinfo.Date = vm.slotdate;
                // slotinfo.ChildConsumerID = currentSelectId;
                slotinfo.ChildConsumerID = vm.selectedFamilyMemberId;
                //return datacontext.appointment.setBookAppointmentForfamily(slotinfo).$promise.then(function (response) {
                return datacontext.appointment.setBookAppointmentForfamily(slotinfo).then(function (response) {
                    vm.confirmAppointmentLoader = false;
                    verifyOtpFirstTimeUser(response);
                    getListOfTimeSlot(vm.slotdate, vm.selectedproviderId);
                }, function (response) { });
            }

        }

        function verifyOtpFirstTimeUser(response) {

            if (!response.consumerAppointment.hasVerifiedOTP) {
                alert(response.message);
                vm.isConfirmButtonDisabled = true;
                vm.otpbtn = false;
                vm.otptext = false;
            }
            else {

                vm.otpbtn = true;
                vm.otptext = true;
                vm.isConfirmButtonDisabled = false;
              
                //var s = "02:35";
         
                // alert(response.message);
                if (response.success == true) {
                    var sltTime = (vm.slottime).split(":");

                    var myDate = new Date(vm.slotdate);
                   // var x = new Date();
                   // int y = 5;
                    //var myDate = new Date(response.consumerAppointment.Date);
                    //var stratDate = myDate;
                    //var endDate = myDate;
                    var stratDate = new Date(vm.slotdate);
                    var endDate = new Date(vm.slotdate);
                    endDate.setHours(sltTime[0]);
                    endDate.setMinutes(sltTime[1]);
                    //stratDate.setHours(endDate.getHours() - 1);
                    stratDate.setTime(endDate.getTime() - 3600000);
                   // startDate.getTime() + 3600000
                    
                    common.addEventToCalendar("Appointment", vm.hosName, response.message, stratDate, endDate); //title, where, notes, startDate, endDate
                    common.gaTrackEvent('Book Appointment', 'Click Book Confirm', 'Dr. '+ vm.doctorName + ' ,' + vm.hosName );
                    logSuccess(response.message, '', true);
                }
                else {
                    logError(response.message, '', true);
                }
                $('#confirmappointmentmodal').modal('hide');
                $location.path('/view_appointments');
            }

        }
        vm.otpClick = function () {
            //return datacontext.appointment.sentOtp(vm.otp).$promise.then(function (response) {
            return datacontext.appointment.sentOtp(vm.otp).then(function (response) {
                if (response.success) {
                    //alert(response.message);
                    logSuccess(response.message, '', true);
                    vm.otpbtn = true;
                    vm.otptext = true;
                    vm.isConfirmButtonDisabled = false;
                }
                else {
                   // alert(response.message);
                    logError(response.message, '', true);
                    vm.otpbtn = false;
                    vm.otptext = false;
                    vm.isConfirmButtonDisabled = true;
                }
            }, function (response) { });
        }


        vm.sectionDetails = function (value) {
            vm.slottime = value;
        }

        vm.datechange = function () {
            vm.loadingHospital = true;
            getListOfTimeSlot(vm.slotdate, vm.selectedproviderId);
            
        }
        vm.commonDropDownOption = function (familyList) {
            $('#common-drop-down-modal').modal('hide');
            // if (vm.selectedFamilyMemberId == -1) {
            if (familyList.key == -1) {
               // $('#common-drop-down-modal').modal('hide');
                $location.path("/profile");
            }
            else {
                vm.selectedFamilyMemberId = familyList.key;
                vm.selectedFamilyMember = familyList.value;
                //$('#common-drop-down-modal').modal('hide');
            }
            
        }

        activate();

        function activate() {
            var promises = [getProviderId(),getAllTimeslot()];
            common.activateController(promises, controllerId)
            .then(function () {
                vm.parentbookAppPage = true;
                //log('Book Appointment View');
            });
        }
        function getProviderId() {
            var providerInfo = datarepo.commonrepo.getProviderID();//selectedproviderId.providerID
            vm.selectedproviderId = providerInfo.providerID;
              //vm.selectedproviderId = 117;

            return datacontext.appointment.getProviderDetailsById(vm.selectedproviderId).then(function (data) {
                return vm.selecteddoctorsInfo = data;
            });
        }
        function getAllTimeslot() {
            getListOfTimeSlot(date, vm.selectedproviderId)
        }

        function getListOfTimeSlot(date, ProviderId) {
            vm.loadingHospital = true;
          //  vm.appslotPanel = false;
            vm.hospitalwithslot = false;
            return datacontext.appointment.getListOfTimeSlot(date, ProviderId).then(function (data) {
                if (data.length == 0) {
                    console.log(data.length);
                    $scope.slotempty = true;
                    vm.hospitalwithslot = false;
                }
                else {
                    $scope.slotempty = false;
                    vm.hospitalwithslot = true;
                }
                vm.appslotPanel = true;
                vm.loadingHospital = false;
                console.log(data);
                return $scope.appointmentSlotsData = data;
            });

        }
        function GetFamilyListForDropDown() {

            return datacontext.appointment.GetFamilyListForDropDown().then(function (data) {

                vm.selectedFamilyMember = data[0].value;
                vm.selectedFamilyMemberId = data[0].key;

               //var commonDropdownList = [];
               // for (var i = 0; i < commonList.length; i++) {
               //     //x.key = data[i].value;
               //     //x.value = data[i].key;
               //     //xxz.push(x);
               //     commonDropdownList.push({ key: commonList[i].key, value: commonList[i].value });
               // }

                datarepo.commonrepo.setCommonDropDownData(data);
                var commonDropdownListTemp = datarepo.commonrepo.getCommonDropDownData();
                commonDropdownListTemp.push({ key: -1, value: "Add Family Member" });
                return vm.commonDropDownList = commonDropdownListTemp;
                //return $scope.familymember = data;
            });
        }
    }
})();