(function () {
    'use strict';

    var app = angular.module('app');

    // Collect the routes
    app.constant('routes', getRoutes());

    // Configure the routes and route resolvers
    app.config(['$routeProvider', 'routes', routeConfigurator]);
    function routeConfigurator($routeProvider, routes) {

        routes.forEach(function (r) {
            $routeProvider.when(r.url, r.config);
        });
        $routeProvider.otherwise({ redirectTo: '/dashboard' });
    }

    // Define the routes 
    function getRoutes() {
        return [
            {
                url: '/myProfile',
                config: {
                    id: 'dashboardMyProfile',
                    title: 'My Profile',
                    icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/myprofile.png" />',
                    templateUrl: 'app/myProfile/myProfile.html',
                    canViewWithoutLogin: false,
                    description: 'Manage yours and your family\'s profile',
                    settings: {
                        //nav: 1
                         
                    }
                }
            },
            {
                url: '/search',
                config: {
                    id: 'dashboardSearch',
                    title: 'Book Appointment',
                    icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/search.png" />',
                    templateUrl: 'app/search/search.html',
                    canViewWithoutLogin: true,
                    description: 'Search for the best doctors & fix an apppointment',
                    settings: {
                        nav: 1
                         
                    }
                }
            },
            {
                url: '/book_appointment',
                config: {
                    title: 'Book Appointment',
                    canViewWithoutLogin: false,
                    templateUrl: 'app/appointment/bookAppointment.html',
                    settings: {
                         
                    }
                }
            },
            {
                url: '/view_appointments',
                config: {
                    id: 'dashboardMyAppointments',
                    title: 'My Appointments',
                    icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/myappointments.png" />',
                    templateUrl: 'app/appointment/myAppointments.html',
                    canViewWithoutLogin: false,
                    description: 'Your appointments, all in one place',
                    settings: {
                        nav: 2
                         
                    }
                }
            },
             {
                 url: '/vaccination',
                 config: {
                     id: 'dashboardVaccination',
                     title: 'Vaccination',
                     icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/vaccination.png" />',
                     templateUrl: 'app/phr/vaccination/vaccination.html',
                     canViewWithoutLogin: false,
                     description: 'Manage vaccinations for your li\'l ones',
                     settings: {
                         nav: 5
                          
                     }
                 }
             },
             {
                 url: '/favouriteDoctors',
                 config: {
                     id: 'dashboardMyFavourites',
                     title: 'My Favourites',
                     icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/myfavouritesbold.png" />',
                     canViewWithoutLogin: false,
                     templateUrl: 'app/social/myFavourites/myFavourites.html',
                     description: 'Quick book appointments with the doctors you trust',
                     settings: {
                         nav: 6
                          
                     }
                 }
             },
             {
                 url: '/registration',
                 
                config: {
                    title: 'Registration',
                    canViewWithoutLogin: true,
                    templateUrl: 'app/registration/registration.html',
                    settings: {
                        //nav: 7
                         
                    }
                }
            },
            {
                url: '/profile',
                config: {
                    title: 'Profile',
                    icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/myprofile.png" />',
                    templateUrl: 'app/profile/profile.html',
                    description: 'Manage yours and your family\'s profile',
                    canViewWithoutLogin: false,
                    settings: {
                        //nav: 1,
                        //content: '<i class="icon-lock"></i> Profile'
                         
                    }
                }
            },
            
            {
                url: '/vaccinationDetails',
                config: {
                    title: 'Vaccination Deatils',
                    templateUrl: 'app/phr/vaccination/vaccinationDetails.html',
                    settings: {
                         
                    }
                }
            },
            {
                url: '/vital',
                config: {
                    title: 'Vitals',
                    icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/vitals.png" />',
                    description: 'Track your BP, Glucose and other vital signs',
                    templateUrl: 'app/phr/vitals/managevitals.html',
                    canViewWithoutLogin: false,
                    settings: {
                        nav: 3
                         
                    }
                }
            },
            {
                url: '/bmi',
                config: {
                    title: 'BMI',
                    icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/bmi.png" />',
                    description: 'Keep yourself in the safe zone',
                    templateUrl: 'app/phr/vitals/bmi.html',
                    canViewWithoutLogin: false,
                    settings: {
                        nav: 4
                         
                    }
                }
            },
            {
                url: '/dashboard',
                config: {
                    title: 'Dashboard',
                    canViewWithoutLogin: true,
                    templateUrl: 'app/dashboard/dashboard.html',
                    settings: {
                        historyEnabled: false
                    }
                }
            }, {
                url: '/prescription',
                config: {
                    title: 'DgKare',
                    icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/myprescriptions.png" />',
                    templateUrl: 'app/digitalLocker/prescription.html',
                    description: 'Store, view & share your prescriptions and reports with this digital closet',
                    canViewWithoutLogin: false,
                    settings: {
                        nav: 7
                    }
                }
            },
            {
                url: '/suggest',
                config: {
                    title: 'Suggest',
                    templateUrl: 'app/social/suggestDoctor/suggestDoctor.html',
                    settings: {
                         
                    }
                }
            },
            {
                url: '/previousRecommendations',
                config: {
                    title: 'My Suggested Doctors',
                    icon: '<img class="dashboard-new-img" src="content/images/DASHBOARD-LIGHT/mysuggesteddoctors.png" />',
                    description: 'The doctors you suggest',
                    templateUrl: 'app/social/suggestDoctor/myPreviousSuggestions.html',
                    canViewWithoutLogin: false,
                    settings: {
                        //nav: 9,
                         
                    }
                }
            },
            {
                url: '/feedback',
                config: {
                    title: 'Feedback',
                    templateUrl: 'app/social/feedback/feedback.html',
                    settings: {
                    }
                }
            },           
            {
                url: '/notifications',
                config: {
                    title: 'Notifications',
                    templateUrl: 'app/notification/notification.html',
                    settings: { }
                }
            }
            ,
            {
                url: '/searchResult',
                config: {
                    title: 'Search Result',
                    canViewWithoutLogin: true,
                    templateUrl: 'app/search/searchResult.html',
                    settings: { }
                }
            },
            {
                url: '/login',
                config: {
                    title: 'Login',
                    canViewWithoutLogin: true,
                    templateUrl: 'app/registration/login.html',
                    settings: { }
                }
            },
            {
                url: '/register',
                canViewWithoutLogin: true,
                config: {
                    title: 'Register',
                    canViewWithoutLogin: true,
                    templateUrl: 'app/registration/register.html',
                    settings: { }
                }
            },
            {
                url: '/tell_us_more',
                canViewWithoutLogin: false,
                config: {
                    title: 'Tell Us More',
                    templateUrl: 'app/registration/tellUsMore.html',
                    settings: { }
                }
            },
            {
                url: '/choose_your_doctor',
                config: {
                    title: 'Doctor Setup',
                    templateUrl: 'app/registration/doctorSetup.html',
                    settings: { }
                }
            },
            {
                url: '/editAppointment',
                config: {
                    title: 'Edit Appointment',
                    templateUrl: 'app/appointment/editAppointment.html',
                    settings: { }
                }
            },
            {
                url: '/familyprofile',
                config: {
                    title: 'Add Family Members',
                    templateUrl: 'app/profile/familyprofile.html',
                    settings: { }
                }
            },
            {
                url: '/specify_your_doctor',
                config: {
                    title: 'Specify Your Doctor',
                    templateUrl: 'app/registration/specifyDoctors.html',
                    settings: { }
                }
            },
            {
                url: '/add_doctors',
                config: {
                    title: 'Add More Doctors',
                    templateUrl: 'app/registration/addMoreDoctors.html',
                    settings: { }
                }
            },
            {
                url: '/login_with_fb',
                canViewWithoutLogin: true,
                config: {
                    title: 'Tell Us More',
                    canViewWithoutLogin: true,
                    templateUrl: 'app/registration/facebookLogin.html',
                    settings: { }
                }
            },
            {
                url: '/vaccinationNoKids',
                config: {
                    title: 'Vaccination',
                    templateUrl: 'app/phr/vaccination/vaccinationNoKids.html',
                    settings: {   }

                }
            },
            {
                url: '/forgot_password',
                canViewWithoutLogin: true,
                config: {
                    title: 'Forgot Password',
                    canViewWithoutLogin: true,
                    templateUrl: 'app/registration/forgotPassword.html',
                    settings: {   }
                }
            }
        ];
    }
})();