﻿(function () {
    'use strict';
    var controllerId = 'dashboard';
    angular.module('app').controller(controllerId, ['$rootScope', 'common', 'config', 'datacontext', '$scope', '$route', 'routes', '$location', 'userService', 'datarepo','activeMenu', dashboard]);

    function dashboard($rootScope, common, config, datacontext, $scope, $route, routes, $location, userService, datarepo, activeMenu) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);

        var vm = this;
        vm.title = 'Dashboard';
        vm.userService = userService;
        

        activate();
        $rootScope.go = function (url, pagetitle) {
   
                common.gaTrackPage(pagetitle + ' Page');
            
            $location.path(url);
        }

       

        $rootScope.logOut = function () {
            return datacontext.registration.logout().then(function () {
                //return $scope.upcomingAppointmentsData = data;
                userService.logout();
                //userService.isLogged = false;
                //userService.userName = '';
                log('Successfully logged out', '', true);
                //alert("Logged out successfully !");
                $location.path('/registration');
            }, function (response) { });
            //$location.path('/search');
        }

        function getNavRoutes() {
            vm.navRoutes = routes.filter(function (r) {
                return r.config.settings && r.config.settings.nav;
            }).sort(function (r1, r2) {
                return r1.config.settings.nav > r2.config.settings.nav;
            });
        }

        function isCurrent(route) {
            if (!route.config.title || !$route.current || !$route.current.title) {
                return '';
            }
            var menuName = route.config.title;
            return $route.current.title.substr(0, menuName.length) === menuName ? 'current' : '';
        }

        function activate() {
            $scope.isLoggedIn = userService.isLogged;
            getNavRoutes();
            common.activateController([], controllerId);
                //.then(function () { log('Dashboard View Activated'); });
        }

    }
})();