﻿(function () {
    'use strict';

    var serviceId = 'datarepo';

    angular.module('app').factory(serviceId,
        ['common', 'datarepositories', datarepo]);

    function datarepo(common, datarepositories) {
        var $q = common.$q;
        var dataRepoNames = ['commonrepo'];

        var service = {
        };

        init();
        return service;

        function init() {
            defineLazyLoadeddataRepos();
        }


        // Add ES5 property to datacontext for each named repo
        function defineLazyLoadeddataRepos() {
            dataRepoNames.forEach(function (name) {
                Object.defineProperty(service, name, {
                    configurable: true, // will redefine this property once
                    get: function () {
                        // The 1st time the repo is requested via this property, 
                        // we ask the repositories for it (which will inject it).
                        var repo = datarepositories.getDataRepo(name);
                        // Rewrite this property to always return this repo;
                        // no longer redefinable
                        Object.defineProperty(service, name, {
                            value: repo,
                            configurable: false,
                            enumerable: true
                        });
                        return repo;
                    }
                });
            });
        }       
    }
})();