﻿(function () {
    'use strict';
    var controllerId = 'prescription';
    angular.module('app').controller(controllerId, ['common', '$rootScope','$scope', 'datacontext', prescription]);

    function prescription(common, $rootScope,$scope, datacontext) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'Prescription';
        vm.uploadedDocumentList = [];
        vm.resultNotFound = false;
        activate();

        vm.loadMuUploadedDocument = function () {

            // GetMyUploadedDocuments();
            return datacontext.digitallocker.GetMyUploadedDocuments().then(function (data) {
                vm.uploadedDocumentList = data;
                for (var i = 0 ; i < data.length; i++) {
                    data[i].updatedDate = moment(data[i].updatedDate).format("DD MMM, YYYY");
                    data[i].createdDate = moment(data[i].createdDate).format("DD MMM, YYYY");
                }

                if (vm.uploadedDocumentList.length == 0) {
                    vm.resultNotFound = true;
                }
                else {
                    vm.resultNotFound = false;
                }

                return vm.uploadedDocumentList;

            });
        }

        vm.downloadFile = function (doclist, filename, fileextention) {
            var param = new Array();
            param["fileName"] = doclist.fileName;
            param["filePath"] = doclist.documentPath;
            param["fileextention"] = doclist.fileExtenssion;
            param["fileid"] = doclist.consumerDigitalDocumentsID;
         
            //  $rootScope.isBusy = true;
            return datacontext.digitallocker.downloadDocument(param).then(function (data) {
                console.log(data);
        
                logSuccess("Downloaded successfully", '', true);
                //   $rootScope.isBusy = false;
                return true;

            });
            // downloadTrack(documentPath);
        }
        $scope.downloadCardToggleDetail = function ($index) {
            $scope.downloadcardActivePosition = $scope.downloadcardActivePosition == $index ? -1 : $index;

        };
        $scope.removeDocuments = function (doclist,index) {
          
            var remove = confirm("Do you wish to remove this document ?");
           
            if (remove == true) {
                vm.uploadedDocumentList.splice(vm.uploadedDocumentList.indexOf(vm.uploadedDocumentList[index]), 1);
                //return datacontext.digitallocker.DeleteDigitalDocument(doclist.consumerDigitalDocumentsID).then(function (data) {
                //    console.log(data);

                //    logSuccess(data.message, '', true);
                //    //   $rootScope.isBusy = false;
                //    return true;

                //});
                return datacontext.digitallocker.DeleteDigitalDocument(doclist.consumerDigitalDocumentsID).then(function (data) {
                    //Set the properties
                  //  clearUploadFormField();
                    logSuccess(data.message, '', true);

                }, function (response) {
                  //  clearUploadFormField();
                    logError(data.message, '', true);

                });
                //$scope.upcomingAppointmentsData.splice($scope.upcomingAppointmentsData.indexOf($scope.upcomingAppointmentsData[$index]), 1);
                //return datacontext.appointment.DeleteDigitalDocument(ApptId).then(function (response) {
                //    logSuccess(response.message, '', true);
                //    if ($scope.upcomingAppointmentsData.length == 0) {
                //        $scope.upcomingEmpty = true;
                //    }
                //    else {
                //        $scope.upcomingEmpty = false;
                //    }
                //    //getUpcomingAppointments();
                //});
                //consumerDigitalDocumentsID: 58
                //consumerID: 186
                //createdBy: "0"
                //createdDate: "28 Apr, 2014"
                //description: ""
                //documentFor: "Self"
                //documentPath: "PHR/186/28042014/ff"
                //documentType: "Prescription"
                //fileExtenssion: ""
                //fileName: "ff"
                //iconToShowInLocker: ".png"
                //isActive: true
                //updatedBy: "0"
                //updatedDate: "28 Apr, 2014"
               
               
            }
        }


        function activate() {
            common.activateController([], controllerId);
            //.then(function () { log('Prescription View Activated'); });
        }

    }
})();



