﻿(function () {
    'use strict';
    var controllerId = 'uploadFile';
    angular.module('app').controller(controllerId, ['common', '$location', '$scope', 'datacontext', 'datarepo', uploadFile]);

    function uploadFile(common, $location, $scope, datacontext, datarepo) {

        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'uploadFile';
        var pictureSource;   // picture source
        var destinationType; // sets the format of returned value
        $scope.thumbnailImage = false;
        var thumbImage;
        $scope.data = 'none';
        $scope.fileExtension = '';
        vm.hideContent = false;
        vm.uploadfileShow = false;
        $scope.ImageContainer = true;
        vm.fileuploadob = {
            FileName: '',
            FileForValue: '',
            FileForKey: 0,
            FileTypeValue: '',
            FileTypeKey: 0,
            FileDescription: '',
            FileData: '',
            FileExtension: '',
            ContentType: '',
            Imageuri: ''

        }
        vm.Content_Type = '';
        vm.S3uploadTest = [];
        var uploadType = "";

        activate();

        function initializecamera() {

            document.addEventListener('deviceready', onDeviceReady, false);
        }

        function onDeviceReady() {
            // receivedEvent('deviceready');

            pictureSource = navigator.camera.PictureSourceType;
            destinationType = navigator.camera.DestinationType;
        }

        function activate() {
            common.activateController([initializecamera(), GetFamilyListDropDown()], controllerId);
            //.then(function () { log('Prescription View Activated'); });
        }

        vm.captureImage = function () {
           
            vm.uploadfileShow = false;
            $scope.ImageContainer = true;

            vm.hideContent = true;
            uploadType = "ByCamera"
            // Take picture using device camera and retrieve image as base64-encoded string
            navigator.camera.getPicture(onPhotoDataSuccess, onFail, {
                quality: 50,
                destinationType: destinationType.DATA_URL
            });

        }

        vm.uploadDocument = function () {
           
            $scope.ImageContainer = true;
            vm.hideContent = true;
            vm.uploadfileShow = true;
            $scope.thumbnailImage = true;
            uploadType = "ByFile";
        }

        $scope.fileChange = function () {

            if (document.getElementById('file').files && document.getElementById('file').files[0]) {
                var FR = new FileReader();

                FR.onloadend = function (e) {

                    var fileid = document.getElementById('file').value;
                   
                    vm.fileuploadob.Imageuri = fileid;
                    var fileexstention = fileid.substr((Math.max(0, fileid.lastIndexOf(".")) || Infinity) + 1);

                    var Filecontent = e.target.result;

                    Filecontent = Filecontent.split("base64,");

                    vm.fileuploadob.FileExtension = "." + fileexstention;
                    vm.fileuploadob.FileData = Filecontent[1];

                    thumbImage = document.getElementById('thumbImage');
                    $scope.ImageContainer = false;
                    $scope.$apply();
                    switch (fileexstention) {

                        case "png":
                            vm.fileuploadob.FileExtension = ".jpeg";
                            vm.fileuploadob.ContentType = "image/jpeg";
                            thumbImage.src = "content/images/File-type-icons/png.png";
                            break;
                        case "jpg":
                        case "jpeg":
                            vm.fileuploadob.FileExtension = ".jpeg";
                            vm.fileuploadob.ContentType = "image/jpeg";
                            thumbImage.src = "content/images/File-type-icons/jpg.png";
                           
                            break;
                        case "pdf":
                            vm.fileuploadob.ContentType = "application/pdf";
                            thumbImage.src = "content/images/File-type-icons/pdf.png";
                            break;
                        case "xlsx":
                        case "xls":
                            vm.fileuploadob.ContentType = "application/vnd.ms-excel";
                            thumbImage.src = "content/images/File-type-icons/pdf.png";
                            break;
                        case "doc":
                        case "docs":
                            vm.fileuploadob.ContentType = "application/msword";
                            thumbImage.src = "content/images/File-type-icons/pdf.png";
                            break;
                        default:
                            break;
                    }

                }
                FR.readAsDataURL(document.getElementById('file').files[0]);
            }

        }

        //vm.uploadtest = function () {
        //    alert("upload test");
        //    // Retrieve image file location from specified source
        //    //navigator.camera.getPicture(onPhotoDataSuccess, onFail, {
        //    //    quality: 50,
        //    //    destinationType: destinationType.DATA_URL,
        //    //    sourceType: pictureSource.PHOTOLIBRARY,
        //    //    mediaType: navigator.camera.MediaType.ALLMEDIA
        //    //});
        //    //  getUploadDetailsBeforeupload();
        //    vm.uploadfileShow = true;
        //    $scope.thumbnailImage = true;
        //    uploadType = "ByFile";
        //    navigator.camera.getPicture(onPhotoURISuccess, onFail, {
        //        quality: 50,
        //        destinationType: destinationType.FILE_URI,
        //        sourceType: pictureSource.PHOTOLIBRARY,
        //        mediaType: navigator.camera.MediaType.ALLMEDIA
        //    });

        //}

        //function onPhotoURISuccess(imageURI) {

        //    vm.fileuploadob.Imageuri = imageURI;

        //    var fileexstention = imageURI.substr((Math.max(0, imageURI.lastIndexOf(".")) || Infinity) + 1);
        //    thumbImage = document.getElementById('thumbImage');
        //    switch (fileexstention) {
        //        case "png":
        //            vm.fileuploadob.FileExtension = ".jpeg";
        //            vm.fileuploadob.ContentType = "image/jpeg";
        //            thumbImage.src = "content/images/File-type-icons/png.png";
        //            alert(vm.fileuploadob.FileExtension);
        //            break;
        //        case "jpg":
        //        case "jpeg":
        //            vm.fileuploadob.FileExtension = ".jpeg";
        //            vm.fileuploadob.ContentType = "image/jpeg";
        //            thumbImage.src = "content/images/File-type-icons/jpg.png";
        //            alert(vm.fileuploadob.FileExtension);
        //            break;
        //        case "pdf":
        //            vm.fileuploadob.FileExtension = ".pdf";
        //            vm.fileuploadob.ContentType = "application/pdf";
        //            thumbImage.src = "content/images/File-type-icons/pdf.png";
        //            break;
        //        case "xlsx":
        //        case "xls":
        //            vm.fileuploadob.FileExtension = "." + fileexstention;
        //            vm.fileuploadob.ContentType = "application/vnd.ms-excel";
        //            thumbImage.src = "content/images/File-type-icons/pdf.png";
        //            break;
        //        case "doc":
        //        case "docs":
        //            vm.fileuploadob.FileExtension = "." + fileexstention;
        //            vm.fileuploadob.ContentType = "application/msword";
        //            thumbImage.src = "content/images/File-type-icons/pdf.png";
        //            break;
        //        default:
        //            break;


        //    }

        //    alert("Content type " + vm.fileuploadob.ContentType);


        //}

        vm.saveDitaldocument = function () {



            if (uploadType == "ByFile") {
                if (document.getElementById('file').value == "") {
                    logError("Please choose a file", '', true);
                }
                else if (vm.fileuploadob.FileName == "") {
                    logError("File name required", '', true);
                }
                else {
                  //  vm.uploadfileShow = false;
                    savedocument();
                }
            }
            else {
                if (vm.fileuploadob.FileName == "") {
                    logError("File name required", '', true);
                }
                else {
                    vm.uploadfileShow = false;
                    savedocument();
                }
            }
            //if (uploadType == "ByCamera") {
            //    if (vm.fileuploadob.FileName == "") {
            //        logError("File name required", '', true);
            //    }
            //    else {
            //        vm.uploadfileShow = false;
            //        savedocument();
            //    }
            //}
            //else {
            //    savedocument();
            //}


        }

        function savedocument() {
            $scope.thumbnailImage = false
            vm.hideContent = false;
            //   if (uploadType == "ByCamera") {
            
            return datacontext.digitallocker.saveDitaldocument(vm.fileuploadob).then(function (data) {
                //Set the properties
                clearUploadFormField();
                logSuccess(data.message, '', true);

            }, function (response) {
                clearUploadFormField();
                logError(data.message, '', true);

            });

           // getUploadDetailsBeforeupload();

        }

        function clearUploadFormField() {
            vm.fileuploadob.FileName = "";
            vm.fileuploadob.FileData = "";
            document.getElementById('file').innerHTML = "";
            document.getElementById("file").value = "";
        }

        function getUploadDetailsBeforeupload() {

            //  var options = new FileUploadOptions();
            //  options.fileKey = "file";
            //  //var time = new Date().getTime();
            ////  var userId = getUserId(); // In my case, Parse.User.current().id;
            //  //var fileName = userId + "-" + time + ".jpg";
            //  options.fileName = vm.fileuploadob.FileName + vm.fileuploadob.FileExtension;;
            //  options.mimeType = vm.fileuploadob.ContentType;
            //  options.chunkedMode = false;


            //var ft = new FileTransfer(),
            //options = new FileUploadOptions();

            //options.fileKey = "file";
            //options.fileName = vm.fileuploadob.FileName + vm.fileuploadob.FileExtension;
            //options.mimeType = vm.fileuploadob.ContentType;
            //options.chunkedMode = false;
            //alert("file name " + vm.fileuploadob.FileName + vm.fileuploadob.FileExtension + " and " + vm.fileuploadob.ContentType);
            return datacontext.digitallocker.getUploadDetailsBeforeupload(vm.fileuploadob.FileName + vm.fileuploadob.FileExtension, vm.fileuploadob.ContentType).then(function (data) {

                //options.params = {
                //    "key": "PHR/978/07052014/Hydrangeas.jpeg",//data[0].s3FilePath,
                //    "AWSAccessKeyId": "AKIAJGLR2TS42UM3NR7Q",//data[0].awsAccessKey,
                //    "acl": "private",
                //    "policy": "eyJleHBpcmF0aW9uIjogIjIwMTQtMDUtMDdUMTI6NTQ6MjIuMzc0Nzk3M1oiLCJjb25kaXRpb25zIjogW3siYnVja2V0IjogImthcmU0dS5jb25zdW1lci5kb2N1bWVudHMiIH0seyJhY2wiOiAicHJpdmF0ZSIgfSxbImVxIiwgIiRrZXkiLCAiUEhSLzk3OC8wNzA1MjAxNC9IeWRyYW5nZWFzLmpwZWciXSxbImVxIiwgIiRDb250ZW50LVR5cGUiLCAiaW1hZ2UvanBlZyJdLF19", //data[0].encodedString,
                //    "signature": "4fk/okkUMYVxK3bwyIo4MgaFsis=",//data[0].signature,
                //    "Content-Type": "image/jpeg"//vm.fileuploadob.ContentType
                //};

                //console.log(options);
                //console.log(vm.fileuploadob.Imageuri + "https://" + data[0].bucketName + ".s3.amazonaws.com/");
                //alert(vm.fileuploadob.Imageuri + "https://" + data[0].bucketName + ".s3.amazonaws.com/");
                //ft.upload(vm.fileuploadob.Imageuri, "https://" + data[0].bucketName + ".s3.amazonaws.com/",
                //    function (e) {
                //        //deferred.resolve(e);
                //        alert("Upload Success");
                //    },
                //    function (e) {

                //        alert("Upload failed");
                //        alert(e);
                //        alert(e.message);
                //       // deferred.reject(e);
                //    }, options);
                alert(vm.fileuploadob.Imageuri);
                console.log(vm.fileuploadob.Imageuri);
                console.log(options);
                var uri = encodeURI("https://kare4u.consumer.documents.s3.amazonaws.com/");

                // var policyDoc = "POLICY_DOC_GOES_HERE";
                // var signature = "SIGNATURE_GOES_HERE";
                var params = {
                    "key": "PHR/978/08052014/Desert.jpeg",
                    "AWSAccessKeyId": "AKIAJGLR2TS42UM3NR7Q",
                    "acl": "private",
                    "policy": "eyJleHBpcmF0aW9uIjogIjIwMTQtMDUtMDhUMjA6MTY6NDEuODM1MjU5M1oiLCJjb25kaXRpb25zIjogW3siYnVja2V0IjogImthcmU0dS5jb25zdW1lci5kb2N1bWVudHMiIH0seyJhY2wiOiAicHJpdmF0ZSIgfSxbImVxIiwgIiRrZXkiLCAiUEhSLzk3OC8wODA1MjAxNC9EZXNlcnQuanBlZyJdLFsiZXEiLCAiJENvbnRlbnQtVHlwZSIsICJpbWFnZS9qcGVnIl0sXX0=",
                    "signature": "NUUx2u4STKq6bAAjpF6aDGEaZQ0=",
                    "Content-Type": "image/jpeg"
                };
                options.params = params;

                var ft = new FileTransfer();
                ft.upload(vm.fileuploadob.Imageuri, uri, uploadSuccess, uploadFail, options);

                return true;

            });
        }

        function uploadSuccess() {
            alert("uploadSuccess");
        }

        function uploadFail(e) {
            alert(e.code);
            alert(e.message);
        }

        vm.cancelDitaldocument = function () {
           
            vm.hideContent = false;
            vm.uploadfileShow = false;
            $scope.thumbnailImage = false;
            clearUploadFormField();
        }

        vm.forRelation = function () {
            $('#common-drop-down-modal').modal('show');
        }

        vm.commonDropDownOption = function (familyList) {
            $('#common-drop-down-modal').modal('hide');
            // if (vm.selectedFamilyMemberId == -1) {
            if (familyList.key == -1) {
                // $('#common-drop-down-modal').modal('hide');
                $location.path("/profile");
            }
            else {
                vm.fileuploadob.FileForKey = familyList.key;
                vm.fileuploadob.FileForValue = familyList.value;
                //$('#common-drop-down-modal').modal('hide');

            }

        }

        vm.chooseFileType = function () {
            $('#file-type-modal').modal('show');

        }

        vm.fileTypeOption = function (typeList) {
            $('#file-type-modal').modal('hide');
            vm.fileuploadob.FileTypeValue = typeList.value;
            vm.fileuploadob.FileTypeKey = typeList.key;


            //$('#common-drop-down-modal').modal('hide');



        }

        function onPhotoDataSuccess(imageData) {
            // Uncomment to view the base64-encoded image data

            // Get image handle
            //
            console.log("imageData");
            console.log(imageData);
            $scope.thumbnailImage = true;
            $scope.ImageContainer = false;
            $scope.$apply();
            thumbImage = document.getElementById('thumbImage');
            vm.fileuploadob.FileExtension = ".jpeg";
            // Unhide image elements
            //
            //thumbImage.style.display = 'block';

            // Show the captured photo
            // The in-line CSS rules are used to resize the image
            //
            thumbImage.src = "data:image/jpeg;base64," + imageData;
           
            vm.fileuploadob.FileData = imageData;
        }

        function onFail(message) {
            alert('Failed because: ' + message);
        }

        function GetFamilyListDropDown() {
            vm.commonDropDownHeader = "Choose family member"
            // datacontext.cacheservice.getDropDownValues('Family').
            // return datacontext.appointment.GetFamilyListForDropDown().then(function (data) {
            return datacontext.appointment.GetFamilyListForDropDown().then(function (data) {
                console.log(data);
                vm.fileuploadob.FileForValue = data[0].value;
                vm.fileuploadob.FileForKey = data[0].key;
                GetFileTypeList();
                datarepo.commonrepo.setCommonDropDownData(data);
                var commonDropdownListTemp = datarepo.commonrepo.getCommonDropDownData();
                commonDropdownListTemp.push({ key: -1, value: "Add Family Member" });
                return vm.commonDropDownList = commonDropdownListTemp;
                //return $scope.familymember = data;
            });
        }

        function GetFileTypeList() {
            vm.fileTypeHeader = "Choose document type";
            return datacontext.cacheservice.getDropDownValues('Document Type').then(function (data) {
                // return datacontext.digitallocker.GetFileTypeList("Document Type").then(function (data) {
                var commonDropdownListTemp = [];
                vm.fileuploadob.FileTypeValue = data[0].displayText;
                vm.fileuploadob.FileTypeKey = data[0].value;
                for (var i = 0; i < data.length; i++) {
                    commonDropdownListTemp.push({ key: data[i].value, value: data[i].displayText });
                }
                //datarepo.commonrepo.setCommonDropDownData(data);
                // var commonDropdownListTemp = datarepo.commonrepo.getCommonDropDownData();

                return vm.fileTypeList = commonDropdownListTemp;
                //return $scope.familymember = data;
            });
        }


        $scope.fileChangetest = function () {

            if (document.getElementById('file1').files && document.getElementById('file1').files[0]) {
                var FR = new FileReader();

                FR.onloadend = function (e) {

                    var fileid = document.getElementById('file1').value;
                    alert("filePath" + fileid);
                    vm.fileuploadob.Imageuri = fileid;
                    var fileexstention = fileid.substr((Math.max(0, fileid.lastIndexOf(".")) || Infinity) + 1);

                    var Filecontent = e.target.result;

                    Filecontent = Filecontent.split(";base64,");

                    vm.fileuploadob.FileExtension = "." + fileexstention;
                    vm.fileuploadob.FileData = Filecontent[1];

                    thumbImage = document.getElementById('thumbImage');

                    switch (fileexstention) {
                        case "png":
                            vm.fileuploadob.FileExtension = ".jpeg";
                            vm.fileuploadob.ContentType = "image/jpeg";
                            thumbImage.src = "content/images/File-type-icons/png.png";
                            break;
                        case "jpg":
                        case "jpeg":
                            vm.fileuploadob.FileExtension = ".jpeg";
                            vm.fileuploadob.ContentType = "image/jpeg";
                            thumbImage.src = "content/images/File-type-icons/jpg.png";
                            alert(vm.fileuploadob.FileExtension);
                            break;
                        case "pdf":
                            vm.fileuploadob.ContentType = "application/pdf";
                            thumbImage.src = "content/images/File-type-icons/pdf.png";
                            break;
                        case "xlsx":
                        case "xls":
                            vm.fileuploadob.ContentType = "application/vnd.ms-excel";
                            thumbImage.src = "content/images/File-type-icons/pdf.png";
                            break;
                        case "doc":
                        case "docs":
                            vm.fileuploadob.ContentType = "application/msword";
                            thumbImage.src = "content/images/File-type-icons/pdf.png";
                            break;
                        default:
                            break;
                    }

                    S3FileUploadtest();

                }
                FR.readAsDataURL(document.getElementById('file1').files[0]);
            }

        }

        function S3FileUploadtest() {
            return datacontext.digitallocker.getUploadDetailsBeforeupload(vm.fileuploadob.FileName + vm.fileuploadob.FileExtension, vm.fileuploadob.ContentType).then(function (data) {
                //  console.log(data);

                //  logSuccess("Downloaded successfully", '', true);
                //   $rootScope.isBusy = false;
                vm.Content_Type = vm.fileuploadob.ContentType;
                alert("s3FilePath  " + data[0].s3FilePath);
                alert("awsAccessKey  " + data[0].awsAccessKey);
                alert("signature  " + data[0].signature);
                alert("Content type " + vm.fileuploadob.ContentType);
                //options.params = {
                //    "key": data[0].s3FilePath,
                //    "AWSAccessKeyId": data[0].awsAccessKey,
                //    "acl": "private",
                //    "policy": data[0].encodedString,
                //    "signature": data[0].signature,
                //    "Content-Type": vm.fileuploadob.ContentType
                //};
                //alert("https://" + data[0].bucketName + ".s3.amazonaws.com/");
                //// alert("Imageuri " + vm.fileuploadob.Imageuri);
                //ft.upload(vm.fileuploadob.Imageuri, "https://" + data[0].bucketName + ".s3.amazonaws.com/",
                //    function (e) {
                //        //deferred.resolve(e);
                //        alert("Upload Success");
                //    },
                //    function (e) {

                //        alert("Upload failed");
                //        alert(e);
                //        alert(e.message);
                //        // deferred.reject(e);
                //    }, options);
                vm.S3uploadTest = data[0];

                console.log(vm.S3uploadTest);
                return vm.S3uploadTest;

            });
        }
    }
})();