﻿(function() {
    'use strict';

    // Define the directive on the module.
    // Inject the dependencies. 
    // Point to the directive definition function.
    angular.module('app').directive('userLoggedIn', ['$rootScope', '$location', 'userService', userLoggedIn]);
    
    function userLoggedIn($rootScope, $location, userService) {
        return {
            link: function (scope, elem, attrs, ctrl) {
                $root.$on('$routeChangeStart', function (event, currRoute, prevRoute) {
                    if (!prevRoute.canViewWithoutLogin && !userService.isLogged) {
                        // reload the login route
                        alert("Unauthorized");
                    }

                });
            }
            }
    }

})();