﻿(function () {
    'use strict';

    var controllerId = 'shell';
    angular.module('app').controller(controllerId,
        ['$rootScope', 'common', 'config', 'datacontext', '$scope', '$route', 'routes', '$location', 'userService', 'activeMenu', 'datarepo',shell]);

    function shell($rootScope, common, config, datacontext, $scope, $route, routes, $location, userService, activeMenu, datarepo ) {
        var vm = this;
        var logSuccess = common.logger.getLogFn(controllerId, 'success');
        var events = config.events;
        $rootScope.busyMessage = 'Please Wait';
        vm.activeMenu = activeMenu;
        vm.isCurrent = isCurrent;
        vm.userService = userService;
        activate();

        $rootScope.go = function (url, pagetitle) {
            common.gaTrackPage(pagetitle + ' Page');
            $location.path(url);
        }
        /*History functionality*/
        $rootScope.goBack = function () {
            //$scope.animationStyle = "slide-left-animation";
            window.history.go(-1);
        }
        
        function getNavRoutes() {
            vm.navRoutes = routes.filter(function (r) {
                return r.config.settings && r.config.settings.nav;
            }).sort(function (r1, r2) {
                return r1.config.settings.nav > r2.config.settings.nav;
            });
        }

        function isCurrent(route) {
            if (!route.config.title || !$route.current || !$route.current.title) {
                return '';
            }
            var menuName = route.config.title;
            return $route.current.title.substr(0, menuName.length) === menuName ? 'current' : '';
        }
                
        $rootScope.logOut = function () {
            return datacontext.registration.logout().then(function () {
                userService.logout();
                log('Successfully logged out', '', true);
                $location.path('/registration');
            }, function (response) { });
        }

        function activate() {
            var promises = [];
            common.activateController(promises, controllerId)
                .then(function () { logSuccess('Kare4u App loaded!') });

        }
    };
})();