﻿(function () {
    'use strict';
    var controllerId = 'vaccination';
    angular.module('app').controller(controllerId, ['common', 'datacontext', '$location', '$scope', 'userService', vaccination]);

    function vaccination(common, datacontext, $location, $scope, userService) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'Vaccination';
        vm.page = 'Vaccination';
        vm.selectedVaccine = "";
        $scope.firstVaccChild = 0;
        vm.listOfVaccChild = [];
        vm.vaccList = "";
        vm.vaccDetailsList = "";
        vm.SelectedVaccinationProvider = { 'value': '', 'label': '' };
        vm.SelectedVaccinationHospital = { 'value': '', 'label': '' };
        vm.selectedVac = {};
        vm.vaccChildStatus = true;
        vm.vacNoKids = true;
        vm.addKidsDiv = true;
        vm.selectedFamilyMember = {
        "name": "",
        "relation": 122,
        "dateOfBirth" : "",
        "contact" : "",
        "sex" : 100
    };
        var familyupdate = true;
        vm.vaccDetails = true;
        vm.callFLag = true;
        var childrenList = [];
        activate();

        function activate() {
            var promises = [getChildrenForVaccination(), getGenders(), getRelations()];
            common.activateController(promises, controllerId);
        }

        function getChildrenForVaccination() {
            return datacontext.vaccination.getChildrenForVaccination().then(function (data) {
                console.log(data);
                var commonDropdownListFamilyMem = [];
                if (data.length > 0) {
                    $scope.firstVaccChild = data[0].value;
                    $scope.firstVaccChildName = data[0].text;
                    if (vm.callFLag) {
                        vm.GetVaccinationList();
                        vm.callFLag = false;
                    }
                    vm.vacNoKids = true;
                }
                else if (data.length <= 0) {
                    commonDropdownListFamilyMem = [];
                    vm.vacNoKids = false;
                }

                for (var i = 0; i < data.length; i++) {
                    commonDropdownListFamilyMem.push({ key: data[i].value, value: data[i].text, Type: "FamMembers" });
                }
                commonDropdownListFamilyMem.push({ key: 0, value: 'Add Kids', Type: "FamMembers" });
                childrenList = commonDropdownListFamilyMem;
                return vm.commonDropDownList = commonDropdownListFamilyMem;
            });
        }

        vm.GetVaccinationList = function () {
            vm.vaccList = [];
            return datacontext.vaccination.GetVaccinationList($scope.firstVaccChild).then(function (data) {
                console.log($scope.firstVaccChild);
                if (data.length > 0) {
                    vm.vaccList = data;
                    vm.vacNoKids = true;
                    vm.vaccChildStatus = true;
                }
                else if (data.length <= 0) {
                    if ($scope.firstVaccChild == 0 && $scope.firstVaccChildName == 'Add Kids') {
                        vm.addRelation();
                        vm.vacNoKids = false;
                        vm.addKidsDiv = false;
                    }
                    else {
                        vm.vacNoKids = true;
                        vm.vaccList = data;
                        vm.vaccChildStatus = false;
                    }
                }
                console.log(vm.vaccList);
                return vm.vaccList;
            });
        };

        vm.editvaccination = function (vac) {
            console.log(vac);
            if (vac != undefined) {
                vm.selectedVac = vac;
                vm.SelectedVaccinationProvider.Provider = { 'value': vac.providerID, 'label': vac.providerName };
                vm.SelectedVaccinationHospital.Hospital = { 'value': vac.groupEntityID, 'label': vac.groupName };
                var vaccdate = new Date(vac.vaccinationGivenOn);
                vm.VaccinationGivenOn = vaccdate.getFullYear() + '-' + (vaccdate.getMonth() + 1) + '-' + vaccdate.getDate();
            }
            if (vac.vaccinationAlreadyGiven == 0) {
                vm.SelectedVaccinationProvider.Provider = "";
                vm.SelectedVaccinationHospital.Hospital = "";
                var date = new Date();
                vm.VaccinationGivenOn = date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
            }
            vm.vaccDetails = false;
        };
        vm.UpdateVaccinationData = function () {
            
            vm.selectedVac.providerID = vm.SelectedVaccinationProvider.Provider.value;
            vm.selectedVac.providerName = vm.SelectedVaccinationProvider.Provider.label;
            vm.selectedVac.groupEntityID = vm.SelectedVaccinationHospital.Hospital.value;
            vm.selectedVac.groupName = vm.SelectedVaccinationHospital.Hospital.label;
            vm.selectedVac.vaccinationGivenOn = vm.VaccinationGivenOn;
            if (vm.selectedVac.providerID == undefined && vm.selectedVac.providerName == undefined) {
                vm.selectedVac.providerID = 0;
                vm.selectedVac.providerName = '';
            }
            return datacontext.vaccination.UpdateVaccinationData(vm.selectedVac).then(function (response) {
                vm.GetVaccinationList();
                vm.vaccDetails = true;
            }, function (response) { });
        };
        vm.CreateVaccinationChart = function () {
            return datacontext.vaccination.CreateVaccinationChart($scope.firstVaccChild).then(function (response) {
                vm.GetVaccinationList();
            }, function (response) { });
        };
        vm.getVaccDoctors = function (term) {
            return datacontext.vaccination.getVaccDoctors(term).then(function (result) {
                 return result;
            });
        };
        vm.getVaccHospitals = function (term) {
            return datacontext.vaccination.getVaccHospitals(term).then(function (result) {
                return result;
            });
        };

        $scope.toggleVaccDetail = function ($index) {
            $scope.activePosition = $scope.activePosition == $index ? -1 : $index;
        };

        function getRelations() {
            return datacontext.cacheservice.getDropDownValues('Family').then(function (data) {
                var commonDropdownListRelation = [];
                vm.selectedFamilyMember.relationName = data[2].displayText;
                vm.selectedFamilyMember.relation = data[2].value;
                for (var i = 0; i < data.length; i++) {
                    if (data[i].value == 122 || data[i].value == 123 || data[i].value == 132) {
                        commonDropdownListRelation.push({ value: data[i].displayText, key: data[i].value, Type: "Relation" });
                    }
                }
                return vm.commonDropDownList = commonDropdownListRelation;
            });
        };

        function getGenders() {
            return datacontext.cacheservice.getDropDownValues('Sex').then(function (data) {
                var commonDropdownListGender = [];
                console.log(data);
                vm.selectedFamilyMember.sexTxt = data[0].displayText;
                vm.selectedFamilyMember.sex = data[0].value;
                for (var i = 0; i < data.length; i++) {
                    commonDropdownListGender.push({ value: data[i].displayText, key: data[i].value, Type: "Category" });
                }
                return vm.commonDropDownList = commonDropdownListGender;
            });
        }

        vm.updateFamilyDetails = function () {

            if (vm.selectedFamilyMember.name == "" || vm.selectedFamilyMember.relationName == "" || vm.selectedFamilyMember.dateOfBirth == "" || vm.selectedFamilyMember.sex == "" || vm.selectedFamilyMember.contact == "") {
                logError('Please fill all the fields.', '', true);
            }
            else {
                return datacontext.profile.updateFamilyDetails(vm.selectedFamilyMember, familyupdate).then(function (response) {
                    console.log();
                    vm.callFLag = true;
                    getChildrenForVaccination();
                    vm.vacNoKids = true;
                    logSuccess('Family member added successfully.', '', true);
                }, function (response) { });
            }
        };

        vm.addRelation = function (familyMember) {
            familyupdate = false;
            vm.selectedFamilyMember.name = "";
            //vm.selectedFamilyMember.relationName = familyMember.relationName;
            //vm.selectedFamilyMember.relation = familyMember.relation;
            vm.selectedFamilyMember.dateOfBirth = "";
            vm.selectedFamilyMember.contact = parseInt(userService.contact);
            vm.selectedFamilyMember.sex = vm.selectedFamilyMember.sex;
            if (vm.vacNoKids == true && vm.vaccChildStatus == true && vm.vaccDetails == true) {
                vm.vacNoKids = false;
                vm.addKidsDiv = false;
            }
            else {
                vm.addKidsDiv = false;
            }
        };

        vm.closeAddKids = function () {
            if ($scope.firstVaccChild == 0 && $scope.firstVaccChildName == 'Add Kids' && childrenList.length > 0) {
                vm.vacNoKids = true;
                vm.vaccChildStatus = true;
                vm.vaccDetails = true;
                vm.callFLag = true;
                getChildrenForVaccination();
            }
            else {
                vm.vacNoKids == false
                vm.addKidsDiv = true;
            }
        }

        $scope.openFamilyMemModal = function () {
            getChildrenForVaccination();
            vm.commonDropDownHeader = "Select a child";
            vm.commonDropDownFilterDisplay = false;
            vm.commonDropDownFilteredValue = "";
            vm.commonDropDownPlaceHoldertext = "Select Family Member";
            $('#common-drop-down-modal').modal('show');
        }

        $scope.openGenderModal = function () {
            getGenders();
            vm.commonDropDownHeader = "";
            vm.commonDropDownHeader = "Choose gender";
            vm.commonDropDownFilterDisplay = false;
            vm.commonDropDownFilteredValue = "";
            vm.commonDropDownPlaceHoldertext = "Select Category";
            $('#common-drop-down-modal').modal('show');
        }

        $scope.openRelationModal = function () {
            getRelations();
            vm.commonDropDownHeader = "Relation";
            vm.commonDropDownFilterDisplay = false;
            vm.commonDropDownFilteredValue = "";
            vm.commonDropDownPlaceHoldertext = "Select Relation";
            $('#common-drop-down-modal').modal('show');
        }

        vm.commonDropDownOption = function (cityList) {
            $('#common-drop-down-modal').modal('hide');
            if (cityList.Type == "FamMembers") {
                $scope.firstVaccChild = cityList.key;
                $scope.firstVaccChildName = cityList.value;
                vm.GetVaccinationList();
            }
            else if (cityList.Type == "Category") {
                vm.selectedFamilyMember.sexTxt = cityList.value;
                vm.selectedFamilyMember.sex = cityList.key;
            }
            else if (cityList.Type == "Relation") {
               
                vm.selectedFamilyMember.relationName = cityList.value;
                vm.selectedFamilyMember.relation = cityList.key;
               
            }
        }

        vm.closeVaccEditDialog = function () {
            vm.vaccDetails = true;
        }

        vm.shareSociallyVac = function () {
            //alert("About to share message");
            common.shareSocially("check out vaccination service in Kare4U mobile app. You can setup vaccination chart for your kids in seconds. Get alerts and schedule appointments with your pediatrician");
        }

    }
})();