﻿(function () {
    'use strict';
    var controllerId = 'vital';
    angular.module('app').controller(controllerId, ['common', 'datacontext', '$scope', vital]);

    function vital(common, datacontext, $scope) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'Vital';

        vm.onAll = true;
        vm.onPulseRate = false;
        vm.onBP = false;
        vm.onSugar = false;
        ///Vital Variables
        vm.vitalPage = false;
        vm.vitalInitialData = [];
        vm.vitalGraphData = [];
        vm.plotData = [];
        vm.showGraph = true;
        vm.addVitalShow = false;
        vm.unitfeet = true;
        vm.unitcm = false;
        vm.unitkg = true;
        vm.unitlbs = false;
        $scope.SaveIcon = false;
        $scope.EditIcon = true;
        $scope.editTextValue = true;
        vm.vitalToSave = {
            "ConsumerID": "",
            "PulseRate": "",
            "BP_Systolic": "",
            "BP_Diastolic": "",
            "PBS": "",
            "RBS": "",
            "VitalCreatedOn": moment().format("DD MMM, YYYY"),
            //extra
            "Body_Temperature": "",
            "Cholesterol": "",
            "HeartBeat": "",
            "Height": "",
            "Weight": ""
        };
        $scope.vitalToSaveEdited = {
            "ConsumerID": 0,
            "PHRVitalID": 0,
            "VitalID": 0,
            "Value": 0,
            "VitalName": "",
            "CriticalVital": "",
            "VitalDate": ''
        };
        var minVital = 0;
        var maxVital = 0;


        ///BMI Variables
        vm.bmiGraphData = [];
        vm.bmiPlotData = [];
        vm.addBMIShow = false;
        vm.weightKG = 0;
        vm.WeightLbs = 0;
        vm.heightFeet = 0;
        vm.heightInch = 0;
        vm.heightCM = 0;
        vm.editBmiEnable = false;
        $scope.editBMIShow = false;
        $scope.pointIndex = 0;
        vm.addHeightBMI = 1.70;
        vm.addWeightBMI = 60;
        var minBMI = 0;
        var maxBMI = 0;

        /////Controller Body
        /////////////////////////////////////////////////
        activate();
        function activate() {
            var promises = [getFamilyMembers()];
            common.activateController(promises, controllerId);
        }
        ///// Vital-Chart Code
        //////////////////////////////
        /////
        function getFamilyMembers() {
            //return datacontext.phr.getFamilyMembers().then(function (data) {
            return datacontext.appointment.GetFamilyListForDropDown().then(function (data) {
                var familyMamList = [];
                //vm.selectedFamilyMember = data[0].value; key
                //vm.selectedFamilyMemberName = data[0].text; 
                vm.selectedFamilyMember = data[0].key;
                vm.selectedFamilyMemberName = data[0].value;
                //vm.listFamilyMembers = data;
                if (vm.vitalPage) {
                    vm.showVitalChart();
                }
                else {
                    vm.showBMIChart();
                }
                for (var i = 0; i < data.length; i++) {
                    //familyMamList.push({ key: data[i].value, value: data[i].text, Type: "FamMembers" });
                    familyMamList.push({ key: data[i].key, value: data[i].value, Type: "FamMembers" });
                }
                //return vm.listFamilyMembers;
                return vm.commonDropDownList = familyMamList;
            });
        }
        vm.showVitalChart = function () {
            vm.onAll = true;
            vm.onPulseRate = false;
            vm.onBP = false;
            vm.onSugar = false;
            $scope.vitalToSaveEdited.VitalName = '';
            getPHRVitals();
        };
        function getPHRVitals() {
            return datacontext.phr.getPHRVitals(vm.selectedFamilyMember).then(function (data) {
                //vm.vitalInitialData = data;
                vm.vitalDynamoInitialData = data;
                //vm.setVitalGraphData();
                vm.setDynamoVitalGraphData();
                return vm.vitalInitialData;
            });
        }
        //Dynamo Method
        vm.setDynamoVitalGraphData = function ()
        {
            vm.pulseRateInitialData = [];
            vm.bpInitialData = [];
            vm.bsInitialData = [];
            vm.vitalGraphData = [];
            vm.pulseRatePlotData = [];
            vm.diastolicPlotData = [];
            vm.systolicPlotData = [];
            vm.ppsPlotData = [];
            vm.rbsPlotData = [];
            for (var i = 0; i < vm.vitalDynamoInitialData.length; i++) {
                var vitalType = vm.vitalDynamoInitialData[i].consumerIDAndType.split("#")[1];
                
                if (vitalType == 1) {
                    vm.pulseRatePlotData.push([new Date(vm.vitalDynamoInitialData[i].vitalDate).getTime(), vm.vitalDynamoInitialData[i].pulseRate]);
                    vm.pulseRateInitialData.push(vm.vitalDynamoInitialData[i]);
                }
                if (vitalType == 4) {
                    if (vm.vitalDynamoInitialData[i].systolic != null) {
                        vm.systolicPlotData.push([new Date(vm.vitalDynamoInitialData[i].vitalDate).getTime(), vm.vitalDynamoInitialData[i].systolic]);
                    }
                    if (vm.vitalDynamoInitialData[i].diastolic != null) {
                        vm.diastolicPlotData.push([new Date(vm.vitalDynamoInitialData[i].vitalDate).getTime(), vm.vitalDynamoInitialData[i].diastolic]);
                    }
                    vm.bpInitialData.push(vm.vitalDynamoInitialData[i]);
                }
                if (vitalType == 8) {
                    if (vm.vitalDynamoInitialData[i].pps != null) {
                        vm.ppsPlotData.push([new Date(vm.vitalDynamoInitialData[i].vitalDate).getTime(), vm.vitalDynamoInitialData[i].pps]);
                    }
                    if (vm.vitalDynamoInitialData[i].rbs != null) {
                        vm.rbsPlotData.push([new Date(vm.vitalDynamoInitialData[i].vitalDate).getTime(), vm.vitalDynamoInitialData[i].rbs]);
                    }
                    vm.bsInitialData.push(vm.vitalDynamoInitialData[i]);
                }
            }
            if (typeof vm.vitalDynamoInitialData[0] != 'undefined') {
                if (vm.onAll == true) {
                    vm.vitalGraphData.push({ label: "Pulse Rate", data: vm.pulseRatePlotData });
                    vm.vitalGraphData.push({ label: "Systolic", data: vm.systolicPlotData });
                    vm.vitalGraphData.push({ label: "Diastolic", data: vm.diastolicPlotData });
                    vm.vitalGraphData.push({ label: "PPS", data: vm.ppsPlotData });
                    vm.vitalGraphData.push({ label: "FBS", data: vm.rbsPlotData });
                }
                else if (vm.onPulseRate == true) {
                    vm.vitalGraphData.push({ label: "Pulse Rate", data: vm.pulseRatePlotData });
                }
                else if (vm.onBP == true) {
                    vm.vitalGraphData.push({ label: "Systolic", data: vm.systolicPlotData });
                    vm.vitalGraphData.push({ label: "Diastolic", data: vm.diastolicPlotData });
                }
                else if (vm.onSugar == true) {
                    vm.vitalGraphData.push({ label: "PPS", data: vm.ppsPlotData });
                    vm.vitalGraphData.push({ label: "FBS", data: vm.rbsPlotData });
                }
            }
            if (vm.vitalGraphData.length > 0) {
                vm.showGraph = true;
            }
            else {
                vm.showGraph = false;
            }
            $.plot($("#vitalLineChart"), vm.vitalGraphData, {
                series: {
                    lines: {
                        show: true,
                        lineWidth: 3
                    },
                    points: {
                        show: true,
                        lineWidth: 5
                    },
                    shadowSize: 6
                },
                grid: {
                    hoverable: true,
                    clickable: true,
                    //tickColor: "#c7c4c3",
                    borderWidth: 0
                    // backgroundColor: "rgba(255, 255, 255, 0.2)"
                },
                legend: {
                    container: $("#vitalLineChartlegend"),
                    noColumns: 3,
                    backgroundColor: "green",
                    color: "white",
                    labelFormatter: function (label, series) {
                        return '<span style="white-space:nowrap;font-size:10px;padding:5px;color:white;">' + label + '</span>';
                    }
                },
                xaxis: {
                    mode: "time",
                    timeformat: "%d-%b-%Y",
                    minTickSize: [1, "day"],
                    // max: maxVital,
                    // min: minVital
                    tickLength: 0,
                    color: "white"
                },
                yaxis: {
                    ticks: 5,
                    tickDecimals: 0,
                    //min: minVital,
                    // max: maxVital
                    color: "white"
                }
            });
        };
        $("#vitalLineChart").bind("plotclick", function (event, pos, item) {
            if (item.series.label == "Pulse Rate") {
                $scope.vitalToSaveEdited.VitalName = "Pulse Rate";
                $scope.vitalToSaveEdited.VitalDate = moment(vm.pulseRateInitialData[item.dataIndex].vitalDate).format("DD MMM, YYYY");
                $scope.vitalToSaveEdited.Value = vm.pulseRateInitialData[item.dataIndex].pulseRate;
                $scope.editVitalData = vm.pulseRateInitialData[item.dataIndex];
            }
            if (item.series.label == "Systolic") {
                $scope.vitalToSaveEdited.VitalName = "Systolic";
                $scope.vitalToSaveEdited.VitalDate = moment(vm.bpInitialData[item.dataIndex].vitalDate).format("DD MMM, YYYY");
                $scope.vitalToSaveEdited.Value = vm.bpInitialData[item.dataIndex].systolic;
                $scope.editVitalData = vm.bpInitialData[item.dataIndex];
            }
            if (item.series.label == "Diastolic") {
                $scope.vitalToSaveEdited.VitalName = "Diastolic";
                $scope.vitalToSaveEdited.VitalDate = moment(vm.bpInitialData[item.dataIndex].vitalDate).format("DD MMM, YYYY");
                $scope.vitalToSaveEdited.Value = vm.bpInitialData[item.dataIndex].diastolic;
                $scope.editVitalData = vm.bpInitialData[item.dataIndex];
            }
            if (item.series.label == "PPS") {
                $scope.vitalToSaveEdited.VitalName = "PPS";
                $scope.vitalToSaveEdited.VitalDate = moment(vm.bsInitialData[item.dataIndex].vitalDate).format("DD MMM, YYYY");
                $scope.vitalToSaveEdited.Value = vm.bsInitialData[item.dataIndex].pps;
                $scope.editVitalData = vm.bsInitialData[item.dataIndex];
            }
            if (item.series.label == "FBS") {
                $scope.vitalToSaveEdited.VitalName = "FBS";
                $scope.vitalToSaveEdited.VitalDate = moment(vm.bsInitialData[item.dataIndex].vitalDate).format("DD MMM, YYYY");
                $scope.vitalToSaveEdited.Value = vm.bsInitialData[item.dataIndex].rbs;
                $scope.editVitalData = vm.bsInitialData[item.dataIndex];
            }
            $scope.$apply();
            $(".vitalvalue").val($scope.vitalToSaveEdited.Value);
        });
        function saveEditedVitalsDetails() {
            if ($scope.vitalToSaveEdited.VitalName == "Pulse Rate") {
                $scope.editVitalData.pulseRate = $scope.vitalToSaveEdited.Value;
            }
            if ($scope.vitalToSaveEdited.VitalName == "Systolic") {
                $scope.editVitalData.systolic = $scope.vitalToSaveEdited.Value;
            }
            if ($scope.vitalToSaveEdited.VitalName == "Diastolic") {
                $scope.editVitalData.diastolic = $scope.vitalToSaveEdited.Value;
            }
            if ($scope.vitalToSaveEdited.VitalName == "PPS") {
                $scope.editVitalData.pps = $scope.vitalToSaveEdited.Value;
            }
            if ($scope.vitalToSaveEdited.VitalName == "FBS") {
                $scope.editVitalData.rbs = $scope.vitalToSaveEdited.Value;
            }
            return datacontext.phr.saveEditedVitalsDetails($scope.editVitalData, $scope.vitalToSaveEdited.VitalName).then(function (response) {
                if (response.status == 400) {
                    logError(response.data.message, '', true);
                }
                else {
                    logSuccess(response.message, '', true);
                    $scope.vitalToSaveEdited.VitalName = '';
                    getPHRVitals();
                }
            }, function (response) { });
        }
        vm.pulseRateEdit = function () {
            $scope.SaveIcon = true;
            $scope.EditIcon = false;
            $scope.editTextValue = false;
        }
        vm.pulseRateSave = function () {
            saveEditedVitalsDetails();
        }
        vm.addVital = function () {
            $scope.vitalToSaveEdited.VitalName = '';
            vm.addVitalShow = true;
        };
        vm.saveVitals = function () {
            vm.vitalToSave.ConsumerID = vm.selectedFamilyMember;
            return datacontext.phr.saveVitals(vm.vitalToSave).then(function (response) {
                if (response.status == 400) {
                    logError(response.data.message, '', true);
                }
                else {
                    if (response.success == true) {
                        logSuccess(response.message, '', true);
                        vm.showVitalChart();
                        vm.addVitalShow = false;
                        vm.clearVitals();
                    }
                    else {
                        logError(response.message, '', true);
                    }
                }
            }, function (response) { });
        };
        vm.clearVitals = function () {
            vm.vitalToSave.ConsumerID = "";
            vm.vitalToSave.PulseRate = "";
            vm.vitalToSave.BP_Systolic = "";
            vm.vitalToSave.BP_Diastolic = "";
            vm.vitalToSave.PBS = "";
            vm.vitalToSave.RBS = "";
            vm.vitalToSave.VitalCreatedOn = moment().format("DD MMM, YYYY");
            //extra
            vm.vitalToSave.Body_Temperature = "";
            vm.vitalToSave.Cholesterol = "";
            vm.vitalToSave.HeartBeat = "";
            vm.vitalToSave.Height = "";
            vm.vitalToSave.Weight = "";
        };

        ///// BMI-Chart Code
        //////////////////////////////
        /////

        vm.kg2Pound = function () {
            if (vm.weightKG == "" || vm.weightKG < 0) {
                vm.weightKG = 0;
            }
            vm.WeightLbs = parseInt(vm.weightKG * 2.2);
            vm.calculateBMI();
        };
        vm.pound2Kg = function () {
            if (vm.WeightLbs == "" || vm.WeightLbs < 0) {
                vm.WeightLbs = 0;
            }
            vm.weightKG = parseInt(vm.WeightLbs / 2.2);
            vm.calculateBMI();
        };
        vm.cm2Feet = function () {
            var unitFeetInch = Math.ceil(Math.round((vm.heightCM * 0.3937008), 1));
            vm.heightFeet = parseInt(unitFeetInch / 12);
            vm.heightInch = (unitFeetInch - (vm.heightFeet * 12));
            vm.calculateBMI();
            vm.calculateIdleWeight();
        };
        vm.feet2CM = function () {
            var unitfeetcm = ((vm.heightFeet * 12) / 0.3937008).toFixed(2);
            var unitinchescm = (vm.heightInch / 0.3937008).toFixed(2);
            var unitcm = parseFloat(unitfeetcm) + parseFloat(unitinchescm);
            vm.heightCM = parseInt(unitcm);
            vm.calculateBMI();
            vm.calculateIdleWeight();
        };

        vm.heightFeetIncrement = function () {
            vm.heightFeet = parseInt(vm.heightFeet) + 1;
            vm.feet2CM();
        };
        vm.heightFeetDecrement = function () {
            vm.heightFeet = parseInt(vm.heightFeet) - 1;
            if (vm.heightFeet < 0) {
                vm.heightFeet = 0;
            }
            vm.feet2CM();
        };
        vm.heightInchIncrement = function () {
            vm.heightInch++;
            if (vm.heightInch == 12) {
                vm.heightInch = 0;
                vm.heightFeet++;
            }
            vm.feet2CM();
        };
        vm.heightInchDecrement = function () {
            vm.heightInch = parseInt(vm.heightInch) - 1;
            if (vm.heightInch < 0) {
                vm.heightInch = 11;
                vm.heightFeet--;
                if (vm.heightFeet < 0) {
                    vm.heightFeet = 0;
                }
            }
            vm.feet2CM();
        };
        vm.heightCMIncrement = function () {
            vm.heightCM = parseInt(vm.heightCM) + 1;
            vm.cm2Feet();
        };
        vm.heightCMDecrement = function () {
            vm.heightCM = parseInt(vm.heightCM) - 1;
            if (vm.heightCM < 0) {
                vm.heightCM = 0;
            }
            vm.cm2Feet();
        };

        vm.weightKgIncrement = function () {
            vm.weightKG = parseInt(vm.weightKG) + 1;
            vm.kg2Pound();
        };
        vm.weightKgDecrement = function () {
            vm.weightKG = parseInt(vm.weightKG) - 1;
            if (vm.weightKG < 0) {
                vm.weightKG = 0;
            }
            vm.kg2Pound();
        };
        vm.weightPoundIncrement = function () {
            vm.WeightLbs = parseInt(vm.WeightLbs) + 1;
            vm.pound2Kg();
        };
        vm.weightPoundDecrement = function () {
            vm.WeightLbs = parseInt(vm.WeightLbs) - 1;
            if (vm.WeightLbs < 0) {
                vm.WeightLbs = 0;
            }
            vm.pound2Kg();
        };

        vm.showBMIChart = function () {
            getBMIData();
        };
        function getBMIData() {
            vm.bmiGraphData = [];
            vm.bmiPlotData = [];
            vm.dummyDataForEdit = [];
            var minBMI, maxBMI;
            var count = 0; //Counter for min and max value set
            return datacontext.phr.getBMIData(vm.selectedFamilyMember).then(function (data) {
                vm.bmiDynamoInitialData = data;
                for (var i = 0; i < data.length; i++) {
                    var heightBMI = data[i].height / 100;
                    var weightBMI = data[i].weight;
                    var calculatedBMI = Math.round((weightBMI / (heightBMI * heightBMI)), 2);
                    if (count == 0) {
                        minBMI = calculatedBMI;
                        maxBMI = calculatedBMI;
                    }
                    else {
                        if (calculatedBMI > maxBMI) {
                            maxBMI = calculatedBMI;
                        }
                        if (calculatedBMI < minBMI) {
                            minBMI = calculatedBMI;
                        }
                    }
                    vm.bmiPlotData.push([new Date(data[i].vitalDate).getTime(), calculatedBMI]);
                }
                vm.bmiGraphData.push({ label: "BMI", data: vm.bmiPlotData });
                if (vm.bmiPlotData.length > 0) {
                    vm.showGraph = true;
                    vm.addHeightBMI = data[data.length - 1].height / 100;
                    vm.addWeightBMI = data[data.length - 1].weight;
                }
                else {
                    vm.showGraph = false;
                    vm.addHeightBMI = 1.70;
                    vm.addWeightBMI = 60;
                }
                getGenericChart(vm.bmiGraphData, '#BMILineChart', "#BMILineChartlegend");
                return vm.bmiGraphData;
            });
        }
        $("#BMILineChart").bind("plotclick", function (event, pos, item) {
            $scope.pointIndex = item.dataIndex;
            $scope.editBMIDate = moment(vm.bmiDynamoInitialData[$scope.pointIndex].vitalDate).format("DD MMM, YYYY");
            $scope.editBMIValue = item.datapoint[1];
            $scope.editBMIShow = true;
            $scope.$apply();
        });
        vm.calculateBMI = function () {
            var heightBMI = vm.heightCM / 100;
            var weightBMI = vm.weightKG;
            vm.calculatedBMI = Math.round((weightBMI / (heightBMI * heightBMI)), 2);
            var rawMargin;
            if (vm.calculatedBMI > 50) {
                rawMargin = 50;
            }
            else {
                rawMargin = vm.calculatedBMI;
            }
            var margin = ((rawMargin * 2) - 3).toString() + "%";

            document.getElementById("testslide").style.marginLeft = margin;
        };
        vm.calculateIdleWeight = function () {
            var heightBMI = vm.heightCM / 100;
            vm.idleWeightLow = parseInt((heightBMI * heightBMI) * 18.5);
            vm.idleWeightHigh = parseInt((heightBMI * heightBMI) * 25);
        };
        vm.addBMI = function () {
            vm.clearBMI();
            vm.addBMIShow = true;
        };
        vm.clearBMI = function () {
            vm.vitalToSave.VitalCreatedOn = moment().format("DD MMM, YYYY");
            vm.weightKG = vm.addWeightBMI;
            vm.heightCM = vm.addHeightBMI * 100;
            vm.kg2Pound();
            vm.cm2Feet();
            vm.calculateBMI();
        };
        vm.reloadBMIGraph = function () {
            getGenericChart(vm.bmiGraphData, '#BMIChart svg');
        };
        vm.saveBMI = function () {
            if (vm.editBmiEnable == false) {
                vm.vitalToSave.ConsumerID = vm.selectedFamilyMember;
                vm.vitalToSave.Height = vm.heightCM;
                vm.vitalToSave.Weight = vm.weightKG;
                return datacontext.phr.saveVitals(vm.vitalToSave).then(function (response) {
                    if (response.status == 400) {
                        logError(response.data.message, '', true);
                    }
                    else {
                        logSuccess('BMI added successfully', '', true);
                        vm.addBMIShow = false;
                        vm.showBMIChart();
                    }
                }, function (response) { });
            }
            else {
                vm.bmiDynamoInitialData[$scope.pointIndex].weight = vm.weightKG;
                vm.bmiDynamoInitialData[$scope.pointIndex].height = vm.heightCM;
                return datacontext.phr.saveEditedVitalsDetails(vm.bmiDynamoInitialData[$scope.pointIndex], "BMI").then(function (response) {
                    if (response.status == 400) {
                        logError(response.data.message, '', true);
                    }
                    else {
                        logSuccess(response.message, '', true);
                        vm.addBMIShow = false;
                        vm.showBMIChart();
                    }
                }, function (response) { });
            }
        };
        vm.bmiUpdate = function () {
            vm.vitalToSave.VitalCreatedOn = moment(vm.bmiDynamoInitialData[$scope.pointIndex].vitalDate).format("DD MMM, YYYY");
            vm.weightKG = parseFloat(vm.bmiDynamoInitialData[$scope.pointIndex].weight);
            vm.heightCM = parseFloat(vm.bmiDynamoInitialData[$scope.pointIndex].height);
            vm.kg2Pound();
            vm.cm2Feet();
            vm.calculateBMI();
            vm.editBmiEnable = true;
            vm.addBMIShow = true;
        };
        ///// Common PHR Code
        //////////////////////////////
        /////
        vm.closeFamilyList = function () {
            $('#familymodal').modal('hide');
        };
        vm.openFamilyList = function () {
            $('#familymodal').modal('show');
        };
        function getGenericChart(graphdata, chartId, chartLegendId) {
            $.plot($(chartId), graphdata, {
                series: {
                    lines: {
                        show: true,
                        lineWidth: 3
                    },
                    points: {
                        show: true,
                        lineWidth: 5
                    },
                    shadowSize: 6
                },
                grid: {
                    hoverable: true,
                    clickable: true,
                    //tickColor: "#c7c4c3",
                    borderWidth: 0
                    // backgroundColor: "rgba(255, 255, 255, 0.2)"
                },
                legend: {
                    container: $(chartLegendId),
                    noColumns: 3,
                    //backgroundColor: "green",
                    color: "white",
                    labelFormatter: function (label, series) {
                        return '<span style="white-space:nowrap;font-size:10px;padding:5px;color:white;">' + label + '</span>';
                    }
                },
                colors: ["#2FABE9", "#bdea74", "#FA5833", "#eae874"],
                //xaxis: { ticks: 10, tickDecimals: 0 },
                xaxis: {
                    mode: "time",
                    timeformat: "%d-%b-%Y",
                    minTickSize: [1, "day"],
                    // max: maxVital,
                    tickLength: 0,
                    // min: minVital
                    color: "white"
                },
                yaxis: {
                    ticks: 5,
                    tickDecimals: 0,
                    //min: minVital,
                    // max: maxVital
                    color: "white"
                }
            });
            //nv.addGraph(function () {
            //    if (chartId == '#BMIChart svg') {
            //        var chart = nv.models.cumulativeLineChart(chartId)
            //                  .useInteractiveGuideline(false)
            //                  .x(function (d) { return d[0] })
            //                  .y(function (d) { return d[1] })
            //                  .color(d3.scale.category10().range())
            //                  .transitionDuration(300)
            //                  .clipVoronoi(false)
            //                  .forceY([minBMI - 5, maxBMI + 5]);
            //    }
            //    else {
            //        var chart = nv.models.cumulativeLineChart(chartId)
            //                  .useInteractiveGuideline(false)
            //                  .x(function (d) { return d[0] })
            //                  .y(function (d) { return d[1] })
            //                  .color(d3.scale.category10().range())
            //                  .transitionDuration(300)
            //                  .clipVoronoi(false)
            //                  .forceY([minVital - 5, maxVital + 5]);;
            //    }
            //    chart.xAxis
            //       .tickFormat(function (d) {
            //           return d3.time.format('%d %b, %y')(new Date(d))
            //       });

            //    //chart.yAxis
            //    //    .tickFormat(d3.format(',.1%'));

            //    d3.select(chartId)
            //      .datum(graphdata)
            //      .call(chart);
            //    //TODO: Figure out a good way to do this automatically
            //    nv.utils.windowResize(chart.update);

            //    chart.dispatch.on('stateChange', function (e) { nv.log('New State:', JSON.stringify(e)); });
            //    return chart;
            //});
        }
        $scope.openFamilyListModal = function () {
            vm.commonDropDownHeader = "Family Members";
            vm.commonDropDownFilterDisplay = false;
            vm.commonDropDownFilteredValue = "";
            vm.commonDropDownPlaceHoldertext = "Select Family Members";
            $('#common-drop-down-modal').modal('show');
        }
        vm.commonDropDownOption = function (cityList) {
            $('#common-drop-down-modal').modal('hide');
            if (cityList.Type == "FamMembers") {
                vm.selectedFamilyMember = cityList.key;
                vm.selectedFamilyMemberName = cityList.value;
                if (vm.vitalPage) {
                    vm.showVitalChart();
                }
                else {
                    vm.showBMIChart();
                }
            }
        }
        vm.shareSociallyVitals = function () {
            common.shareSocially("Using Kare4U app to monitor my vitals (Diabetes, Pulse Rate, etc.)");
        }
        vm.shareSociallyBMI = function () {
            common.shareSocially("Monitor your BMI index by using Kare4U mobile app for a healthy lifestyle. Using BMI service of Kare4U mobile app to monitor weight.");
        }
    }
})();