﻿(function () {
    'use strict';
    var controllerId = 'profile';
    angular.module('app').controller(controllerId, ['common', 'datacontext', '$scope', '$location', 'userService', profile]);

    function profile(common, datacontext, $scope, $location, userService) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var logInfo = common.logger.getLogFn(this.serviceId, 'info');
        var vm = this;
        vm.title = 'profile';
        vm.myProfile = [];
        vm.newUserLogin = "";
        vm.newPassword = "";
        vm.oldPassword = "";
        vm.newContact = "";
        vm.commonDropDownFilterDisplay = false;

        vm.familyMembers = [];
        vm.selectedFamilyMember = {
            "name": "",
            "relation": 120,
            "dateOfBirth": "",
            "contact": "",
            "sex": 100,
            "sexDescription": "",
            "relationDescription": ""
        };
        vm.newFamilyMember = {
            "name": "",
            "relation": 120,
            "dateOfBirth": "",
            "contact": "",
            "sex": 100,
            "sexDescription": "",
            "relationDescription":""
        };
        $scope.selectGender = 'male';
        vm.isPasswordDisabled = true;
        vm.isContactDisabled = true;
        vm.isEmailDisabled = true;
        vm.showFamilyMembers = true;
        vm.isEditDiv = false;
        vm.addFamilyMember = true;
        vm.familyupdate = false;

        vm.spouseExist = false;
        vm.fatherExist = false;
        vm.motherExist = false;
        vm.kidsExist = false;
        vm.othersExist = false;

        $scope.toggleFamilyDetail = function ($index) {
            $scope.activePosition = $scope.activePosition == $index ? -1 : $index;
        };
        activate();
        function activate() {
            var promises = [getRelations()];
            common.activateController(promises, controllerId);
        }
        function getRelations() {
            return datacontext.cacheservice.getDropDownValues('Family').then(function (data) {
                vm.selectedFamilyMember.relation = data[0].value;
                vm.selectedFamilyMember.relationDescription = data[0].displayText;
                var commonDropdownrelation = [];

                for (var i = 0; i < data.length; i++) {
                    commonDropdownrelation.push({ key: data[i].value, value: data[i].displayText, Type: "Relation" });
                }
                vm.relationDropDownList = commonDropdownrelation;
                console.log(vm.relationDropDownList);
                vm.tempRelationList = commonDropdownrelation;
                getGenders();
                return vm.relationDropDownList;
            });
        };
        function getGenders() {
            return datacontext.cacheservice.getDropDownValues('Sex').then(function (data) {
                vm.selectedFamilyMember.sex = data[0].value;
                vm.selectedFamilyMember.sexDescription = data[0].displayText;
                vm.genderList = data;
                var commonDropdownGender = [];
                for (var i = 0; i < data.length; i++) {
                    commonDropdownGender.push({ key: data[i].value, value: data[i].displayText, Type: "Gender" });
                }
                vm.commonDropDownList = commonDropdownGender;
                vm.genderDropDownList = commonDropdownGender;

                getMyProfile();
                getFamilyMembers();
                return vm.genderList;
            });
        }
        function getFamilyMembers() {
            return datacontext.profile.getFamilyMembers().then(function (data) {
                if (data.length > 0) {
                    vm.showFamilyMembers = true;
                }
                else {
                    vm.showFamilyMembers = false;
                }
                vm.familyMembers = data;
                RelationExists();
                return vm.familyMembers;
            }, function (result) {
                logInfo(result, '', true);
            });
        }
        function getMyProfile() {
            return datacontext.profile.getMyProfile().then(function (data) {
                if (isNaN(moment().diff(data[0].dateOfBirth, 'years'))) {
                    vm.profileAge = "";
                }
                else {
                    vm.profileAge = "(" + moment().diff(data[0].dateOfBirth, 'years') + " yrs";
                }
                vm.profileGender = "";
                vm.profileGenderDesc = "";
                for (var i = 0; i < vm.genderList.length; i++) {
                    if (vm.genderList[i].value == data[0].sex) {
                        if (vm.profileAge == "") {
                            vm.profileGender = "(" + vm.genderList[i].displayText + ")";
                        }
                        else {
                            vm.profileGender = ", " + vm.genderList[i].displayText + ")";
                        }
                        vm.profileGenderDesc = vm.genderList[i].displayText;
                        break;
                    }
                }
                if (vm.profileGender == "") {
                    if (vm.profileAge == "") {
                    }
                    else {
                        vm.profileAge = vm.profileAge + ")";
                    }
                }

                if (userService.userImageSrc != "") {
                    try {
                        vm.userImageurl = userService.userImageSrc;

                    } catch (e) {
                        logError("Error in retriving your facebook image.", '', true);
                        if (data[0].sex == '100') {
                            vm.userImageurl = "content/images/user-image.png";
                        }
                        else {
                            vm.userImageurl = "content/images/profile/femaleuser-image.png";
                        }
                    }
                }
                else {
                    if (data[0].sex == '100') {
                        vm.userImageurl = "content/images/user-image.png";
                    }
                    else {
                        vm.userImageurl = "content/images/profile/femaleuser-image.png";
                    }
                }

                if (data[0].dateOfBirth == "Not Updated") {
                    data[0].dateOfBirth = "";
                }
                return vm.myProfile = data[0];
            });
        }

        vm.updateProfile = function () {
            return datacontext.profile.updateProfile(vm.myProfile).then(function (response) {
                getMyProfile();
                userService.userName = vm.myProfile.firstName;
                logSuccess('Profile updated successfully', '', true);
                vm.isEditDiv = false;
            }, function (response) { });
        };

        vm.updateUserLogin = function () {
            var newDetails = {
                UserLogin: vm.newUserLogin
            };
            return datacontext.profile.updateUserIDOrPassword(newDetails).then(function (response) {
                getMyProfile();
                logSuccess('User Login updated successfully', '', true);
                $('#editEmailModal').modal('hide');
                vm.newUserLogin = "";
            }, function (response) { });
        };

        vm.updatePassword = function () {
            var newDetails = {
                NewPassword: vm.newPassword,
                Password: vm.oldPassword
            };
            return datacontext.profile.updateUserIDOrPassword(newDetails).then(function (response) {
                getMyProfile();
                logSuccess('Password updated successfully', '', true);
                $('#editPasswordModal').modal('hide');
                vm.newPassword = "";
                vm.oldPassword = "";
            }, function (response) { });
        };

        vm.updateContact = function () {
            var newDetails = {
                Contact: vm.newContact
            };
            return datacontext.profile.updateUserIDOrPassword(newDetails).then(function (response) {
                getMyProfile();
                logSuccess('Contact updated successfully', '', true);
                $('#editContactModal').modal('hide');
                vm.newContact = "";
            }, function (response) { });
        };

        vm.editRelation = function (familyMember, selectedMemIndex) {
            vm.familyupdate = true;
            vm.addFamilyMember = false;
            vm.selectedFamilyMember = familyMember;
            var dob = new Date(familyMember.dateOfBirth);
            familyMember.dateOfBirth = moment(dob).format("DD MMM, YYYY");
            familyMember.contact = parseInt(familyMember.contact);
            vm.selectedFamilyMember.sex = familyMember.sex;
            for (var i = 0; i < vm.genderDropDownList.length; i++) {
                if (vm.genderDropDownList[i].key == vm.selectedFamilyMember.sex) {
                    vm.selectedFamilyMember.sexDescription = vm.genderDropDownList[i].value;
                    break;
                }
            }
            vm.selectedFamilyMember.relation = familyMember.relation;
            for (var i = 0; i < vm.tempRelationList.length; i++) {
                if (vm.tempRelationList[i].key == vm.selectedFamilyMember.relation) {
                    vm.selectedFamilyMember.relationDescription = vm.tempRelationList[i].value;
                    break;
                }
            }
        };

        vm.updateFamilyDetails = function () {
            if (vm.familyupdate) {
                return datacontext.profile.updateFamilyDetails(vm.selectedFamilyMember, vm.familyupdate).then(function (response) {
                    logSuccess('Profile updated successfully', '', true);
                    getFamilyMembers();
                    vm.addFamilyMember = true;
                }, function (response) { });
            }
            else {
                return datacontext.profile.updateFamilyDetails(vm.newFamilyMember, vm.familyupdate).then(function (response) {
                    logSuccess('Family member added successfully', '', true);
                    getFamilyMembers();
                    vm.addFamilyMember = true;
                }, function (response) { });
            }
        };

        vm.addRelation = function () {
            vm.familyupdate = false;
            vm.newFamilyMember.name = "";
            vm.newFamilyMember.dateOfBirth = moment().format("DD MMM, YYYY");;
            vm.newFamilyMember.contact = parseInt(userService.contact);
            vm.newFamilyMember.sex = 100;
            vm.newFamilyMember.sexDescription = "Male";
            vm.addFamilyMember = false;
            vm.relationDisabled = false;
            vm.genderDisabled = true;
            var tempRelationListKids = [];
            for (var i = 0; i < vm.tempRelationList.length; i++) {
                if (vm.tempRelationList[i].key > 125 || vm.tempRelationList[i].key == 122 || vm.tempRelationList[i].key == 123) {
                    tempRelationListKids.push(vm.tempRelationList[i]);
                }
            }
            vm.relationDropDownList = tempRelationListKids;
            vm.newFamilyMember.relation = vm.tempRelationList[6].key;
            vm.newFamilyMember.relationDescription = vm.tempRelationList[6].value;
        };

        vm.addFather = function () {
            vm.familyupdate = false;
            vm.relationDropDownList = vm.tempRelationList;
            vm.newFamilyMember.name = "";
            vm.newFamilyMember.relation = 124;
            vm.newFamilyMember.relationDescription = vm.tempRelationList[4].value;
            vm.newFamilyMember.dateOfBirth = moment(vm.myProfile.dateOfBirth).subtract('years', 30).format("DD MMM, YYYY");
            vm.newFamilyMember.contact = parseInt(userService.contact);
            vm.newFamilyMember.sex = 100;
            vm.newFamilyMember.sexDescription = "Male";
            vm.addFamilyMember = false;
            vm.relationDisabled = true;
            vm.genderDisabled = true;
        };

        vm.addMother = function () {
            vm.familyupdate = false;
            vm.relationDropDownList = vm.tempRelationList;
            vm.newFamilyMember.name = "";
            vm.newFamilyMember.relation = 125;
            vm.newFamilyMember.relationDescription = vm.tempRelationList[5].value;
            vm.newFamilyMember.dateOfBirth = moment(vm.myProfile.dateOfBirth).subtract('years', 25).format("DD MMM, YYYY");
            vm.newFamilyMember.contact = parseInt(userService.contact);
            vm.newFamilyMember.sex = 101;
            vm.newFamilyMember.sexDescription = "Female";
            vm.addFamilyMember = false;
            vm.relationDisabled = true;
            vm.genderDisabled = true;
        };

        vm.addSpouse = function () {
            vm.familyupdate = false;
            vm.relationDropDownList = vm.tempRelationList;
            vm.newFamilyMember.name = "";
            vm.newFamilyMember.dateOfBirth = moment(vm.myProfile.dateOfBirth).add('years', 5).format("DD MMM, YYYY");
            vm.newFamilyMember.contact = parseInt(userService.contact);
            if (vm.myProfile.sex == '100') {
                vm.newFamilyMember.relation = 121;
                vm.newFamilyMember.sex = 101;
                vm.newFamilyMember.sexDescription = "Female";
                vm.newFamilyMember.relationDescription = vm.tempRelationList[1].value;
            }
            else {
                vm.newFamilyMember.relation = 120;
                vm.newFamilyMember.sex = 100;
                vm.newFamilyMember.sexDescription = "Male";
                vm.newFamilyMember.relationDescription = vm.tempRelationList[0].value;
            }
            vm.addFamilyMember = false;
            vm.relationDisabled = true;
            vm.genderDisabled = true;
        };

        vm.addKids = function () {
            vm.familyupdate = false;
            var tempRelationListKids = [];
            for (var i = 0; i < vm.tempRelationList.length; i++) {
                if (vm.tempRelationList[i].key == 122 || vm.tempRelationList[i].key == 123 || vm.tempRelationList[i].key == 132) {
                    tempRelationListKids.push(vm.tempRelationList[i]);
                }
            }
            vm.relationDropDownList = tempRelationListKids;
            vm.newFamilyMember.name = "";
            vm.newFamilyMember.relation = 122;
            vm.newFamilyMember.relationDescription = vm.tempRelationList[2].value;
            vm.newFamilyMember.dateOfBirth = moment().format("DD MMM, YYYY");
            vm.newFamilyMember.contact = parseInt(userService.contact);
            vm.newFamilyMember.sex = 100;
            vm.newFamilyMember.sexDescription = "Male";
            vm.addFamilyMember = false;
            vm.relationDisabled = false;
            vm.genderDisabled = false;
        };

        vm.viewVaccination = function () {
            $location.path('/vaccination');
        };

        vm.closeFamilyDetails = function () {
            vm.addFamilyMember = true;
            vm.relationDropDownList = vm.tempRelationList;
        }

        function RelationExists() {
            for (var i = 0; i < vm.familyMembers.length; i++) {
                if (vm.familyMembers[i].relation == 120 || vm.familyMembers[i].relation == 121) {
                    vm.spouseExist = true;
                }
                if (vm.familyMembers[i].relation == 124) {
                    vm.fatherExist = true;
                }
                if (vm.familyMembers[i].relation == 125) {
                    vm.motherExist = true;
                }
                if (vm.familyMembers[i].relation == 122 || vm.familyMembers[i].relation == 123) {
                    vm.kidsExist = true;
                }
                if (vm.familyMembers[i].relation != 120 && vm.familyMembers[i].relation != 121 && vm.familyMembers[i].relation != 122 && vm.familyMembers[i].relation != 123 && vm.familyMembers[i].relation != 124 && vm.familyMembers[i].relation != 125) {
                    vm.othersExist = true;
                }
            }
        }

        vm.openEmailModal = function () {
            $('#editEmailModal').modal('show');
        }
        vm.openPasswordModal = function () {
            $('#editPasswordModal').modal('show');
        }
        vm.openContactModal = function () {
            $('#editContactModal').modal('show');
        }

        vm.profilegender = function () {
            vm.commonDropDownHeader = "Choose Gender";
            vm.commonDropDownFilteredValue = "";
            $('#common-drop-down-modal').modal('show');
        }
        vm.commonDropDownOption = function (genderOb) {
            $('#common-drop-down-modal').modal('hide');
            vm.myProfile.sex = genderOb.key;
            vm.profileGenderDesc = genderOb.value;
        }
        vm.familyAddRelGender = function () {
            $('#gender-drop-down-modal').modal('show');
        }
        vm.genderDropDownOption = function (genderOb) {
            $('#gender-drop-down-modal').modal('hide');
            if (vm.familyupdate) {
                vm.selectedFamilyMember.sexDescription = genderOb.value;
                vm.selectedFamilyMember.sex = genderOb.key; 
            }
            else {
                vm.newFamilyMember.sexDescription = genderOb.value;
                vm.newFamilyMember.sex = genderOb.key;
            }
        }
        vm.familyAddRelation = function () {
            $('#relation-drop-down-modal').modal('show');
        }
        vm.relationDropDownOption = function (relationOb) {
            $('#relation-drop-down-modal').modal('hide');
            if (vm.familyupdate) {
                if (relationOb.key == 120 || relationOb.key == 122 || relationOb.key == 124 || relationOb.key == 126 || relationOb.key == 129 || relationOb.key == 130) {
                    vm.selectedFamilyMember.sexDescription = "Male";
                    vm.selectedFamilyMember.sex = 100;
                    vm.genderDisabled = true;
                }
                else if (relationOb.key == 121 || relationOb.key == 123 || relationOb.key == 125 || relationOb.key == 127 || relationOb.key == 128 || relationOb.key == 131) {
                    vm.selectedFamilyMember.sexDescription = "Female";
                    vm.selectedFamilyMember.sex = 101;
                    vm.genderDisabled = true;
                }
                else {
                    vm.selectedFamilyMember.sexDescription = "Male";
                    vm.selectedFamilyMember.sex = 100;
                    vm.genderDisabled = false;
                }
                vm.selectedFamilyMember.relation = relationOb.key;
                vm.selectedFamilyMember.relationDescription = relationOb.value;
            }
            else {
                if (relationOb.key == 120 || relationOb.key == 122 || relationOb.key == 124 || relationOb.key == 126 || relationOb.key == 129 || relationOb.key == 130) {
                    vm.newFamilyMember.sexDescription = "Male";
                    vm.newFamilyMember.sex = 100;
                    vm.genderDisabled = true;
                }
                else if (relationOb.key == 121 || relationOb.key == 123 || relationOb.key == 125 || relationOb.key == 127 || relationOb.key == 128 || relationOb.key == 131) {
                    vm.newFamilyMember.sexDescription = "Female";
                    vm.newFamilyMember.sex = 101;
                    vm.genderDisabled = true;
                }
                else {
                    vm.newFamilyMember.sexDescription = "Male";
                    vm.newFamilyMember.sex = 100;
                    vm.genderDisabled = false;
                }
                vm.newFamilyMember.relation = relationOb.key;
                vm.newFamilyMember.relationDescription = relationOb.value;
            }
        }
    }
})();