﻿(function () {
    'use strict';
    var controllerId = 'doctorsetup';
    angular.module('app').controller(controllerId, ['common', 'datacontext','datarepo', '$scope', '$location', '$rootScope','searchCriteria', doctorsetup]);

    function doctorsetup(common, datacontext, datarepo, $scope, $location, $rootScope, searchCriteria) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');

        var vm = this;
        vm.title = 'Doctor setup';
        //vm.selectedSpecializationId = "";
        //vm.selectedSpecializationName = "";
        vm.specializationsDetails = [];
        var commonDropdowntwoListSpec = [];
       // vm.genericSpecializationContainer = { value: "", key: "" };
        vm.favouriteDoctors = [];
        var commonSpec = [];
        vm.isFirstVisit = true;
        $scope.flag = false;
        $scope.commonSpecializationsListOptionsText = "SHOW ALL";
        $scope.showAll = false;
        activate();

        function activate() {
            var promises = [ getSpecializationDetails(), getFavouriteDoctors()];
            common.activateController(promises, controllerId);
                //.then(function () { log('Activated Doctor Setup View'); });
        }

        function getSpecializationDetails() {
            return datacontext.registration.getSpecializationDetails().then(function (data) {
                return vm.specializationsDetails = data;
            });
        }
        
        function getFavouriteDoctors() {
            return datacontext.registration.getFavouriteDoctors().then(function (data) {
                if (data.length != 0)
                    vm.isFirstVisit = false;
                return vm.favouriteDoctors = data;
            });
        }
        vm.redirectToSearch = function () {

            $location.path('/dashboard');
        }
        vm.redirectToSearchPage = function () {
            //logSuccess('Thank you! you can access your favourite list from "My Favourites" page found in the dashboard at a later time.', '', true);
            $location.path('/dashboard');
        }
        vm.addMyDoctor = function (myCustomSpecialization) {
            //? need to be modified
            //alert(myCustomSpecialization.specializationID + " " + myCustomSpecialization.specializationName);
            searchCriteria.specializationId = myCustomSpecialization.specializationID;
           
            searchCriteria.specializationName = myCustomSpecialization.specializationName;
        

            //var autocompleteResult = datarepo.commonrepo.getAutocompleteResult();
            //autocompleteResult.doctorSpec = myCustomSpecialization.specializationID;
            //datarepo.commonrepo.saveAutocompleteResult(autocompleteResult);
            //vm.genericSpecializationContainer.key = myCustomSpecialization.specializationID;
            //vm.genericSpecializationContainer.value = myCustomSpecialization.specializationName;
            //datarepo.commonrepo.saveSpecializationDetails(vm.genericSpecializationContainer);
            $location.path('/specify_your_doctor');
        }
        vm.addMyDoctorSpecialization = function () {
            //$('#doctorSpecializationModal').modal('show');
            // doctorSpecializationList();
            getCommonSpecializations();
            // vm.commonDropDownHeader = "Choose Specialization";
            vm.commonDropDownTwoHeader = "Choose Specialization";
            //vm.commonDropDownFilterDisplay = true;
            //vm.commonDropDownFilteredValue = "";
            //vm.commonDropDownPlaceHoldertext = "Filter Specialization";
            vm.commonDropDownTwoFilterDisplay = true;
            vm.commonDropDownTwoFilteredValue = "";
            vm.commonDropDownTwoPlaceHoldertext = "Filter Specialization";
            // $('#common-drop-down-modal').modal('show');
            $('#common-Drop-Down-Two-modal').modal('show');
        }

        vm.commonDropDownTwoOption = function (specializationList) {
            $('#common-Drop-Down-Two-modal').modal('hide');
           // vm.hideDropdown = true;
           // searchCriteria.specializationName = specializationList.value;
           // searchCriteria.specializationId = specializationList.key;

            if (specializationList.Type == "Specialization") {
                //searchCriteria
                searchCriteria.specializationId = specializationList.key;
                searchCriteria.specializationName = specializationList.value;
                //vm.genericSpecializationContainer.key = dropdownList.key;
                //vm.genericSpecializationContainer.value = dropdownList.value;
                //datarepo.commonrepo.saveSpecializationDetails(vm.genericSpecializationContainer);
                $location.path('/specify_your_doctor');
            }
        }

        $scope.toggleAll = function () {
            $scope.showAll = !$scope.showAll;
            if ($scope.flag == false) {
                doctorSpecializationList();
            }
            $scope.flag = true;
            if ($scope.commonSpecializationsListOptionsText == "SHOW ALL") {
                $scope.commonSpecializationsListOptionsText = "HIDE ALL";
            }
            else if ($scope.commonSpecializationsListOptionsText == "HIDE ALL") {
                $scope.commonSpecializationsListOptionsText = "SHOW ALL";
            }
        }

        function getCommonSpecializations() {
            commonSpec = [];
            return datacontext.cacheservice.getCommonSpecializations().then(function (data) {
                for (var i = 0; i < data.length; i++) {
                    commonSpec.push({ key: data[i].value, value: data[i].displayText, Type: "Specialization" });
                }
                vm.commonSpecializations = commonSpec;

                return vm.commonSpecializations;

            });
        }

        function doctorSpecializationList() {
            //return datacontext.cacheservice.getDropDownValues('DoctorSpecialization').then(function (data) {
            //    var commonDropDownListSpecialization = [];
            //    //vm.selectedSpecializationId = data[0].value;
            //    //vm.selectedSpecializationName = data[0].displayText;
            //    for (var i = 0; i < data.length; i++)
            //    {
            //        commonDropDownListSpecialization.push({ key: data[i].value, value: data[i].displayText, Type: "Specialization" });
            //    }
            //    return vm.commonDropDownList = commonDropDownListSpecialization;
            //});

            return datacontext.cacheservice.getDropDownValues('DoctorSpecialization').then(function (data) {
              //  vm.selectedSpecializationName = "";
               // vm.selectedSpecializationId = 0;
                for (var i = 0; i < data.length; i++) {
                    commonDropdowntwoListSpec.push({ key: data[i].value, value: data[i].displayText, Type: "Specialization" });
                }

                vm.commonDropDownTwoList = commonDropdowntwoListSpec;
                //console.log(vm.commonDropDownTwoList);
               // if (!IsLowEndPhone) { $('#common-Drop-Down-Two-modal').modal('show'); }
                return vm.commonDropDownTwoList;
            });

        }
        //vm.commonDropDownOption = function (dropdownList) {
        //    $('#common-drop-down-modal').modal('hide');
        //    if (dropdownList.Type == "Specialization") {
        //        //searchCriteria
        //        searchCriteria.specializationId = dropdownList.key;
        //        searchCriteria.specializationName = dropdownList.value;
        //        //vm.genericSpecializationContainer.key = dropdownList.key;
        //        //vm.genericSpecializationContainer.value = dropdownList.value;
        //        //datarepo.commonrepo.saveSpecializationDetails(vm.genericSpecializationContainer);
        //        $location.path('/specify_your_doctor');
        //    }
        //}

    }
})();