﻿(function () {
    'use strict';
    var controllerId = 'facebooklogin';
    angular.module('app').controller(controllerId, ['common', 'datacontext', '$scope', '$location', '$rootScope','datarepo', facebooklogin]);

    function facebooklogin(common, datacontext, $scope, $location, $rootScope, datarepo) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'Facebook Login';

        vm.selectedFbGenderName = "";
        vm.selectedFbGenderId = "";
        vm.selectedFbCategorytName = "";
        vm.selectedFbCategorytId = "";
        vm.selectedFbDob = "";
        vm.selectedFbContactNo = "";
        vm.selectedFbEmail = "";
        var conBasicProfile = {
            DateOfBirth: '',
            Sex: '',
            FirstName: '',
            Contact: '',
            PatientBasicInfoID:''

        }

        var FbDeatils;
        var FbUserDeatils;
        FbDeatils = datarepo.commonrepo.getFacebookDeatils();

        FbUserDeatils = datarepo.commonrepo.getFacebookUserDetails();

        conBasicProfile.PatientBasicInfoID = FbUserDeatils.consumer.consumerBasicInfo.patientBasicInfoID;
       
        if (FbDeatils.fbBirthday != "") {
        vm.selectedFbDob = moment(FbDeatils.fbBirthday).format("DD MMM, YYYY");
        }

        vm.selectedFbEmail = FbDeatils.fbEmail;
        vm.selectedFbContactNo = "";

        conBasicProfile.FirstName = FbDeatils.fbName;
        if (FbDeatils.fbGender == "male") {
            vm.selectedFbGenderName = "Male ( Tap here to choose )";
            vm.selectedFbGenderId = 100;
        }
        else if (FbDeatils.fbGender == "female") {
            vm.selectedFbGenderName = "Female ( Tap here to choose )";
            vm.selectedFbGenderId = 101;
        }
        else {
            vm.selectedFbGenderName = "NA ( Tap here to choose )";
            vm.selectedFbGenderId = 102;
        }

        if (FbDeatils.fbRelationship == "Single") {
            vm.selectedFbCategorytId = 5294;
            vm.selectedFbCategorytName = "Single ( Tap here to choose )";
        }
        else if (FbDeatils.fbRelationship == "Married") {
            vm.selectedFbCategorytId = 5295;
            vm.selectedFbCategorytName = "Married ( Tap here to choose )";
        }
        else {
            vm.selectedFbCategorytId = 0;
            vm.selectedFbCategorytName = "";
        }

        activate();

       
        function activate() {
            var promises = [userCategoryList(), userGenderList()];
            common.activateController(promises, controllerId);
            //.then(function () { log('Activated Tell Us More View'); });
        }
        vm.redirectToHome = function () {
            $location.path("/");
        }
        vm.proceedForFbDoctorSetup = function () {
            //alert(vm.selectedGenderId+" " +vm.selectedCategorytId);
            if (vm.selectedFbDob == "" || vm.selectedFbGenderName == "" || vm.selectedFbCategorytName == "" || vm.selectedFbContactNo == "" || vm.selectedFbEmail == "") {
                logError("Please fill up all the fields", '', true);
            }
            //else if (vm.selectedFbDob == "") {
            //    logError("Please enter your date of birth", '', true);
            //}
            //else if (vm.selectedFbGenderName == "") {
            //    logError("Please choose your gender ", '', true);
            //}
            //else if (vm.selectedFbCategorytName == "") {
            //    logError("Please choose your relationship ", '', true);
            //}
            //else if (vm.selectedFbContactNo == "") {
            //    logError("Please enter your phone number ", '', true);
            //}
            else {
                datacontext.registration.saveUserDetails(vm.selectedFbGenderId, vm.selectedFbCategorytId);
                conBasicProfile.DateOfBirth = vm.selectedFbDob;
                conBasicProfile.Sex = vm.selectedFbGenderId;
                conBasicProfile.Contact = vm.selectedFbContactNo;
               // conBasicProfile. =vm.selectedFbEmail;
                datacontext.registration.updateUserDetails(conBasicProfile).then(function (response) {
                    logSuccess(response.message, '', true);
                    $location.path("/choose_your_doctor");
                }, function (response) {
                    logError(response.message, '', true);
                });

                
            }
        }
        vm.openGenderModal = function () {
            userGenderList();
            vm.commonDropDownHeader = "Choose Gender";
            vm.commonDropDownFilterDisplay = false;
            vm.commonDropDownFilteredValue = "";
            vm.commonDropDownPlaceHoldertext = "Filter Gender";
            $('#common-drop-down-modal').modal('show');
        }
        function userGenderList() {
            return datacontext.cacheservice.getDropDownValues('Sex').then(function (data) {
                var commonDropDownListGender = [];
                //vm.selectedGenderName = "Choose your gender : "+data[0].displayText;
                vm.selectedGenderId = data[0].value;
                for (var i = 0; i < data.length; i++) {
                    commonDropDownListGender.push({ key: data[i].value, value: data[i].displayText, Type: "Gender" });
                }
                return vm.commonDropDownList = commonDropDownListGender;
            });
        }
        vm.openCategoryModal = function () {
            userCategoryList();
            vm.commonDropDownHeader = "Choose Your Category";
            vm.commonDropDownFilterDisplay = false;
            vm.commonDropDownFilteredValue = "";
            vm.commonDropDownPlaceHoldertext = "Fiter Category";
            $('#common-drop-down-modal').modal('show');
        }
        function userCategoryList() {
            return datacontext.cacheservice.getDropDownValues('Marital Status').then(function (data) {
                var commonDropDownListCategory = [];
                //vm.selectedCategorytName = "Choose your category : "+data[0].displayText;
                vm.selectedCategorytId = data[0].value;
                for (var i = 0; i < data.length; i++) {
                    commonDropDownListCategory.push({ key: data[i].value, value: data[i].displayText, Type: "Category" });
                }
                return vm.commonDropDownList = commonDropDownListCategory;
            });
        }
        vm.commonDropDownOption = function (dropdownList) {
            $('#common-drop-down-modal').modal('hide');
            if (dropdownList.Type == "Gender") {
                vm.selectedFbGenderId = dropdownList.key;
                vm.selectedFbGenderName = dropdownList.value;
            }
            else {
                vm.selectedFbCategorytId = dropdownList.key;
                vm.selectedFbCategorytName = dropdownList.value;
            }
        }
    }
})();