﻿(function () {
    'use strict';
    var controllerId = 'forgotpassword';
    angular.module('app').controller(controllerId, ['common', 'datacontext', 'datarepo', '$scope', '$location', '$rootScope', forgotpassword]);

    function forgotpassword(common, datacontext, datarepo, $scope, $location, $rootScope) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'Forgotten password setup';
        vm.forgotpasswordemail = "";
        activate();

        function activate() {
            var promises = [];
            common.activateController(promises, controllerId)
                .then(function () { log('Activated Forgot Password View'); });
        }
        vm.backToRegister = function () {
            $location.path("/registration");
        }
        vm.resetPassword = function () {
            if (vm.forgotpasswordemail == "") {
                logError("Please enter your Email id.", '', true);
            }
            else {
                return datacontext.registration.resetPassword(vm.forgotpasswordemail).then(function (data) {
                    if (response.Success == true) {
                        logSuccess(data.message, '', true);
                        $location.path("/registration");
                    }
                    else {
                        logError(data.message, '', true);
                    }
                });
            }
        }
    }
})();