﻿(function () {
    'use strict';
    var controllerId = 'specifydoctors';
    angular.module('app').controller(controllerId, ['common', 'datacontext', 'datarepo', '$scope', '$location', '$rootScope', 'searchCriteria', specifydoctors]);

    function specifydoctors(common, datacontext, datarepo, $scope, $location, $rootScope, searchCriteria) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'Specify doctors';
        // vm.searchLocation = 'searchNearBy';
        // vm.searchLocationNearBy = true;
        // vm.searchLocationByCity = false;
        //vm.searchResultCity = [];
        // vm.selectedSpecialization = "";
        // vm.defaultCity = "";
        vm.availableCityArea = [];
        vm.specializationInfo = "";
        var searchDoctorParams = { specializationId: "", specializationName: "", cityId: "", cityName: "", cityAreaId: "", cityAreaName: "", doctorId: "", doctorName: "" };
        vm.favouriteDoctors = [];
        vm.commonDropDownFilterDisplay = false;
        vm.commonDropDownFilteredValue = "";
        vm.commonDropDownPlaceHoldertext = "Filter Cities"
        vm.searchCriteria = searchCriteria;

        //var directResult = {
        //    doctorName: '',
        //    doctorLat: '',
        //    doctorLng: '',
        //    //doctorLat: '',
        //    //doctorLng: '',
        //    doctorSpec: '',
        //    doctorLoc: '',
        //    doctorIsAuto: false,
        //    firstTime: false,
        //    searchBy: ''
        //}
        vm.commonDropDownList = [];
        activate();

        function activate() {
            var promises = [getAvailableCities()];
            common.activateController(promises, controllerId);
            //.then(function () { log('Activated Specify Doctors View'); });
        }

        function getAvailableCities() {

            return datacontext.cacheservice.getAvailableCities().then(function (data) {
                var commonDropdownList = [];
                for (var i = 0; i < data[0].citiesAvailable.length; i++) {
                    //x.key = data[i].value;
                    //x.value = data[i].key;
                    //xxz.push(x);
                    commonDropdownList.push({ key: data[0].citiesAvailable[i].demographyCode, value: data[0].citiesAvailable[i].demographyName });
                }
                searchCriteria.cityId = data[0].citiesAvailable[0].demographyCode;
                searchCriteria.cityName = data[0].citiesAvailable[0].demographyName;
                //vm.selectedDemographyCode = data[0].citiesAvailable[0].demographyCode;
                //vm.selectedDemographyName = data[0].citiesAvailable[0].demographyName;
                return vm.commonDropDownList = commonDropdownList
                //return vm.availableCities = data[0].citiesAvailable;
            });
        }


        vm.getDoctors = function (searchTerm) {

            return datacontext.search.getSearchedDoctors(searchTerm).then(function (result) {
                return result;
            });
        }

        vm.changeCity = function () {
            vm.commonDropDownHeader = "Choose Your City"
            $('#common-drop-down-modal').modal('show');

        }
        vm.commonDropDownOption = function (cmnList) {
            $('#common-drop-down-modal').modal('hide');
            searchCriteria.cityId = cmnList.key;
            searchCriteria.cityName = cmnList.value;
            //vm.selectedDemographyCode = cmnList.key;
            //vm.selectedDemographyName = cmnList.value;
        }
        //doctorCity, doctorSearch
        vm.addMoreDoctors = function () {

            //if (vm.searchCriteria.cityName == "" || vm.searchCriteria.doctorName == "") {
              //  logError('Please fill all the fields', '', true);
            //}
           // else {
                searchCriteria.isAutocomplete = false;
                //if (searchCriteria.doctorName != '') {
                //    searchCriteria.doctorName = searchCriteria.doctorName.value;
                //}
                // searchDoctorParams.doctorName = $("#specialistAutocompleteRes").val();
                // searchDoctorParams.doctorLoc = vm.selectedDemographyCode;
                // var autocompleteResult = datarepo.commonrepo.getAutocompleteResult();
                //autocompleteResult.doctorName = $("#specialistAutocompleteRes").val(); //done
                //  autocompleteResult.doctorLoc = vm.selectedDemographyCode;  //done
                // autocompleteResult.specializationName = searchDoctorParams.specializationName;
                // autocompleteResult.specializationId = searchDoctorParams.specializationId;
                // autocompleteResult.doctorIsAuto = false;
                //  autocompleteResult.pageindex = 0;
                //  autocompleteResult.doctorLat = "";
                //  autocompleteResult.doctorLng = "";
                //alert(autocompleteResult.doctorName+" "+autocompleteResult.doctorLoc+" "+autocompleteResult.specializationName+" "+autocompleteResult.specializationId);
                //  datarepo.commonrepo.saveAutocompleteResult(autocompleteResult);

                //alert(searchDoctorParams.cityId + " : " + searchDoctorParams.cityName + " , " + searchDoctorParams.specializationId + " : " + searchDoctorParams.specializationName + " , " + searchDoctorParams.cityAreaId + " : " + searchDoctorParams.cityAreaName+" , "+searchDoctorParams.doctorId+" : "+searchDoctorParams.doctorName);
                //datarepo.commonrepo.saveFavouriteListFilterInfo(searchDoctorParams);
                $location.path("/add_doctors");
                //console.log(searchDoctorParams);
           // }
        }

        $scope.selectCallback = function () {

            if (vm.searchCriteria.cityName == "") {
                logError('Please choose a city', '', true);
            }
            else {
                //gaPlugin.trackEvent(nativePluginResultHandler, nativePluginErrorHandler, "Button", "Click", "selectCallback", 1);
                // trackSpecialization();

                //  gaPlugin.trackEvent(nativePluginResultHandler, nativePluginErrorHandler, "Check Member", "Navigation", "true", 1);
                // searchCriteria.isAutocomplete = false;
                searchCriteria.doctorName = searchCriteria.doctorName.value;
                // trackDoctorName();
                searchCriteria.isAutocomplete = true;
                //  searchCriteria.firstTime = false;
                // searchCriteria.pageIndex = 0;
                $location.path("/add_doctors");
                // $('#searchModal').modal('hide');
                // $location.path('/searchResult');
            }
        }
        vm.getSearchedDoctors = function (term, specId) {
            console.log("specId:" + specId);
            if (specId == undefined) {
                specId = 0;
            }
            return datacontext.search.getSearchedDoctors(term, specId).then(function (result) {
                return result;
            });
        }
        vm.getRespectiveCityArea = function (cityId) {
            searchDoctorParams.cityId = cityId;
            searchDoctorParams.cityName = $("#doctorCity option:selected").text();
            return datacontext.registration.getAvailableCityArea(cityId).then(function (result) {
                return vm.availableCityArea = result;
            });
        }
        vm.addCityAreaInfo = function (cityAreaName) {
            var index = searchStringInArray(cityAreaName, vm.availableCityArea);
            var cityAreaId = vm.availableCityArea[index].cityAreaID;
            searchDoctorParams.cityAreaId = cityAreaId;
            searchDoctorParams.cityAreaName = cityAreaName;
        }
        vm.addSpecialistInfo = function (specialistName) {
            //alert(specialistName.value);
        }
        function searchStringInArray(str, strArray) {
            for (var j = 0; j < strArray.length; j++) {
                if (strArray[j].cityAreaName.match(str))
                    return j;
            }
            return -1;
        }
        //function getDoctorsList() {
        //    //return datacontext.appointment.getDoctorsInfo(doctorname).then(function (result) {
        //    //    alert("lkdjfkldjf");
        //    //        vm.doctorsInfo = result;
        //    //        return vm.doctorsInfo;
        //    //    });
        //}
        function getFavouriteDoctors() {
            return datacontext.registration.getFavouriteDoctors().then(function (data) {
                return vm.favouriteDoctors = data;
            });
        }
    }
})();