﻿(function () {
    'use strict';
    var controllerId = 'tellusmore';
    angular.module('app').controller(controllerId, ['common', 'datacontext', '$scope', '$location', '$rootScope', 'datarepo', 'registeredUserInfo', tellusmore]);

    function tellusmore(common, datacontext, $scope, $location, $rootScope, datarepo, registeredUserInfo) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'Tell us more';
        vm.selectedGenderName = "";
        vm.selectedGenderId = "";
        vm.selectedCategorytName = "";
        vm.selectedCategorytId = "";

        //Common modal configuration
        vm.commonDropDownTwoFilterDisplay = false;
        vm.hideCommonSpecializations = true;



        //var conBasicProfile = {          
        //    Sex: '',
        //    FirstName: '',           
        //    PatientBasicInfoID: ''

        //}


        //var kare4uuserdata = datarepo.commonrepo.getKare4uRegisterdUserDetails();
        //conBasicProfile.PatientBasicInfoID = kare4uuserdata.consumer.consumerBasicInfo.patientBasicInfoID;

        activate();

        function activate() {
            var promises = [userCategoryList(), userGenderList()];
            common.activateController(promises, controllerId);
            //.then(function () { log('Activated Tell Us More View'); });
        }
        vm.redirectToHome = function () {
            $location.path("/");
        }
        vm.proceedForDoctorSetup = function () {
            if (vm.selectedGenderName == "" || vm.selectedCategorytName == "") {
                logError('Please fill all the fields', '', true);
            }
            else {
                //alert(vm.selectedGenderId+" " +vm.selectedCategorytId);
                datacontext.registration.saveUserDetails(vm.selectedGenderId, vm.selectedCategorytId);
                //conBasicProfile.Sex = vm.selectedGenderId;
                // $location.path("/choose_your_doctor");

                registeredUserInfo.Sex = vm.selectedGenderId;
                datacontext.registration.updatekare4uUserDetails(registeredUserInfo).then(function (response) {
                    logSuccess(response.message, '', true);
                    $location.path("/choose_your_doctor");
                }, function (response) {
                    logError(response.message, '', true);
                });
            }
            //$location.path("/choose_your_doctor");
        }
        vm.openGenderModal = function () {
            userGenderList();
            vm.commonDropDownHeader = "Choose Gender";
            vm.commonDropDownFilterDisplay = false;
            vm.commonDropDownFilteredValue = "";
            vm.commonDropDownPlaceHoldertext = "Filter Gender";
            $('#common-drop-down-modal').modal('show');
        }
        function userGenderList() {
            return datacontext.cacheservice.getDropDownValues('Sex').then(function (data) {
                var commonDropDownListGender = [];
                //vm.selectedGenderName = "Choose your gender : "+data[0].displayText;
                vm.selectedGenderId = data[0].value;
                for (var i = 0; i < data.length; i++) {
                    commonDropDownListGender.push({ key: data[i].value, value: data[i].displayText, Type: "Gender" });
                }
                return vm.commonDropDownList = commonDropDownListGender;
            });
        }
        vm.openCategoryModal = function () {
            userCategoryList();
            //vm.commonDropDownTwoHeader = "Choose Your Category";
            //vm.commonDropDownTwoFilterDisplay = false;
            //vm.commonDropDownTwoFilteredValue = "";
            //vm.commonDropDownTwoPlaceHoldertext = "Fiter Category";
            $('#choose-category-modal').modal('show');
        }
        function userCategoryList() {
            return datacontext.cacheservice.getDropDownValues('Marital Status').then(function (data) {
                var commonDropDownListCategory = [];
                //vm.selectedCategorytName = "Choose your category : "+data[0].displayText;
                vm.selectedCategorytId = data[0].value;
                for (var i = 0; i < data.length; i++) {
                    commonDropDownListCategory.push({ key: data[i].value, value: data[i].displayText, Type: "Category" });
                }
                return vm.commonDropDownTwoList = commonDropDownListCategory;
            });
        }
        vm.commonDropDownOption = function (dropdownList) {
            $('#common-drop-down-modal').modal('hide');

            vm.selectedGenderId = dropdownList.key;
            vm.selectedGenderName = dropdownList.value;


        }
        vm.commonDropDownTwoOption = function (selectedCategory) {
            $('#choose-category-modal').modal('hide');
            vm.selectedCategorytId = selectedCategory.key;
            vm.selectedCategorytName = selectedCategory.value;

        }
    }
})();