﻿
(function () {
    'use strict';
    var controllerId = 'search';
    angular.module('app').controller(controllerId, ['common', 'datacontext', 'datarepo', '$scope', '$location', '$rootScope', 'searchCriteria', 'phonegapFeatures', search]);

    function search(common, datacontext, datarepo, $scope, $location, $rootScope, searchCriteria, phonegapFeatures) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var vm = this;
        vm.hideDropdown = true;
        vm.title = 'Search';
        vm.localityshow = false;
        vm.commonDropDownFilterDisplay = false;
        vm.commonDropDownFilteredValue = "";
        vm.commonDropDownPlaceHoldertext = "";
        var commonDropdowntwoListSpec = [];
        var currentLocation = '';
        vm.searchCriteria = searchCriteria;
        vm.commonSpecializations = [];
        var commonSpec = [];
        
        var gaPlugin;
        vm.doctorSpecialization = [];
        vm.availableCities = [];
        var gaPlugin;

        $scope.flag=false;
        $scope.commonSpecializationsListOptionsText = "SHOW ALL";
        $scope.showAll = false;

        $scope.toggleAll = function () {
            $scope.showAll = !$scope.showAll;
            if ($scope.flag == false) {
                getDoctorSpecialization();
            }
            $scope.flag = true;
            if ($scope.commonSpecializationsListOptionsText == "SHOW ALL") {
                $scope.commonSpecializationsListOptionsText = "HIDE ALL";
            }
            else if ($scope.commonSpecializationsListOptionsText == "HIDE ALL") {
                $scope.commonSpecializationsListOptionsText = "SHOW ALL";
            }
        }

        function getGeoLoaction() {
            //If running local
            if (!window.cordova) {
                searchCriteria.lattitude = 20.3261287;
                searchCriteria.longitude = 85.8192468;
                searchCriteria.locationAvailable = true;
                getLocationInfo();
            }
            document.addEventListener("deviceready", onDeviceReady, false);
        }
        function onDeviceReady() {

            navigator.geolocation.getCurrentPosition(onSuccess, onError);
            gaPlugin = window.plugins.gaPlugin;
            //gaPlugin.init(nativePluginResultHandler, nativePluginErrorHandler, "UA-33654876-5", 10);
            gaPlugin.init(nativePluginResultHandler, nativePluginErrorHandler, "UA-33654876-5", 10);//production
           // gaPlugin.init(nativePluginResultHandler, nativePluginErrorHandler, "UA-49305907-1", 10);//susanta
            
            // gaPlugin = window.plugins.gaPlugin;
            // gaPlugin.init(nativePluginResultHandler, nativePluginErrorHandler, "UA-49305907-1", 10);
        }
        
        function onSuccess(position) {
            $rootScope.isBusy = true;
            var currLatitude = position.coords.latitude;
            var currLongitude = position.coords.longitude;
            searchCriteria.locationAvailable = true;
            //Performance check
            //If the existing locations are same, no need to retrieve
            if (currLatitude == searchCriteria.lattitude && currLongitude == searchCriteria.longitude) {
                //do nothing
            }
            else {
                searchCriteria.lattitude = position.coords.latitude;
                searchCriteria.longitude = position.coords.longitude;
                getLocationInfo();
            }
            $rootScope.isBusy = false;

        }

        function onError(error) {

            searchCriteria.lattitude = '';
            searchCriteria.longitude = '';
            searchCriteria.locationAvailable = false;
            if (searchCriteria.cityId == 0) {
                //So we are going to get the first result
                getAvailableCities().then(function (data) {
                    searchCriteria.cityId = data[0].key;
                    searchCriteria.cityName = data[0].value;
                })
                currentLocation = 'Current Location Unavailable';

                return;
            }


            var errcodeStatusTemp = datarepo.commonrepo.getStatusOfErrorCode();
            if (!errcodeStatusTemp) {
                datarepo.commonrepo.setStatusOfErrorCode(true);
                // alert(error.message);
                alert("Location service is disabled. Please turn it on to get a better experience.");
            }

        }

        function getLocationInfo() {

            return datacontext.search.getExactGeolocation(searchCriteria.lattitude, searchCriteria.longitude).then(function (data) {
                console.log(data);
                for (var i = 0 ; i < data.results[0].address_components.length; i++) {
                    if (data.results[0].address_components[i].types[0] == "route") {

                        currentLocation = data.results[0].address_components[i].long_name;
                        //searchCriteria.cityName = data.results[0].address_components[i].long_name;

                    }
                    if (data.results[0].address_components[i].types[0] == "locality" && data.results[0].address_components[i].types[1] == "political") {
                        currentLocation = currentLocation + ', ' + data.results[0].address_components[i].long_name;
                        //searchCriteria.cityName = searchCriteria.cityName + ', ' + data.results[0].address_components[i].long_name;
                    }
                }

                //If a city was selected then leave else set the current location
                if (searchCriteria.cityId == 0) {
                    searchCriteria.cityName = currentLocation;
                }

            });

        }

        

        $scope.openSpecializationModal = function () {
            getCommonSpecializations();
            vm.commonDropDownTwoHeader = "Choose Specialization";
            vm.commonDropDownTwoFilterDisplay = true;
            vm.commonDropDownTwoFilteredValue = "";
            vm.commonDropDownTwoPlaceHoldertext = "Filter Specialization";
            $('#common-Drop-Down-Two-modal').modal('show');
        }
        vm.clearinput = function (){
            searchCriteria.specializationName = '';
            searchCriteria.specializationId = '';
            $('#common-Drop-Down-Two-modal').modal('hide');
        }

        $scope.openCityModal = function () {
            getAvailableCities();
            vm.commonDropDownHeader = "Choose City";
            vm.commonDropDownFilterDisplay = false;
            vm.commonDropDownFilteredValue = "";
            vm.commonDropDownPlaceHoldertext = "Fiter City";

        }

        vm.commonDropDownOption = function (cityList) {
            $('#common-drop-down-modal').modal('hide');
            searchCriteria.cityId = cityList.key;
            searchCriteria.cityName = cityList.value;

        }

        vm.commonDropDownTwoOption = function (specializationList) {
            $('#common-Drop-Down-Two-modal').modal('hide');
            vm.hideDropdown = true;
            searchCriteria.specializationName = specializationList.value;
            searchCriteria.specializationId = specializationList.key;
        }

        vm.getSearchedDoctors = function (searchTerm) {

            return datacontext.search.getSearchedDoctors(searchTerm).then(function (result) {
                return result;
            });
        }
        function nativePluginResultHandler(result) {
          
            //alert('nativePluginResultHandler - '+result);
           // console.log('nativePluginResultHandler: ' + result);

        }

        function nativePluginErrorHandler(error) {
           
            //alert('nativePluginErrorHandler - '+error);
            //console.log('nativePluginErrorHandler: ' + error);
        }

        function trackSpecialization(searchedDoctorname) {
          
            //alert(searchCriteria.specializationName);
            if (window.cordova) {
                //alert(searchCriteria.specializationName);
                // if (searchCriteria.specializationId != 0 && searchCriteria) {
 
                gaPlugin.trackEvent(nativePluginResultHandler, nativePluginErrorHandler, "Search Doctors", "Click Search", searchCriteria.cityName + ' , ' + searchCriteria.specializationName + ' , ' + searchedDoctorname, 2);
               // }
             }
        }
        function trackDoctorName() {
            if (window.cordova) {
                if (searchCriteria.doctorName != '') {
                    gaPlugin.trackEvent(nativePluginResultHandler, nativePluginErrorHandler, "Doctorname", "Search", searchCriteria.doctorName, 1);
                }
            }
        }
        $scope.selectCallback = function () {
            //gaPlugin.trackEvent(nativePluginResultHandler, nativePluginErrorHandler, "Button", "Click", "selectCallback", 1);
            trackSpecialization(searchCriteria.doctorName.value);
            
          //  gaPlugin.trackEvent(nativePluginResultHandler, nativePluginErrorHandler, "Check Member", "Navigation", "true", 1);
            searchCriteria.doctorName = searchCriteria.doctorName.value;
            //trackDoctorName();
            searchCriteria.isAutocomplete = true;
            searchCriteria.firstTime = false;
            searchCriteria.pageIndex = 0;
            $('#searchModal').modal('hide');
            $location.path('/searchResult');
        }

        vm.searchResultPage = function () {
            //gaPlugin.trackEvent(nativePluginResultHandler, nativePluginErrorHandler, "Button", "Click", "searchResultPage", 1);
            trackSpecialization(searchCriteria.doctorName);
           // trackDoctorName();
            searchCriteria.isAutocomplete = false;
            searchCriteria.firstTime = false;
            searchCriteria.pageIndex = 0;
            //console.log(vm.selectedSpecialization.value);
            $location.path('/searchResult');

        }

        function getCommonSpecializations() {
            commonSpec = [];
            return datacontext.cacheservice.getCommonSpecializations().then(function (data) {
                for (var i = 0; i < data.length; i++) {
                    commonSpec.push({ key: data[i].value, value: data[i].displayText, Type: "Specialization" });
                }
                vm.commonSpecializations = commonSpec;
               
                return vm.commonSpecializations;

            });
        }

        function getDoctorSpecialization() {
            return datacontext.cacheservice.getDropDownValues('DoctorSpecialization').then(function (data) {
                vm.selectedSpecializationName = "";
                vm.selectedSpecializationId = 0;
                for (var i = 0; i < data.length; i++) {
                    commonDropdowntwoListSpec.push({ key: data[i].value, value: data[i].displayText, Type: "Specialization" });
                }

                vm.commonDropDownTwoList = commonDropdowntwoListSpec;
                //console.log(vm.commonDropDownTwoList);
                if (!IsLowEndPhone) { $('#common-Drop-Down-Two-modal').modal('show'); }
                return vm.commonDropDownTwoList;
            });

        }

        function getAvailableCities() {
            return datacontext.cacheservice.getAvailableCities().then(function (data) {
                vm.selectedDemographyId = 0;

                var commonDropdownListCity = [];

                if (searchCriteria.locationAvailable == true) {
                    //commonDropdownListCity.push({ key: 0, value: 'Current Location(' + currentLocation + ')', Type: "City" });
                    commonDropdownListCity.push({ key: 0, value: currentLocation + '(Current Location)', Type: "City" });
                }
                else {
                    commonDropdownListCity = [];
                }
                for (var i = 0; i < data[0].citiesAvailable.length; i++) {
                    commonDropdownListCity.push({ key: data[0].citiesAvailable[i].demographyCode, value: data[0].citiesAvailable[i].demographyName, Type: "City" });
                }
                vm.commonDropDownList = commonDropdownListCity;
                $('#common-drop-down-modal').modal('show');

                return vm.commonDropDownList;

            });
        }

        //vm.selectedSpecialization = '';

        //vm.saveSelectedSpecialization = function (selectedSpecialization)
        //{
        //searchCriteria.specializationId = selectedSpecialization.key;
        //searchCriteria.specializationName = selectedSpecialization.value;
        ////alert(searchCriteria.specializationId +" "+ searchCriteria.specializationName)
        //}
        
        
        activate();

        function activate() {
            var promises = [getGeoLoaction(),getDoctorSpecialization()];
            common.activateController(promises, controllerId);
        }

    }
})();

