﻿(function () {
    'use strict';
    var controllerId = 'searchResult';
    angular.module('app').controller(controllerId, ['common', '$scope', 'datarepo', '$rootScope', '$location', 'datacontext','Reddit','searchCriteria', searchResult]);

    function searchResult(common, $scope, datarepo, $rootScope, $location, datacontext, Reddit, searchCriteria) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        var vm = this;
        vm.title = 'Search Result';
        vm.doctorsInfo = []; 
        var date = new Date();
        var date = date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
        vm.slotdate = date;
        vm.ProviderId = '';
        vm.noSchduleAvail = false;
        vm.searchCriteria = searchCriteria;
        $scope.selectedDoctorName = '';
        $scope.doctorAvgRate = 3;
        $scope.doctorUserRate = 0;
        $scope.max = 5;
        vm.suggestDoc = true;
        var pageindex = 0;
        $scope.searchresult = [];
        vm.suggestDoctor = false;
        // vm.whysuggest = false;
        vm.checkedicon = true;
        vm.busyapp = false;
        var scrolling = true;
        $scope.locationFilterActive=false;
        $scope.specializationFilterActive = false;
        var LatLong;
        vm.myRating = 0;
        vm.max = 5;
        vm.hospital = '';
        vm.spec = '';
        //var directionDisplay,
        //        directionsService = new google.maps.DirectionsService(),
        //        map;
 
        var myCenter = new google.maps.LatLng(0, 0);
        var marker = new google.maps.Marker({
            position: myCenter
        });
        vm.searchedResult = {
            location: '',
            locationStatus: '',
            specialization: '',
            specializationstatus: '',
            doctorname: '',
            doctornameStatus: ''
        }
        
        var Reddit = function () {
            this.items = [];
            this.busy = false;
            this.after = '';
        };
        vm.rateDoctorName = "";

        //Ratings configuration
        vm.openRatingModal = function () {
            $('#doctorRatingModal').modal('show');
        }
        vm.closeRatingModal = function () {
            vm.myRating = 0;
            $('#doctorRatingModal').modal('hide');
        }

       
        vm.saveRating = function () {
            return datacontext.appointment.saveMyFavouriteDoctorRating($scope.selectedDoctorID, vm.myRating).then(function (response) {
                vm.myRating = 0;
                logSuccess("Rating successfully added", '', true);
                $('#doctorRatingModal').modal('hide');
                searchCriteria.pageIndex = 0;
                scrolling = true;
                getSearchResult();
            }, function (response) {
                logError(response.message, '', true);
                $('#doctorRatingModal').modal('hide');
                vm.myRating = 0;
            });
        }
        //Rating cofiguration ends


        function getSearchResult() {
            //alert("scrolling"+scrolling);
            //alert("vm.busyapp" + vm.busyapp);
            if (scrolling) {
                if (vm.busyapp) return;
                vm.busyapp = true;
                vm.whysuggest = false;
                //  var autocompletedata = datarepo.commonrepo.getAutocompleteResult();
                return datacontext.appointment.getDoctorsInfo().then(function (result) {
                    if (result[0].providerSearchDetails.length == 0) {
                        vm.suggestDoctor = false;
                    }
                    else {
                        vm.suggestDoctor = true;
                    }
                    //return datacontext.appointment.getDoctorsInfo(autocompletedata).then(function (result) {
                    if (result[0].isLastRecord) {
                       
                        scrolling = false;
                    }
                    else {
                       // vm.suggestDoctor = false;
                        scrolling = true;
                    }

                    $scope.firsttime = false;
                    searchCriteria.pageIndex = searchCriteria.pageIndex + 10;
                    // autocompletedata.pageindex = pageindex;
                    // datarepo.commonrepo.saveAutocompleteResult(autocompletedata);
                    vm.busyapp = false;
                    vm.suggestDoc = false;
                    vm.whysuggest = true;
                    $scope.reddit.items.push(result[0]);
                    return vm.doctorsInfo = result;
                });
            }
        }

        Reddit.prototype.nextPage = function () {
            getSearchResult();



        };

        $('#googlemap').on('show.bs.modal', function (e) {

        })
        $('#googlemap').on('shown.bs.modal', function (e) {
            // do something...
            myCenter = new google.maps.LatLng(LatLong.hospitalLatitude, LatLong.hospitalLongitude);
            marker = new google.maps.Marker({
                position: myCenter
            });
            initialize();

        })
        vm.navigateToGooglemap = function (pSM) {
            LatLong = pSM;
            vm.googlemapHeadername = pSM.hospitalName + " ("+pSM.hospitalLocation +")";
            $('#googlemap').modal('show');          
        }
        vm.modalclose = function () {
           
            $('#googlemap').modal('hide');
            initialize();
        }

        function initialize() {

             var mapProp = {
                 center: myCenter,
                    zoom: 14,
                    draggable: true,
                    scrollwheel: true,
                    mapTypeId: google.maps.MapTypeId.ROADMAP
                };
                var map = new google.maps.Map(document.getElementById("map-canvas"), mapProp);
                //console.log(mapProp);
                marker.setMap(map);

                google.maps.event.addListener(marker, 'click', function () {

                    infowindow.setContent(contentString);
                    infowindow.open(map, marker);

                });
            
           

            marker = new google.maps.Marker({
                position: myCenter
            });
           
        };


         $scope.navigateBookApp = function (docname, ProviderId) {

          
             datarepo.commonrepo.saveProviderID(ProviderId, docname);

             $location.path('/book_appointment');
        }
      
         $scope.toggleDoctorDetail = function ($index, docinnerInfoTemp) {
             
            $scope.activePosition = $scope.activePosition == $index ? -1 : $index;
            $scope.selectedDoctorID = docinnerInfoTemp.providerID;
            $scope.selectedDoctorName = docinnerInfoTemp.name;
            vm.rateDoctorName = docinnerInfoTemp.name;
            vm.spec = docinnerInfoTemp.doctorSpecialization[0].description;
            vm.hospital = docinnerInfoTemp.providerSchedule[0].hospitalName;



        };

        vm.goToSuggestDoc = function () {
            $location.path('/suggest');
        }
       // vm.sharedModal = function (docinnername, docSpecdescription, docinnerInfoproviderSchedule) {
        vm.sharedModal = function (docinnerInfo) {
            var msg = "";
           
                if (docinnerInfo.providerSchedule.length == 1) {

                    msg = "Dr." + docinnerInfo.name + "( " + docinnerInfo.doctorSpecialization[0].description + " )" + " will be available in " + docinnerInfo.providerSchedule[0].hospitalName + " on " + docinnerInfo.providerSchedule[0].day + " .";
                   // common.shareSocially("Dr." + docinnername + " consults in "
                    //  + docinnerInfoproviderSchedule[0].hospitalName + " on " + docinnerInfoproviderSchedule[0].day + " .");
                    common.shareSocially(msg);
                }
                else {
                    for (var i = 0; i < docinnerInfo.providerSchedule.length ; i++) {
                       
                        if (docinnerInfo.providerSchedule.length == (i + 1)) {
                            msg = msg + docinnerInfo.providerSchedule[i].hospitalName + " on " + docinnerInfo.providerSchedule[i].day + ".";
                        }
                        else {
                            msg = msg + docinnerInfo.providerSchedule[i].hospitalName + " on " + docinnerInfo.providerSchedule[i].day + " and in ";
                        }
                    }
                   // msg.replace(/ and in \s*$/, "");
                    common.shareSocially("Dr." + docinnerInfo.name + "( " + docinnerInfo.doctorSpecialization[0].description + " )" + " will be available in "+ msg);
                }
           
            
           // common.shareSocially("Dr." + docinnername + " consults in " + docinnerInfoproviderSchedule[0].hospitalName + " on " + docinnerInfoproviderSchedule[0].day + " .")
            //common.shareSocially("Dr." + docinnername + " consults in " + docinnerInfoproviderSchedule[0].hospitalName + " on " + docinnerInfoproviderSchedule[0].day + " .");
        }

        vm.addToFavouriteList = function (favproviderid) {

            var saveToFavourite = {
                specializationID: '',
                specializationName:'',
                providerID: favproviderid,
                providerName: '',
                cityCode: 0,
                city: ''
            };
            console.log(saveToFavourite);
            //return datacontext.registration.saveToFavourites(saveToFavourite).$promise.then(function (data) {
            return datacontext.registration.saveToFavourites(saveToFavourite).then(function (data) {
                if (data.success) {

                    common.gaTrackEvent('Favourite doctor', 'Click Favourite', 'Dr. ' + vm.rateDoctorName + ' ,' + vm.spec + ' ,'+ vm.hospital);
                    logSuccess(data.message, '', true);
                }
                else {
                    logError(data.message, '', true);
                }                       
              //  $location.path("/favouriteDoctors");
                return data;
            });
        }

        vm.locationfiltermodal = function () {
            $("#searchresultmain").addClass("scrollBlock");
            $('#locationfiltermodal').modal('show');
        }
        vm.specfiltermodal = function () {
            $("#searchresultmain").addClass("scrollBlock");
            $('#specfiltermodal').modal('show');
        }
        function resetAndSearch() {
            $("#searchresultmain").removeClass("scrollBlock");
            searchCriteria.pageIndex = 0;
            vm.suggestDoctor = false;
            scrolling = true;
            $scope.reddit.items = [];
            vm.doctorsInfo = [];
            getSearchResult();
        }


        $scope.locationFacetSearch = function ($index, facetvalue) {
            //$scope.checkedicon = $scope.checkedicon == $index ? -1 : $index;
            $scope.locationFilterActive=true;
            searchCriteria.cityAreaFacet = facetvalue.key;
            $('#locationfiltermodal').modal('hide');
            resetAndSearch();
        }
        vm.locationFacetSearchRemove = function () {
            $scope.locationFilterActive = false;
            searchCriteria.cityAreaFacet = '';
            $('#locationfiltermodal').modal('hide');
            resetAndSearch();
            
        }
        vm.specializationFacetSearch = function (specfacetvalue) {
            $scope.specializationFilterActive = true;
            searchCriteria.specialisationFacet = specfacetvalue.key;
            $('#specfiltermodal').modal('hide'); 
            resetAndSearch();
        }
        vm.specializationFacetSearchRemove = function () {
            $scope.specializationFilterActive = false;
            searchCriteria.specialisationFacet = '';
            $('#specfiltermodal').modal('hide');
            resetAndSearch();
        }
        //vm.rateDoctor = function (rating) {
        //    return datacontext.search.saveDoctorRating($scope.selectedDoctorID, rating).then(function (response) {
        //        console.log(response.ProviderOverAllRating.AverageRating);
        //        logSuccess(response.message, '', true);
        //        $('#doctorRatingModal').modal('hide');
        //        getFavouriteDoctors();
        //    }, function (response) {
        //        logError(response.message, '', true);
        //        $('#doctorRatingModal').modal('hide');
        //    });
        //}
        activate();

        function activate() {
            var promises = [getDoctorsInfoForSearchPage()];
            common.activateController(promises, controllerId);
            //.then(function () { log('Search Result View'); });
        }

        function getDoctorsInfoForSearchPage() {
           // var autocompletedata = datarepo.commonrepo.getAutocompleteResult();


            //vm.searchedResult.location = searchCriteria.locationname;
            //vm.searchedResult.locationStatus = searchedResultFromrepo.cityId;
            //vm.searchedResult.specializationstatus = searchCriteria.specializationId;
            //vm.searchedResult.specialization = searchCriteria.specializationName;
            //vm.searchedResult.doctorname = searchCriteria.doctorName;

          //  autocompletedata.pageindex = 0;
          
            //  datarepo.commonrepo.saveAutocompleteResult(autocompletedata);
            searchCriteria.pageIndex = 0;
            searchCriteria.cityAreaFacet = '';
            searchCriteria.specialisationFacet = '';
          
           $scope.reddit = new Reddit();
        }

    }
})();