﻿/// <reference path="../search/Templates/map.html" />
var currentLocation;
var currentAddress;
(function () {
    'use strict';

    var app = angular.module('app');

    'use strict';

    app.directive('itemSwipe', ['$swipe', '$document', '$window', '$timeout',
        function ($swipe, $document, $window, $timeout) {
            return {
                transclude: true,
                template: '<div style="position: relative">'
                            +
                            '<div class="blueMidColor appointment-card swiper" ng-style="swiperStyle" ng-transclude style="position: relative"></div>'
                            +
                          '</div>',
                link: {
                    post: function (scope, iElement, iAttrs, controller) {
                        var startCoords, threeD, $swiper;
                        $swiper = angular.element('.swiper', iElement);
                        scope.proceed = false;

                        function fullSwipe(coords) {
                            return coords.x - startCoords.x > $swiper.width() * (1 / 3) ? true : false;
                        }

                        function cssPrefix(property, value) {
                            var vendors = ['', '-o-', '-moz-', '-ms-', '-khtml-', '-webkit-'];
                            var styles = {};
                            for (var i = vendors.length - 1; i >= 0; i--) {
                                styles[vendors[i] + property] = value;
                            }
                            return styles;
                        }

                        function updateElementPosition(pos) {
                            if ('threeD' in iAttrs) {
                                $swiper.css(cssPrefix('transform', 'translate(' + pos + 'px)'));
                            }
                        }

                        scope.$watch('proceed', function (val) {
                            if (val) {
                                scope.eliminateItem = $timeout(function () {
                                    scope.proceed = false;
                                    return scope.$eval(iAttrs.onRemove);
                                }, 1220);
                            } else {
                                $timeout.cancel(scope.eliminateItem);
                                updateElementPosition(0);
                            }
                        });

                        $swipe.bind($swiper, {
                            'start': function (coords) {
                                startCoords = coords;
                                scope.swiperStyle = { opacity: 0.8 };
                                scope.$apply();
                            },
                            'cancel': function () {

                                scope.swiperStyle = cssPrefix('transition', 'all 0.2s ease-in-out');
                                scope.swiperStyle.opacity = 1;
                                scope.$apply();
                            },
                            'move': function (coords) {
                                updateElementPosition(coords.x - startCoords.x);
                            },
                            'end': function (endCoords) {
                                if (fullSwipe(endCoords)) {
                                    scope.proceed = true;
                                    updateElementPosition($document.width());
                                } else {
                                    scope.proceed = false;
                                    updateElementPosition(0);
                                }
                                scope.swiperStyle = cssPrefix('transition', 'all 0.2s ease-in-out');
                                scope.swiperStyle.opacity = 1;
                                scope.$apply();
                            }
                        });
                    }
                }
            };
        }]);

    app.directive('jquerySelectList', function ($compile) {
        return {
            restrict: "A",
            link: function (scope, element, attrs, controller) {
                element.customStyle();
            },
            scope: {}
        };
    });


    //app.directive('jquerySelectListCategory', function ($compile) {
    //    return {
    //        restrict: "A",
    //        link: function (scope, element, attrs, controller) {
    //            element.customStyleCategory();
    //        },
    //        scope: {}
    //    };
    //});
    //app.directive('jquerySelectSpecialization', function ($compile) {
    //    return {
    //        restrict: "A",
    //        link: function (scope, element, attrs, controller) {
    //            element.customStyleSpecialization();
    //        },
    //        scope: {}
    //    };
    //});
    //app.directive('jquerySelectFamily', function ($compile) {
    //    return {
    //        restrict: "A",
    //        link: function (scope, element, attrs, controller) {
    //            element.customStyleFamily();
    //        },
    //        scope: {}
    //    };
    //});
    //app.directive('jqueryDatePicker', function () {
    //    return {
    //        restrict: "A",
    //        link: function (scope, element, attrs, controller) {
    //           // var currdate = element.val() == "" ? new Date() : element.val();
    //            element.datepicker({
    //                changeMonth: true,
    //                changeYear: true,
    //                yearRange: "-100:+0",
    //                maxDate: "0D"
    //              //  dateFormat: moment(currdate).format('Do MMM YYYY')

    //            });
    //        }
    //    }
    //});
    app.directive('jqueryDatePicker', function () {
        return {
            restrict: 'AE',
            require: 'ngModel',
            link: function (scope, element, attrs, ngModelCtrl) {
                //$(function () {
                //    if (!common.isPhoneGap()) {
                //        alert("ssdf");
                //        element.datepicker({
                //            dateFormat: 'd M, yy',
                //            onSelect: function (date) {
                //                scope.$apply(function () {
                //                    ngModelCtrl.$setViewValue(date);
                //                });
                //            },
                //            changeMonth: true,
                //            changeYear: true,
                //            yearRange: "-100:+0",
                //            maxDate: "0D"
                //        });
                //    }
                //    else {
                //        alert("date");
                //        element.click(function (e) {
                //            var options = {
                //                date: new Date(),
                //                mode: 'date'
                //            };
                //            datePicker.show(options, function (date) {
                //                alert("date" + date);
                //                scope.$apply(function () {
                //                    alert("date" + date);
                //                    angular.element(element).val(moment(date).format("DD MMM, YYYY"));
                //                    ngModelCtrl.$setViewValue(moment(date).format("DD MMM, YYYY"));
                //                });
                //            });
                //        });
                //    }
                //});
                $(function () {
                    if (!window.cordova) {
                        element.datepicker({
                            dateFormat: 'd M, yy',
                            onSelect: function (date) {
                                scope.$apply(function () {
                                    ngModelCtrl.$setViewValue(date);
                                });
                            },
                            changeMonth: true,
                            changeYear: true,
                            yearRange: "0:+1",
                            minDate: new Date()
                        });
                    }
                    element.click(function (e) {
                        var options;
                        if (angular.element(element).val()!= "") {
                            options = {
                                date: new Date(angular.element(element).val()),
                                mode: 'date'
                            };
                        }
                        else {
                            options = {
                                date: new Date(),
                                mode: 'date'
                            };
                        }
                        datePicker.show(options, function (date) {
                            scope.$apply(function () {
                                angular.element(element).val(moment(date).format("DD MMM, YYYY"));
                                ngModelCtrl.$setViewValue(moment(date).format("DD MMM, YYYY"));
                            });
                        });
                    });
                });
            }
        }
    });


    app.directive('jqueryDynamicDatePicker', ['common', function (common) {
        return {
            restrict: 'AE',
            require: 'ngModel',
            link: function (scope, element, attrs, ngModelCtrl) {
                $(function () {
                    if (!window.cordova) {
                        element.datepicker({
                            dateFormat: 'd M, yy',
                            onSelect: function (date) {
                                scope.$apply(function () {
                                    ngModelCtrl.$setViewValue(date);
                                });
                            },
                            changeMonth: true,
                            changeYear: true,
                            yearRange: "0:+1",
                            minDate: new Date()
                        });
                    }
                    element.click(function (e) {
                        var options;
                        if (angular.element(element).val() != "") {
                            options = {
                                date: new Date(angular.element(element).val()),
                                mode: 'date'
                            };
                        }
                        else {
                            options = {
                                date: new Date(),
                                mode: 'date'
                            };
                        }
                        datePicker.show(options, function (date) {
                            scope.$apply(function () {
                                angular.element(element).val(moment(date).format("DD MMM, YYYY"));
                                ngModelCtrl.$setViewValue(moment(date).format("DD MMM, YYYY"));
                            });
                        });
                    });
                });
            }
        }
    }]);



    //app.directive('regdatepicker', function () {
    //    return {
    //        restrict: 'AE',
    //        //require: 'kare4umodel',
    //        link: function (scope, element, attrs, ngModelCtrl) {
    //            $(function () {
    //                element.datepicker({
    //                    dateFormat: 'd M, yy',
    //                    onSelect: function (date) {
    //                        scope.$apply(function () {
    //                            //ngModelCtrl.$setViewValue(date);
    //                            $("#dOB").val(date);
    //                            //$("#dOB").trigger("change");

    //                            $('#registrationDatePickerModal').modal('hide');
    //                        });
    //                    },
    //                    changeMonth: true,
    //                    changeYear: true,
    //                    yearRange: "-100:+0",
    //                    maxDate: "0D",
    //                    dayNamesMin: ["S", "M", "T", "W", "T", "F", "S"]
    //                });
    //            });
    //        },
    //        scope: {
    //            dpid: "@"
    //        }
    //    }
    //});

    //app.directive('appdatepicker', function () {
    //    return {
    //        restrict: 'AE',
    //        //require: 'ngModel',
    //        link: function (scope, element, attrs, ngModelCtrl) {
    //            //$(function () {
    //            //    element.datepicker({
    //            //        dateFormat: 'd M, yy',
    //            //        onSelect: function (date) {
    //            //            scope.$apply(function () {
    //            //                //ngModelCtrl.$setViewValue(date);
    //            //                $("#dOB").val(date);
    //            //                $('#appDatePickerModal').modal('hide');
    //            //            });
    //            //        },
    //            //        changeMonth: true,
    //            //        changeYear: true,
    //            //        yearRange: "0:+1",
    //            //        dayNamesMin: ["S", "M", "T", "W", "T", "F", "S"]
    //            //    });
    //            //});
    //            $(function () {
    //                if (!common.isPhoneGap()) {
    //                    element.datepicker({
    //                        dateFormat: 'dd M, yy',
    //                        onSelect: function (date) {
    //                            scope.$apply(function () {
    //                                ngModelCtrl.$setViewValue(date);
    //                            });
    //                        },
    //                        changeMonth: true,
    //                        changeYear: true,
    //                        yearRange: "-100:+0",
    //                        maxDate: "0D"
    //                    });
    //                }
    //                else {
    //                    element.click(function (e) {
    //                        var options = {
    //                            date: new Date(),
    //                            mode: 'date'
    //                        };
    //                        datePicker.show(options, function (date) {
    //                            scope.$apply(function () {
    //                                angular.element(element).val(moment(date).format("DD MMM, YYYY"));
    //                                ngModelCtrl.$setViewValue(moment(date).format("DD MMM, YYYY"));
    //                            });
    //                        });
    //                    });
    //                }
    //            });

    //        },
    //        scope: {
    //            dpid: "@"
    //        }
    //    }
    //});


    app.directive('jqueryAppointmentDatePicker', function () {
        return {
            restrict: 'A',
            require: 'ngModel',
            link: function (scope, element, attrs, ngModelCtrl) {
                $(function () {
                    if (!window.cordova) {
                        element.datepicker({
                            dateFormat: 'd M, yy',
                            onSelect: function (date) {
                                scope.$apply(function () {
                                    ngModelCtrl.$setViewValue(date);
                                });
                            },
                            changeMonth: true,
                            changeYear: true,
                            yearRange: "0:+1",
                            minDate: new Date()
                        });
                    }
                    element.click(function (e) {
                        var options;
                        if (angular.element(element).val() != "") {
                            options = {
                                date: new Date(angular.element(element).val()),
                                mode: 'date'
                            };
                        }
                        else {
                            options = {
                                date: new Date(),
                                mode: 'date'
                            };
                        }
                        datePicker.show(options, function (date) {
                            scope.$apply(function () {
                                angular.element(element).val(moment(date).format("DD MMM, YYYY"));
                                ngModelCtrl.$setViewValue(moment(date).format("DD MMM, YYYY"));
                            });
                        });
                    });
                });
                //$(function () {
                //    if (!common.isPhoneGap()) {
                //        element.datepicker({
                //            dateFormat: 'dd M, yy',
                //            onSelect: function (date) {
                //                scope.$apply(function () {
                //                    ngModelCtrl.$setViewValue(date);
                //                });
                //            },
                //            changeMonth: true,
                //            changeYear: true,
                //            yearRange: "-100:+0",
                //            maxDate: "0D"
                //        });
                //    }
                //    else {
                //        element.click(function (e) {
                //            var options = {
                //                date: new Date(),
                //                mode: 'date'
                //            };
                //            datePicker.show(options, function (date) {
                //                scope.$apply(function () {
                //                    angular.element(element).val(moment(date).format("DD MMM, YYYY"));
                //                    ngModelCtrl.$setViewValue(moment(date).format("DD MMM, YYYY"));
                //                });
                //            });
                //        });
                //    }
                //});
            }
        }
    });

    //app.directive('raty', function ($parse) {
    //    return {
    //        restrict: "E",
    //        replace: true,
    //        transclude: false,
    //        compile: function (element, attrs) {
    //            var modelAccessor = $parse(attrs.ngModel);
    //            var html = "<div id='" + attrs.id + "' >" + "</div>";
    //            var newElem = $(html);
    //            element.replaceWith(newElem);
    //            return function (scope, element, attrs, controller) {
    //                var processChange = function () {
    //                    var score = element.raty('score');
    //                    //if(score==undefined) score=-1; //If you want cancel to set it to zero.
    //                    scope.$apply(function (scope) {
    //                        modelAccessor.assign(scope, score);
    //                    });
    //                };
    //                element.raty({
    //                    click: processChange
    //                });
    //                scope.$watch(modelAccessor, function (val) {
    //                    //Set string-bool to real bool, only if set
    //                    if (attrs.readOnly != undefined) { var readOnly = (attrs.readOnly == "true") }
    //                    if (attrs.half != undefined) { var half = (attrs.half == "true") }
    //                    if (attrs.halfShow != undefined) { var halfShow = (attrs.halfShow == "true") }
    //                    if (attrs.cancel != undefined) { var cancel = (attrs.cancel == "true") }
    //                    if (attrs.space != undefined) { var space = (attrs.space == "true") }
    //                    if (attrs.targetKeep != undefined) { var targetKeep = (attrs.targetKeep == "true") }
    //                    if (attrs.precision != undefined) { var precision = (attrs.precision == "true") }
    //                    if (attrs.hints != undefined) { var hints = attrs.hints.split(",", 5) } //limit to 5
    //                    element.raty('set', {
    //                        score: val,
    //                        readOnly: readOnly,
    //                        cancel: cancel,
    //                        cancelHint: attrs.cancelHint,
    //                        cancelOff: attrs.cancelOff,
    //                        cancelOn: attrs.cancelOn,
    //                        cancelPlace: attrs.cancelPlace,
    //                        half: half,
    //                        halfShow: halfShow,
    //                        hints: hints,
    //                        number: attrs.number,
    //                        path: attrs.path,
    //                        size: attrs.size,
    //                        space: space,
    //                        starHalf: attrs.starHalf,
    //                        starOff: attrs.starOff,
    //                        starOn: attrs.starOn,
    //                        targetKeep: targetKeep,
    //                        tagetText: attrs.targetText,
    //                        targetType: attrs.targetType,
    //                        width: attrs.width,
    //                        precision: precision
    //                    });
    //                });

    //            };
    //        }
    //    };
    //});




    //app.directive('jquerySelectAgeGroup', function () {
    //    return {
    //        restrict: "A",
    //        link: function (scope, element, attrs, controller) {
    //            element.customSelectAgeGroup();
    //        }
    //    }
    //});

    //app.directive('jquerySelectCity', function () {
    //    return {
    //        restrict: "A",
    //        link: function (scope, element, attrs, controller) {
    //            element.customSelectCity();
    //        },
    //        scope:{}
    //    }
    //});

    //app.directive('jqueryClickColorChange', function ($compile) {
    //    return {
    //        restrict: "A",
    //        link: function (scope, element, attrs, controller) {
    //            element.click(function () {

    //                //$(".toselect").css('padding','20px');

    //                    $(".toselect").removeClass('selected-slot-div');
    //                    $(this).addClass('selected-slot-div');

    //            });
    //        },
    //        scope: {}
    //    };
    //});
    //app.directive("googleMap",['$window', function ($window) {
    //    return {
    //        restrict: "A",
    //        templateUrl: "app/templates/googleMap.html",
    //        link: function (scope, element, attrs, controller) {
    //            //$route.reload();
    //           // window.onload(function () { geolocateUser() });
    //            element.onload = geolocateUser;




    //            function writeAddressName(latLng) {
    //                var geocoder = new google.maps.Geocoder();
    //                geocoder.geocode({
    //                    "location": latLng
    //                },
    //                function (results, status) {
    //                    if (status == google.maps.GeocoderStatus.OK)
    //                        document.getElementById("address").innerHTML = results[0].formatted_address;
    //                    else
    //                        document.getElementById("error").innerHTML += "Unable to retrieve your address" + "<br />";
    //                });
    //            }

    //            function geolocationSuccess(position) {
    //                var userLatLng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
    //                // Write the formatted address
    //                writeAddressName(userLatLng);

    //                var myOptions = {
    //                    zoom: 12,
    //                    center: userLatLng,
    //                    mapTypeId: google.maps.MapTypeId.ROADMAP
    //                };
    //                // Draw the map
    //                var mapObject = new google.maps.Map(document.getElementById("map"), myOptions);
    //                // Place the marker
    //                new google.maps.Marker({
    //                    map: mapObject,
    //                    position: userLatLng
    //                });
    //                // Draw a circle around the user position to have an idea of the current localization accuracy
    //                /* var circle = new google.maps.Circle({
    //                 center: userLatLng,
    //                 radius: position.coords.accuracy,
    //                 map: mapObject,
    //                 fillColor: '#0000FF',
    //                 fillOpacity: 0.5,
    //                 strokeColor: '#0000FF',
    //                 strokeOpacity: 1.0
    //               }); */
    //                //mapObject.fitBounds(circle.getBounds());
    //            }

    //            function geolocationError(positionError) {
    //                document.getElementById("error").innerHTML += "Error: " + positionError.message + "<br />";
    //            }

    //            function geolocateUser() {
    //                // If the browser supports the Geolocation API
    //                if (navigator.geolocation) {
    //                    var positionOptions = {
    //                        enableHighAccuracy: true,
    //                        timeout: 10 * 1000 // 10 seconds
    //                    };
    //                    navigator.geolocation.getCurrentPosition(geolocationSuccess, geolocationError, positionOptions);
    //                }
    //                else
    //                    document.getElementById("error").innerHTML += "Your browser doesn't support the Geolocation API";
    //            }
    //        }
    //    }
    //}]);

    app.directive('googlemap', function () {
        return {
            restrict: 'E',
            replace: true,
            template: '<div></div>',
            link: function (scope, element, attrs) {
                navigator.geolocation.getCurrentPosition(function (position) {
                    currentLocation = position;
                    var LatLang = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);

                    var mapOptions = {
                        zoom: 13,
                        center: LatLang
                    };
                    var map = new google.maps.Map(document.getElementById(attrs.id), mapOptions);
                    var marker = new google.maps.Marker({
                        position: LatLang,
                        map: map
                    });
                    var geocoder = new google.maps.Geocoder();
                    geocoder.geocode({
                        "location": LatLang
                    }, function (results, status) {
                        if (status == google.maps.GeocoderStatus.OK) {
                            currentAddress = results[0].formatted_address;
                        } else {
                            currentAddress = "Unable to get the current location."
                        }

                    });

                })
            }
        };
    });
    app.directive("numericField", function () {
        return {
            restrict: "A",
            link: function (scope, element, attrs, controller) {
                element.keypress(function (e) {
                    if ((e.which >= 48 && e.which <= 57) || e.which == 8 || e.which == 0)
                        return true;
                    else
                        return false;
                });
            }
        };
    });

    app.directive("vineInput", function () {
        return {
            restrict: "A",
            //templateUrl:"app/templates/vineinput.html",
            link: function (scope, element, attrs, controller) {
                angular.element(element).focusin(function () {
                    $(this).siblings(".holo-field-bracket").css({ 'background': '#007A70' });
                    $(this).css({ 'border-color': '#007A70' });
                    $(this).parent().css({ 'border-color': '#007A70' });
                    $(this).siblings().css({ 'border-color': '#007A70' });
                    $(".vinelabel").attr("disabled", "disabled");
                }).focusout(function () {
                    $(this).siblings(".holo-field-bracket").css({ 'background': '#a2a2a2' });
                    $(this).css({ 'border-color': '#a2a2a2' });
                    $(this).parent().css({ 'border-color': '#a2a2a2' });
                    $(this).siblings().css({ 'border-color': '#a2a2a2' });
                });
            },
            scope: {},
            replace: true
        };
    });

    app.directive("inputIcsTextField", function () {
        return {
            restrict: "AE",
            templateUrl: "app/templates/inputIcsTextField.html",
            link: function (scope, element, attrs, controller) {
                angular.element(element).focusin(function () {
                    $(this).siblings(".holo-field-bracket").css({ 'background': '#007A70' });
                    $(this).css({ 'border-color': '#007A70' });
                    $(this).parent().css({ 'border-color': '#007A70' });
                    $(this).siblings().css({ 'border-color': '#007A70' });
                    $(".vinelabel").attr("disabled", "disabled");
                }).focusout(function () {
                    $(this).siblings(".holo-field-bracket").css({ 'background': '#a2a2a2' });
                    $(this).css({ 'border-color': '#a2a2a2' });
                    $(this).parent().css({ 'border-color': '#a2a2a2' });
                    $(this).siblings().css({ 'border-color': '#a2a2a2' });
                    //$("#vinelabel").attr("disabled", "disabled");
                });
            },
            scope: {
                kare4uplaceholder: "@",
                kare4ulabeltext: "@",
                value: "=dataNgModel",
                kare4utype: "@",
                kare4umodel: "=",
                datalength: "@",
                kare4uid: "@",
                inputicsvalue: "@"
            }
        }
    });

    app.directive('raty', function ($parse) {
        return {
            restrict: "E",
            replace: true,
            transclude: false,
            compile: function (element, attrs) {
                var modelAccessor = $parse(attrs.ngModel);
                var html = "<div id='" + attrs.id + "' >" + "</div>";
                var newElem = $(html);
                element.replaceWith(newElem);
                return function (scope, element, attrs, controller) {
                    var processChange = function () {
                        var score = element.raty('score');
                        //if(score==undefined) score=-1; //If you want cancel to set it to zero.
                        scope.$apply(function (scope) {
                            modelAccessor.assign(scope, score);
                        });
                    };
                    element.raty({
                        click: processChange
                    });
                    scope.$watch(modelAccessor, function (val) {
                        //Set string-bool to real bool, only if set
                        if (attrs.readOnly != undefined) { var readOnly = (attrs.readOnly == "true") }
                        if (attrs.half != undefined) { var half = (attrs.half == "true") }
                        if (attrs.halfShow != undefined) { var halfShow = (attrs.halfShow == "true") }
                        if (attrs.cancel != undefined) { var cancel = (attrs.cancel == "true") }
                        if (attrs.space != undefined) { var space = (attrs.space == "true") }
                        if (attrs.targetKeep != undefined) { var targetKeep = (attrs.targetKeep == "true") }
                        if (attrs.precision != undefined) { var precision = (attrs.precision == "true") }
                        if (attrs.hints != undefined) { var hints = attrs.hints.split(",", 5) } //limit to 5
                        element.raty('set', {
                            score: val,
                            readOnly: readOnly,
                            cancel: cancel,
                            cancelHint: attrs.cancelHint,
                            cancelOff: attrs.cancelOff,
                            cancelOn: attrs.cancelOn,
                            cancelPlace: attrs.cancelPlace,
                            half: half,
                            halfShow: halfShow,
                            hints: hints,
                            number: attrs.number,
                            path: attrs.path,
                            size: attrs.size,
                            space: space,
                            starHalf: attrs.starHalf,
                            starOff: attrs.starOff,
                            starOn: attrs.starOn,
                            targetKeep: targetKeep,
                            tagetText: attrs.targetText,
                            targetType: attrs.targetType,
                            width: attrs.width,
                            precision: precision
                        });
                    });

                };
            }
        };
    });

    app.directive('ngRaty', function () {
        return {
            restrict: "A",
            scope: {
                ngRaty: '=',
                ngModel: '=',
                mouseOver: '&',
                mouseOut: '&'
            },
            link: function ($scope, $element, $attrs) {
                var rating = $scope.ngModel;
                var raty = {
                    score: parseFloat(rating, 10),
                    click: function (stars, evt) {
                        evt.stopPropagation();
                        if (!stars) stars = 0;
                        if (!$scope.$$phase) {
                            $scope.$apply(function () {
                                $scope.ngModel = parseFloat(stars);
                            });
                        } else {
                            $scope.ngModel = parseFloat(stars);
                        }
                    },
                    mouseover: function (stars, evt) {
                        if (!$scope.mouseOver) return;
                        $scope.mouseOver({
                            stars: stars,
                            e: evt
                        });
                        $scope.$apply();
                    },
                    mouseout: function (stars, evt) {
                        if (!$scope.mouseOut) return;
                        $scope.mouseOut({
                            stars: stars,
                            e: evt
                        });
                        $scope.$apply();
                    }
                };
                var options = angular.extend(raty, $scope.ngRaty || {});
                $element.raty(options);

                // Set view to score if model changes
                $scope.$watch('ngModel', function (newValue, oldValue) {
                    $element.raty('score', $scope.ngModel);
                });

                function destroy() {
                    $element.raty('destroy');
                }
                $element.bind('$destroy', destroy);
            }
        }
    });
})();