﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'repository.abstract';


    angular.module('app').factory(serviceId, ['$rootScope', '$q', 'common', '$location','localStorageService',
        'config', AbstractRepository]);

    function AbstractRepository($rootScope,$q,common, $location, localStorageService, config) {
        var logError = common.logger.getLogFn(this.serviceId, 'error');
        var logInfo = common.logger.getLogFn(this.serviceId, 'info');
        var logSuccess = common.logger.getLogFn(this.serviceId, 'success');

        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(serviceId);
        var hri = "";
        var fileOb = {
            filename: '',
            fileextension: '',
            fileid:''
        }
        var tempfileInfo = {
            filename: '',
            filetype: ''
        }
        var fullPath = '';
        var directory;
        var readUrlFromPhone = "/storage/emulated/0/Kare4U/";
        var remoteServiceURL = config.remoteServiceURL;
        var localFilePathFromPhone = 'cdvfile://localhost/persistent/Kare4U/';
        // Abstract repo gets its derived object's this.manager
        function Ctor() {
            this.isLoaded = false;
        }

        Ctor.extend = function (repoCtor) {
            // Allow this repo to have access to the Abstract Repo's functions,
            // then put its own Ctor back on itself.
            // See http://stackoverflow.com/questions/8453887/why-is-it-necessary-to-set-the-prototype-constructor
            repoCtor.prototype = new Ctor();
            repoCtor.prototype.constructor = repoCtor;
        };

        // Shared by repository classes 
        Ctor.prototype._areItemsLoaded = _areItemsLoaded;
        Ctor.prototype._queryFailed = _queryFailed;
        // Convenience functions for the Repos
        Ctor.prototype.log = common.logger.getLogFn(this.serviceId);
        Ctor.prototype._logMessage = _logMessage;
        Ctor.prototype.$q = common.$q;
        Ctor.prototype.$resource = common.$resource;
        Ctor.prototype.get = get;
        Ctor.prototype.save = save;
        Ctor.prototype.saveNew = saveNew;
        Ctor.prototype.getwithparm = getwithparm;
        Ctor.prototype.checkUserLogin = checkUserLogin;
        Ctor.prototype.googleApi = googleApi;
        Ctor.prototype.getDataFromCache = getDataFromCache;
        Ctor.prototype.getData = getData;
        Ctor.prototype.getfilewithparm = getfilewithparm;
        //Ctor.prototype.getwithparam = getwithparam;

        return Ctor;

        function _areItemsLoaded(value) {
            if (value === undefined) {
                return this.isLoaded; // get
            }
            return this.isLoaded = value; // set
        }

        function googleApi(latitude,longitude) {
            
            var request = common.$resource('http://maps.googleapis.com/maps/api/geocode/json?latlng=' + latitude + ',' + longitude + '&sensor=false');
            
            return request.get().$promise.then(function (response) {
                return response;
            });

            return common.$resource(remoteServiceURL + api).query();

            $scope.regions = Regions.query();
            $scope.regions.$promise.then(function (result) {
                $scope.regions = result;
            });
        }

        function getfilewithparm(api, param) {

           // $rootScope.isBusy = true;

            fileOb.filename = param.fileName;
            fileOb.fileextension = param.fileextention;
            fileOb.fileid = param.fileid;
           // alert(config.remoteServiceURL + '     ' + "https://mobile.kare4u.in:1024/");
            hri = config.remoteServiceURL + api + '?filePath=' + param.filePath;
           
            // window.open(href);    
            var qualifiedUri = remoteServiceURL + api;
            if (!window.cordova) {
                var param1 = new Array();
                param1["filepath"] = param.filePath;
                PostWith(qualifiedUri, param1);
               
                $rootScope.isBusy = false;
                return true;
            }
                // else if (Cordova.isCordova() && Cordova.isAndroid()) {
            else {
                window.plugins.spinnerDialog.show("Downloading.", "Please Wait...");
                downloadFile();
               
            }
        }

        //function downloadFile() {
        //    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onRequestFileSystemSuccess, null);
        //}
        function downloadFile() {
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onRequestFileSystemSuccess, null);
        }

        //function onRequestFileSystemSuccess(fileSystem) {
        //    //Creating Kare4u Directory if not exist
        //    var entry = fileSystem.root;
        //    entry.getDirectory("Kare4U", { create: true, exclusive: false }, onGetDirectorySuccess, onGetDirectoryFail);

        //}
        function onRequestFileSystemSuccess(fileSystem) {
            //Creating Kare4u Directory if not exist
            var entry = fileSystem.root;
            entry.getDirectory("Kare4U", { create: true, exclusive: false }, onGetDirectorySuccess, onGetDirectoryFail);

        }
        function onGetDirectorySuccess(dir) {
            //Checking file is exist or not locally
            var LocalFileName = fileOb.filename + fileOb.fileid + fileOb.fileextension; //file anme
            directory = dir;
            dir.getFile(LocalFileName, { create: false }, fileExists, fileDoesNotExist);
        }

        function fileExists(fileEntry) {          
            var tempLocalFilePathFromPhone = localFilePathFromPhone + fileOb.filename + fileOb.fileid + fileOb.fileextension;
            openingfile(tempLocalFilePathFromPhone);
        }

        function fileDoesNotExist() {          
            //Download file from server if not exist 
            directory.getFile(
                'dummy.html',
                { create: true, exclusive: false },
                onGetFileSuccess,
                fail
            );
        }

        function onGetDirectoryFail() {
        }

        function onGetFileSuccess(fileEntry) {
            var path = fileEntry.toURL().replace('dummy.html', '');
            var fileTransfer = new FileTransfer();
            fileEntry.remove();
            var hrf = "";
            fileTransfer.download(
               hri,
                path + fileOb.filename+ fileOb.fileid +fileOb.fileextension,
                function (file) {
                 
                    logSuccess(fileOb.filename + fileOb.fileid + fileOb.fileextension + " is downloaded successfully", '', true);
                    showLink(file.toURI());
                  
                },
                function (error) {
                    logError(fileOb.filename + fileOb.fileextension + " download failed", '', true);
                    window.plugins.spinnerDialog.hide();
                }
            );
        }

        function showLink(url) {
            fullPath = url;
            openingfile(fullPath);
        }

        function openingfile(tempFullPath) {
            var contentType;
            var tempReadUrlFromPhone;
            tempReadUrlFromPhone = tempFullPath;
            var fileextension = tempFullPath.substr((Math.max(0, tempFullPath.lastIndexOf(".")) || Infinity) + 1);
            switch (fileextension) {
                //  switch (tempfileInfo.filetype) {
                case "pdf":
                    contentType = "application/pdf";
                    break;
                case "jpg":
                case "jpeg":
                case "png":
                    contentType = "image/jpeg";
                    break;
                case "xlsx":
                case "xls":
                    contentType = "application/vnd.ms-excel";
                    break;
                case "doc":
                case "docs":
                    contentType = "application/msword";
                    break;
                default:
                    alert("Not supported File format");
            }

            window.plugins.spinnerDialog.hide();
            cordova.plugins.fileOpener2.open(
                tempReadUrlFromPhone,
                contentType,
                {
                    error: function (errorObj) {
                        window.plugins.spinnerDialog.hide();
                        //$rootScope.isBusy = false;
                    },
                    success: function () {
                        window.plugins.spinnerDialog.hide();
                        //$rootScope.isBusy = false;
                    }
                }
            );
        }

        function fail(evt) {
            window.plugins.spinnerDialog.hide();
        }

        function PostWith(to, params) {
            var myForm = document.createElement("form");
            myForm.method = "get";
            myForm.action = to;
            myForm.target = "_blank";
            //myForm.setHeaders('AuthToken', 'pW6WEB26m5m9L2ESmjzZ2w==');
            //myForm.setHeaders('UserId', UserService.getLoggedInUser().userid);
            for (var k in params) {
                var myInput = document.createElement("input");
                myInput.setAttribute("name", k);
                myInput.setAttribute("value", params[k]);
                myForm.appendChild(myInput);
            }

            document.body.appendChild(myForm);
            // document.he
            myForm.submit();
            document.body.removeChild(myForm);
            var deferred = $q.defer();
            deferred.reject("Success");
            return deferred.promise;
        }

        function getOfflineData(param, localStorageKey) {
            var deferred = $q.defer();
            //Step 1: Check if localStorageKey is available
            if (!localStorageKey) {
                logError('Oops..This functionality is not available offline. Pls. try later', '', true);
            }
            else {
                var localData = angular.fromJson(localStorageService.get(localStorageKey));
                if (localData) {
                    deferred.resolve(localData);
                }
                else {
                    deferred.reject('No offline data exists yet for this');
                    //logInfo('No offline data exists yet for this', '', true);
                }
                
            }
            return deferred.promise;
        }

        function get(api, localStorageKey) {

            if (!$rootScope.online) {
                return getOfflineData('',localStorageKey);
                
            }
            var request = common.$resource(remoteServiceURL + api, {}, { withCredentials: true });
            $rootScope.isBusy = true;
            return request.query().$promise.then(function (response) {
                //Put the result back in the local storage
                if (localStorageKey) {
                    localStorageService.add(localStorageKey, angular.toJson(response));
                }
                return response;
            }, function (response) {
                if (response.status == '401') {
                    $location.url('/registration');
                    return;
                };
                _queryFailed(response.data);
            }).finally(function () {
                $rootScope.isBusy = false;
            });

            return common.$resource(remoteServiceURL + api).query();
        }

        function getData(api,param, localStorageKey) {

            if (!$rootScope.online) {
                return getOfflineData();

            }
            //  return common.$resource(remoteServiceURL + api, param).query();
            var request = common.$resource(remoteServiceURL + api, param, {}, { withCredentials: true });
            $rootScope.isBusy = true;
            return request.get().$promise.then(function (response) {
                return response;
            }, function (response) {
                if (response.status == '401') {
                    $location.url('/registration');
                    return;
                };
                _queryFailed(response.data)
            }).finally(function () {
                $rootScope.isBusy = false;
            });

            return common.$resource(remoteServiceURL + api).get();
        }

        function getwithparm(api, param, localStorageKey) {
            if (!$rootScope.online) {
                return getOfflineData();

            }
          //  return common.$resource(remoteServiceURL + api, param).query();
            var request = common.$resource(remoteServiceURL + api,param, {}, { withCredentials: true });
            $rootScope.isBusy = true;
            return request.query().$promise.then(function (response) {
                return response;
            }, function (response) {
                if (response.status == '401') {
                    $location.url('/registration');
                    return;
                };
                _queryFailed(response.data)
            }).finally(function () {
                $rootScope.isBusy = false;
            });

            return common.$resource(remoteServiceURL + api).query();
        }

        //This method is invoked for the static data (that are cached)
        //Typically will be called from the cache factory
        function getDataFromCache(api, data) {
            $rootScope.isBusy = true;
            var request = common.$resource(remoteServiceURL + api, data,{
                query: {
                    cache: true,
                    method: "GET",
                    isArray: true
                }
            });
            //return request;
            return request.query().$promise.then(function (response) {
                return response;
            }, function (response) {
                if (response.status == '401') {
                    $location.url('/registration');
                    return;
                };
                _queryFailed(response.data)
            }).finally(function () {
                $rootScope.isBusy = false;
            });

            //return common.$resource(remoteServiceURL + api, {}, {
            //    get: {
            //        method: "GET",
            //        isArray: true,
            //        cache: true
            //    }
            //});
        }


        //This method makes a call just to get the logged on user, if at all
        //This method is only called during the module load. If the user is logged in proper flags are set
        function checkUserLogin() {
            var api = 'api/Consumer/GetLoggedOnConsumerDetails';
            var request = common.$resource(remoteServiceURL + api);
            return request.query().$promise.then(function (response) {
                return response;
            }, function (response) {
                if (response.status == '401') {
                    return null;
                };
                _queryFailed(response.data)
            });
        }

        function save(api, data) {
            var request = common.$resource(remoteServiceURL + api);
            $rootScope.isBusy = true;
            //console.log(remoteServiceURL + api);
            return request.save(data).finally(function () {
                $rootScope.isBusy = false;
            });
            
        }

        function saveNew(api, data) {
            var request = common.$resource(remoteServiceURL + api);
            $rootScope.isBusy = true;
            return request.save(data).$promise.then(function (response) {
                return response;
            }, function (response) {
                if (response.status == '401') {
                    return null;
                }
                else if (response.status == '400') {
                    return response;
                };
                //throw response;
                _queryFailed(response.data)
            }).finally(function () {
                    $rootScope.isBusy = false;
            });

        }

        function _queryFailed(error) {
            var msg = config.appErrorPrefix;
            for (var i = 0; i < error.length; i++) {
                logError(error[i], msg, true);
            }
            
            throw error;
        }

        function _logMessage(message) {
            var msg = 'Message from abstract repository ' + message;
            log(msg);
        }
    }
})();