﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'repository.appointment';

    angular.module('app').factory(serviceId, ['repository.abstract', 'config','searchCriteria', RepositoryAppointment]);

    function RepositoryAppointment(AbstractRepository, config, searchCriteria) {
        var selectedDoctor = '';
        var selectedDoctorInfo = {
            doctorname: '',
            docSpec: '',
            doctorLocation: '',
            lat: '',
            lng: '',
            autocomVal:''
        }
        var providerid = '';
        var slotinfo = {
            docname: "",
            hospitalname: "",
            slottime: "",
            name: "",
            phone: "",
            dob: "",
            gender: ""
        }
        var setSelectedRebookAppointmentProviderId;
        var selectedAppointment;
        var suggestedDoctorInfo = {
            doctorName: "",
            doctorSpecialization:"",
            doctorLocation:""
            
        }
       
        

        function Ctor() {
            this.serviceId = serviceId;
            // Exposed data access functions
          //  this.getUpcomingAppointments = getUpcomingAppointments;
            this.getPastAppointments = getPastAppointments;
            this.getDoctorsInfo = getDoctorsInfo; //Getting search result
           // this.getDoctorDetailsForBookAppointment = getDoctorDetailsForBookAppointment;
            this.getSeltectedDoctor = getSeltectedDoctor;
            this.saveSelectedDoctor = saveSelectedDoctor;
            this.saveProviderId = saveProviderId;
            this.getListOfTimeSlot = getListOfTimeSlot;
            this.getUpcomingAppointments = getUpcomingAppointments;
            this.setBookAppointment = setBookAppointment;
            this.getSelectedAppointment = getSelectedAppointment;
            this.setSelectedAppointment = setSelectedAppointment;
            //this.bookAppointment = bookAppointment;
            this.getProviderId = getProviderId;
            this.setRebookAppointment = setRebookAppointment;
            this.cancelSelectedAppointment = cancelSelectedAppointment;
            this.getProviderDetailsById = getProviderDetailsById;
           // this.getConsumerDetails = getConsumerDetails;
            this.GetFamilyListForDropDown = GetFamilyListForDropDown;
           // this.GetFamilyDetails = GetFamilyDetails;
            this.setBookAppointmentForfamily = setBookAppointmentForfamily;
            this.sentOtp = sentOtp;
            this.saveRatingForSelectedDoctor = saveRatingForSelectedDoctor;
            this.submitSuggestionInfo = submitSuggestionInfo;
            this.getPreviousDoctorSuggestions = getPreviousDoctorSuggestions;
            this.getPaginationRes = getPaginationRes;

            this.GetScheduleForProvider = GetScheduleForProvider;
            this.deletefavouriteDoctor = deletefavouriteDoctor;
            this.saveMyFavouriteDoctorRating = saveMyFavouriteDoctorRating;
        }

        AbstractRepository.extend(Ctor);
        return Ctor;

        function getUpcomingAppointments() {

            var self = this;

            return self.get('api/ConsumerAppointment/Appointments', config.localStorageNames.upcomingAppointments);
        }


        function deletefavouriteDoctor(providerId, favouriteDoctorsID) {
            var self = this;
            var data = {
                ProviderID: providerId,
                MyFavouriteDoctorsID : favouriteDoctorsID,
                IsAvtive: false
            }
            return self.saveNew('api/Consumer/RemoveMyFavouriteDoctor', data);
        }

        

        function getPastAppointments() {

            var self = this;
           
            return self.get('api/ConsumerAppointment/RetrieveAppointmentHistory', config.localStorageNames.pastAppointments);



        }

        function GetScheduleForProvider(providerid) {
            var self = this;
            var data = {
                providerID: providerid
            }
            return self.getwithparm('api/Provider/GetScheduleForProvider', data);
        }
        function getProviderDetailsById(providerid) {
           
            var self = this;
            var data = {
                providerId: providerid
            }
           
           
            return self.getwithparm('api/Provider/GetDoctorProfile', data);

        }
        

        function cancelSelectedAppointment(apptid) {
            var self = this;
            //var id = appt.selectedAppointment.id;
            //alert(appt+'dg');
            var AppId = {
                iD: apptid
            }
           
            //console.log(AppId);
            return self.saveNew('api/ConsumerAppointment/CancelAppointment', AppId);
        }

        

        //function getDoctorsInfo(selectedDoctorName) {
        function getDoctorsInfo() {
            //alert("spec id"+searchCriteria.specializationId);
            //alert("lattitude" + searchCriteria.lattitude);
            //alert("longitude" + searchCriteria.longitude);
            //alert("cityId" + searchCriteria.cityId);
            //alert("doctorName" + searchCriteria.doctorName);
            var self = this;
            var doctorname = {
                
                //searchParam: selectedDoctorName.doctorName,
                //specializationID: selectedDoctorName.doctorSpec,
                //cityID: selectedDoctorName.doctorLoc,
                //Latitude: selectedDoctorName.doctorLat,
                //Longitude: selectedDoctorName.doctorLng,
                //IsAutocomplete: selectedDoctorName.doctorIsAuto,
                //startSearchIndex:selectedDoctorName.pageindex

                searchParam: searchCriteria.doctorName,
                specializationID: searchCriteria.specializationId,
                cityID: searchCriteria.cityId,
                Latitude: searchCriteria.lattitude,
                Longitude: searchCriteria.longitude,
                IsAutocomplete: searchCriteria.isAutocomplete,
                startSearchIndex: searchCriteria.pageIndex,
                CityAreaFacet: searchCriteria.cityAreaFacet,
                SpecialisationFacet: searchCriteria.specialisationFacet

                //searchParam: '',
                //specializationID: 0,
                //cityID: 0,
                //Latitude: "20.3261287",
                //Longitude: "85.8192468",
                //IsAutocomplete: false,
                //startSearchIndex: 0

            }
          return self.getwithparm('api/Search/GetSearchResult', doctorname);
           
                        //return self.$q.when(doctors);
        }

       


        //function getDoctorDetailsForBookAppointment() {
        //    var self = this;

        //    var docterDetailsById = [];
        //    for (var i = 0; i < doctors.length; i++) {
        //        if (doctors[i].providerId == providerid) {
        //            docterDetailsById = doctors[i];
        //        }
        //    }

        //    return self.$q.when(docterDetailsById);
        //}
        function getSeltectedDoctor() {
            var self = this;
           
            return self.$q.when(selectedDoctorInfo);
        }



        function saveSelectedDoctor(docname,docspec,docloc,loclat,loclng,autocompleteValue) {

            selectedDoctorInfo.doctorname = docname;
            selectedDoctorInfo.docSpec = docspec;
            selectedDoctorInfo.doctorLocation = docloc;
            selectedDoctorInfo.lat = loclat;
            selectedDoctorInfo.lng = loclng;
            selectedDoctorInfo.autocomVal = autocompleteValue;
        }

        function saveProviderId(Prviderid) {
            providerid = Prviderid;
           
        }

        function getProviderId() {
            var self = this;
            return self.$q.when(providerid);
            
        }
        
        //function getConsumerDetails() {
        //    var self = this;
        //    return self.get('api/Customer/GetLoggedOnConsumerDetails');
        //}
        function GetFamilyListForDropDown() {
            var self = this;
            return self.get('api/Consumer/GetFamilyListForDropDown');
        } 

        //function GetFamilyDetails(value) {
        //    var self = this;
        //    return self.getwithparm('api/Customer/GetFamilyDetails', value);
        //}
        function getListOfTimeSlot(date, providerid) {
            var self = this;
            var data = {
                providerId: providerid,
                date: date
            }
            //return self.getwithparm('api/Customer/GetFreeScheduleForDay', providerid);
       
            return self.getwithparm('api/ConsumerAppointment/GetFreeScheduleForDay', data);
        }
        function setBookAppointment(slotdetails) {
           

            var self = this;
            //return self.getwithparm('api/Customer/ScheduleAppointment', slotdetails);
            //return self.save('api/ConsumerAppointment/ScheduleAppointment', slotdetails);
            return self.saveNew('api/ConsumerAppointment/ScheduleAppointment', slotdetails);
        }
        function setBookAppointmentForfamily(slotdetails) {


            var self = this;
            //return self.getwithparm('api/Customer/ScheduleAppointment', slotdetails);
            //return self.save('api/ConsumerAppointment/ScheduleAppointmentForFamily', slotdetails);
            return self.saveNew('api/ConsumerAppointment/ScheduleAppointmentForFamily', slotdetails);
            
        }

        function sentOtp(otpcode) {
            var self = this;
            var Otp = {
                OTP: otpcode
            }
            //return self.save('api/ConsumerAppointment/VerifyOTP', Otp);
            return self.saveNew('api/ConsumerAppointment/VerifyOTP', Otp);
        }
        function setRebookAppointment(pastAppt) {
            setSelectedRebookAppointmentProviderId = pastAppt;
        }

        function setSelectedAppointment(upcomingAppt) {
            selectedAppointment = upcomingAppt;
        }
        function getSelectedAppointment() {
            var self = this;
            return self.$q.when(selectedAppointment);
        }

        function submitSuggestionInfo(docName, specId, specName, cityCode, cityName) {
            var self = this;
            var suggestionDetails = {
                DoctorName: docName,
                SpecializationID: specId,
                SpecializationName:specName,
                CityCode: cityCode,
                City: cityName
            }
            console.log(suggestionDetails);
            return self.saveNew('api/Consumer/AddDoctorsRecommendedByUser', suggestionDetails);
        }

        function getPreviousDoctorSuggestions() {
            var self = this;
            return self.get('api/Consumer/GetDoctorsRecommendedByUser', config.localStorageNames.suggestedDoctors);
        }

        function getPaginationRes(searchParam) {
            var self = this;
            var paginationpara = {
                //searchParam: 'Brahma',
                searchParam: searchParam.searchPara,
                cityID: searchParam.cityId,
                IsAutocomplete: searchParam.isAutocomplete,
                startSearchIndex: searchParam.startSearchIndex
            }
            return self.getwithparm('api/Search/GetPaginationSearchResult', paginationpara);
        }

        function saveRatingForSelectedDoctor(selectedDoctorID, doctorRatingByIndividualUser) {
            var self = this;
            var ratingDetails = {
                ProviderID: selectedDoctorID,
                TotalRating: doctorRatingByIndividualUser
            }
            return self.saveNew('api/Customer/RateDoctor', ratingDetails);
        }

        function saveMyFavouriteDoctorRating(selectedDoctorID, doctorRatingByIndividualUser) {
            var self = this;
            var data = {
                ProviderID: selectedDoctorID,
                TotalRating: doctorRatingByIndividualUser
            }
            return self.saveNew('api/Consumer/RateDoctor', data);
        }

        //function bookAppointment() {
        //    upcomingAppointments.push(
        //        {
        //            doctorName: "Dr. Sameer Jena", doctorSpecialization: "Neurology",
        //            doctorLocation: "C.R.P.F.", appointmentMonth: "JAN", appointmentDate: "02"
        //        });
        //}

        //#region Internal Methods        

        //#endregion
    }
})();