﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'repository.cacheservice';

    // Define the factory on the module.
    // Inject the dependencies. 
    // Point to the factory definition function.
    // TODO: replace app with your module name
    angular.module('app').factory(serviceId, ['repository.abstract', CacheService]);

    function CacheService(AbstractRepository) {
        // Define the functions and properties to reveal.
        function Ctor() {
            this.serviceId = serviceId;
            this.getCommonSpecializations = getCommonSpecializations;
            this.getDropDownValues = getDropDownValues;
            this.getAvailableCities = getAvailableCities;
            this.GetFamilyListForDropDown = GetFamilyListForDropDown;
        }

        AbstractRepository.extend(Ctor);
        return Ctor;

        function getCommonSpecializations() {
            var self = this;
            return self.getDataFromCache('api/Utility/GetPopularSpecialization');
        }
        function GetFamilyListForDropDown() {
            var self = this;
            //return self.get('api/Provider/DoctorSpecialization');
            //return self.getDataFromCache('api/Provider/DoctorSpecialization');
            //var self = this;
           
            return self.getDataFromCache('api/Consumer/GetFamilyListForDropDown');
        }
        function getDropDownValues(standardCodeType) {
            var self = this;
            //return self.get('api/Provider/DoctorSpecialization');
            //return self.getDataFromCache('api/Provider/DoctorSpecialization');
            //var self = this;
            var data = {
                standardCode: standardCodeType
            }
            return self.getDataFromCache('api/Utility/GetDropDownValuesFor', data);
        }

        function getAvailableCities() {
            var self = this;
            //return self.get('api/Provider/DoctorSpecialization');
            //return self.getDataFromCache('api/Provider/DoctorSpecialization');
            //var self = this;
           
            return self.getDataFromCache('api/Utility/GetActiveCities');
        }

        //#region Internal Methods        

        //#endregion
    }
})();