﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'repository.chronicdisease';

    angular.module('app').factory(serviceId, ['repository.abstract', RepositoryChronicDisease]);

    function RepositoryChronicDisease(AbstractRepository) {
        // Define the functions and properties to reveal.
        function Ctor() {
            this.serviceId = serviceId;
            this.getChronicDiseases = getChronicDiseases;
            this.getChronicData = getChronicData;

            // Exposed data access functions
        }

        AbstractRepository.extend(Ctor);
        return Ctor;

        function getChronicDiseases() {
            var self = this;
            var chronicDiseases = [
                {
                    chronicdiseaseId: 1,
                    diseaseDesc: "Diabetes "
                },
                {
                    chronicdiseaseId: 2,
                    diseaseDesc: "Asthma"
                },
                {
                    chronicdiseaseId: 3,
                    diseaseDesc: "Blood Pressure"
                },
                {
                    chronicdiseaseId: 4,
                    diseaseDesc: "Cholesterol"
                }
            ];

            return self.$q.when(chronicDiseases);
        }
        function getChronicData(selectedchronicId) {
            var self = this;
            var diabetes = [
                { 'x': 3, 'y': 7 },
                { 'x': 5, 'y': 15 },
                { 'x': 7, 'y': 8 },
                { 'x': 11, 'y': 17 },
                { 'x': 13, 'y': 13 },
                { 'x': 17, 'y': 23 }
            ];
            var asthma = [
                { 'x': 5, 'y': 8 },
                { 'x': 6, 'y': 15 },
                { 'x': 7, 'y': 15 },
                { 'x': 11, 'y': 17 },
                { 'x': 13, 'y': 13 },
                { 'x': 17, 'y': 17 }
            ];
            var bloodpressure = [
                { 'x': 3, 'y': 10 },
                { 'x': 5, 'y': 15 },
                { 'x': 8, 'y': 13 },
                { 'x': 11, 'y': 17 },
                { 'x': 13, 'y': 23 },
                { 'x': 17, 'y': 23 }
            ];
            var cholesterol = [
                { 'x': 3, 'y': 10 },
                { 'x': 5, 'y': 15 },
                { 'x': 8, 'y': 13 },
                { 'x': 11, 'y': 17 },
                { 'x': 13, 'y': 23 },
                { 'x': 17, 'y': 23 }
            ];
            var sendChronicData = [];
            var chronicData = [
                { selectedchronicId: 1, data: diabetes },
                { selectedchronicId: 2, data: asthma },
                { selectedchronicId: 3, data: bloodpressure },
                { selectedchronicId: 4, data: cholesterol }
            ];

            for (var i = 0; i < chronicData.length; i++) {
                if (chronicData[i].chronicdiseaseId == selectedchronicId)
                    sendChronicData = chronicData[i].data;
            }

            return self.$q.when(sendChronicData);
        }

    }
})();