﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'repository.phr';

    angular.module('app').factory(serviceId, ['repository.abstract','config', RepositoryPHR]);

    function RepositoryPHR(AbstractRepository, config) {

        var exampleData = [];
        var bmi = [];

        // Define the functions and properties to reveal.
        function Ctor() {
            this.serviceId = serviceId;
            ///Vitals
            this.getFamilyMembers = getFamilyMembers;
            this.getVitalGroups = getVitalGroups;
            this.getVitalsForGroup = getVitalsForGroup;
            this.getPHRVitals = getPHRVitals;
            this.saveVitals = saveVitals;
            //this.saveSingleVital = saveSingleVital;
            ///BMI
            this.getBMIData = getBMIData;
            ///Chronic
            this.getDiseaseList = getDiseaseList;
            this.getTestDetails = getTestDetails;
            this.getTestResults = getTestResults;
            this.saveChronic = saveChronic;
            this.saveEditedVitalsDetails = saveEditedVitalsDetails;
        }

        AbstractRepository.extend(Ctor);
        return Ctor;

        //Function definations
        ///// Vital-Chart Code
        //////////////////////////////
        function getFamilyMembers() {
            var self = this;
            return self.get('api/Consumer/GetFamilyMembers', config.localStorageNames.familyamembersForDropdown);
        }

        function saveEditedVitalsDetails(data, type) {
            var self = this;
            if (type == "Pulse Rate") {
                return self.saveNew('api/ConsumerPHR/UpdatePulseRate', data);
            }
            if (type == "Systolic") {
                return self.saveNew('api/ConsumerPHR/UpdateBP', data);
            }
            if (type == "Diastolic") {
                return self.saveNew('api/ConsumerPHR/UpdateBP', data);
            }
            if (type == "PPS") {
                return self.saveNew('api/ConsumerPHR/UpdateBS', data);
            }
            if (type == "RBS") {
                return self.saveNew('api/ConsumerPHR/UpdateBS', data);
            }
            if (type == "BMI") {
                return self.saveNew('api/ConsumerPHR/UpdateBMI', data);
            }
            //return self.saveNew('api/ConsumerPHR/SaveSingleVital', data);
        }
        function getVitalGroups() {
            var self = this;
            return self.get('api/ConsumerPHR/getVitalGroups');
        }
        function getVitalsForGroup(vitalGroupId) {
            var self = this;
            var data = {
                vitalGroupID: vitalGroupId
            };
            return self.getwithparm('api/ConsumerPHR/GetVitalsList', data);
        }
        function getPHRVitals(consumerID) {
            var self = this;
            var data = {
                consumerId: consumerID
            }
            return self.getwithparm('api/ConsumerPHR/GetPHRVitals', data);
        }
        //function saveSingleVital(data) {
        //    var self = this;
        //    return self.save('api/ConsumerPHR/SaveGroupVitals', data);
        //};
        function saveVitals(data) {
            console.log(data);
            var self = this;
            return self.saveNew('api/ConsumerPHR/SaveVitals', data);
        };

        ///// BMI-Chart Code
        //////////////////////////////
        function getBMIData(consumerID) {
            var self = this;
            var data = {
                consumerId: consumerID
            }
            return self.getwithparm('api/ConsumerPHR/GetPHRVitalsBMI', data);
        }

        ///// Chronic-Chart Code
        //////////////////////////////
        function getDiseaseList(consumerID) {
            var self = this;
            var data = {
                consumerId: consumerID
            }
            return self.getwithparm('api/ConsumerPHR/GetDiseaseList', data);
        }

        function getTestDetails(diseaseID) {
            var self = this;
            var data = {
                diseaseId: diseaseID
            }
            return self.getwithparm('api/ConsumerPHR/GetTestDetails', data);
        }

        function getTestResults(consumerID, chrDisId, testId) {
            var self = this;
            var data = {
                familyMemberId: consumerID,
                ChronicDiseaseId: chrDisId,
                TestIds: testId
            }
            return self.getwithparm('api/ConsumerPHR/GetTestResults', data);
        }

        function saveChronic(ChronicData) {
            var self = this;
            return self.save('api/ConsumerPHR/CreateChronicRecord', ChronicData);
        };
    }
})();