﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'repository.registration';

    angular.module('app').factory(serviceId, ['repository.abstract','config','searchCriteria', RepositoryRegistration]);

    function RepositoryRegistration(AbstractRepository, config, searchCriteria) {
        var addMoreDoctorsInfo;
        var maritalStatus;
        var doctorSetupMode;
        var availbleCities;
        var availableCityArea;
        var consumerdetails = {
            name: '',
            consumerid: ''
        };
        var userDetails = {
            Gender: "",
            MaritalStatus: ""
            //AgeGroup: ""
        };


        // Define the functions and properties to reveal.
        function Ctor() {
            this.serviceId = serviceId;
            this.setInfoForAddMoreDoctors = setInfoForAddMoreDoctors;
            this.saveMaritalStatus = saveMaritalStatus;
            this.getMaritalStatus = getMaritalStatus;
            this.getSpecializationDetails = getSpecializationDetails;
            this.getSearchResultCity = getSearchResultCity;
            this.getDoctorSetupMode = getDoctorSetupMode;
            this.getInfoForAddMoreDoctors = getInfoForAddMoreDoctors;
            //this.getDoctorsInfo = getDoctorsInfo;
            this.registerUser = registerUser;
            this.login = login;
            this.logout = logout;
            this.facebookLogin = facebookLogin;
            this.getAvailableCities = getAvailableCities;
            this.getAvailableCityArea = getAvailableCityArea;
            this.saveUserDetails = saveUserDetails;
            this.getUserDetails = getUserDetails;
            this.getUserGenderList = getUserGenderList;
            this.getAgeGroupList = getAgeGroupList;
            this.getMaritalCategoryList = getMaritalCategoryList;
            this.getDoctorsInfo = getDoctorsInfo;
            this.saveToFavourites = saveToFavourites;
            this.getFavouriteDoctors = getFavouriteDoctors;
            this.getLoggedInUser = getLoggedInUser;
            this.resetPassword = resetPassword;
            this.getFacebookUserDetails = getFacebookUserDetails;
            this.updateUserDetails = updateUserDetails;
            this.updatekare4uUserDetails = updatekare4uUserDetails;
        }

        AbstractRepository.extend(Ctor);
        return Ctor;
        function setInfoForAddMoreDoctors(addMoreDoctorsPageInfo) {
            addMoreDoctorsInfo = addMoreDoctorsPageInfo;
        }

        function getFacebookUserDetails(fbResponse) {
            var self = this;

            var facebookUserDetails = {
                FBId: fbResponse.id,
                FBName: fbResponse.name,
                FBFirstName: fbResponse.first_name,
                FBLastName: fbResponse.last_name,
                FBVerified: fbResponse.verified,
                FBGender: fbResponse.gender,
                FBBirthday: fbResponse.birthday,
                FBEmail: fbResponse.email
            }
            
            return self.saveNew('api/Login/RegisterOrLoginConsumerUsingFBCredential', facebookUserDetails);
        }
        

        function updateUserDetails(conBasicProfile) {
            var self = this;
            return self.saveNew('api/Consumer/UpdateFacebookUserDetails', conBasicProfile);
        }

        function updatekare4uUserDetails(conBasicProfile) {
            var self = this;
            return self.saveNew('api/Consumer/UpdateConsumerBasicProfile', conBasicProfile);
        }
        


        function saveMaritalStatus(mStatus) {
            maritalStatus = mStatus;
        }
        function getMaritalStatus() {
            var self = this;
            return self.$q.when(maritalStatus);
        }

        function login(data) {           
            var self = this;
            return self.saveNew('api/Login/Login', data);
        }
        function logout() {
         
            var self = this;
            return self.saveNew('api/Login/Logout');
        }

        function getSpecializationDetails() {
            var self = this;
            var userInfo = {
                Gender: userDetails.Gender,
                MaritalStatus: userDetails.MaritalStatus
            };
            return self.getwithparm('api/Utility/GetSpecilizationDetails', userInfo);
        }
        function getSearchResultCity() {
            var self = this;
            var searchCity = [
                { city: "Bhubaneswar", cityValue: 1 },
                { city: "Bengaluru", cityValue: 2 },
                { city: "Hyderabad", cityValue: 3 },
                { city: "Mumbai", cityValue: 4 },
                { city: "Kolkata", cityValue: 5 },
                { city: "Thiruvanantapuram", cityValue: 6 }
            ];
            return self.$q.when(searchCity);
        }
        function getDoctorSetupMode() {
            var self = this;
            return self.$q.when(doctorSetupMode);
        }
        function getInfoForAddMoreDoctors() {
            var self = this;
            return self.$q.when(addMoreDoctorsInfo);
        }
        //function getDoctorsInfo() {

        //}
        function registerUser(registrationDetails) {
            var self = this;
            //console.log(registrationDetails);
            var registerConsumer = {
                Contact: registrationDetails.Contact,
                FirstName: capitaliseFirstLetter(registrationDetails.FirstName),
                Password: registrationDetails.Password,
                UserLogin: registrationDetails.UserLogin,
                DateOfBirth: registrationDetails.DateOfBirth
            }
            console.log(registerConsumer);
            return self.saveNew('api/Login/RegisterMobileConsumer', registerConsumer);
        }
        function capitaliseFirstLetter(string) {
            return string.charAt(0).toUpperCase() + string.slice(1);
        }
        function facebookLogin() {
        }
        function getAvailableCities() {
            var self = this;
            return availbleCities = self.get('api/Utility/GetActiveCities', config.localStorageNames.availableCities);
        }
        function getAvailableCityArea(demographyCode) {
            var self = this;
            var cityDetails = {
                data: demographyCode
            }
            return availableCityArea = self.getwithparm('api/Utility/GetActiveCityArea', cityDetails);
        }
        function saveUserDetails(gender,maritalStatus) {
            var self = this;
            userDetails = {
                Gender: gender,
                MaritalStatus: maritalStatus
                //AgeGroup: ageGroup
            }
        }
        function getUserDetails() {
            var self = this;
            return self.$q.when(consumerdetails);
            
        }
        function getLoggedInUser() {
            var self = this;
            return self.checkUserLogin();
        }
        function getUserGenderList() {
            var self = this;
            var selectionType = {
                category: "Sex"
            }
            return self.getwithparm('api/Utility/GetStandardCodeValues', selectionType);
        }
        function getAgeGroupList() {
            var self = this;
            var selectionType = {
                category: "Age Group"
            }
            return self.getwithparm('api/Utility/GetStandardCodeValues', selectionType);
        }
        function getMaritalCategoryList() {
            var self = this;
            var selectionType = {
                category: "Marital Status"
            }
            return self.getwithparm('api/Utility/GetStandardCodeValues', selectionType);
        }
        function getDoctorsInfo() {

            var self = this;
            var doctorname = {

                searchParam: searchCriteria.doctorName,
                specializationID: searchCriteria.specializationId,
                cityID: searchCriteria.cityId,
                Latitude: searchCriteria.lattitude,
                Longitude: searchCriteria.longitude,
                IsAutocomplete: searchCriteria.isAutocomplete,
                startSearchIndex: searchCriteria.pageIndex,
                CityAreaFacet: searchCriteria.cityAreaFacet,
                SpecialisationFacet: searchCriteria.specialisationFacet

               // searchParam: selectedDoctorName.doctorName,
               // specializationID: selectedDoctorName.doctorSpec,
               // cityID: selectedDoctorName.doctorLoc,
                //IsAutocomplete: selectedDoctorName.IsAutocomplete,
                //latitude: selectedDoctorName.doctorLat,
               // longitude: selectedDoctorName.doctorLng,
               // IsAutocomplete: selectedDoctorName.doctorIsAuto,
                //startSearchIndex: selectedDoctorName.pageindex
            }
            console.log(doctorname);
            return self.getwithparm('api/Search/GetSearchResult', doctorname);
        }
        function saveToFavourites(saveToFavourite) {
            var self = this;
            var addToFav = {
                //specializationID:saveToFavourite.specializationID,
                //specializationName:saveToFavourite.specializationName,
                providerID: saveToFavourite.providerID,
                //providerName: saveToFavourite.providerName,
               // cityCode: saveToFavourite.cityCode,
               // city: saveToFavourite.city,
                IsActive: true
            };
            
            console.log(addToFav);
            return self.saveNew('api/Consumer/AddMyFavouriteDoctor', addToFav);
        }
        
        function getFavouriteDoctors() {
            var self = this;
            return self.get('api/Consumer/GetMyFavouriteDoctors', config.localStorageNames.favouriteDoctorsList);
        }
        function resetPassword(emailid) {
            var self = this;
            var resetPwd = {
                UserLogin: emailid
            }
            return self.saveNew('api/Login/ResetPassword',resetPwd);
        }
    }
})();