﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'repository.search';

    angular.module('app').factory(serviceId, ['repository.abstract','searchCriteria', RepositorySearch]);

    function RepositorySearch(AbstractRepository,searchCriteria) {
        // Define the functions and properties to reveal.
    	function Ctor() {
    	    this.serviceId = serviceId;
    	    this.getDoctorSpecialization = getDoctorSpecialization;
    	    this.getSearchedDoctors = getSearchedDoctors;
    	    this.getExactGeolocation = getExactGeolocation;
    		// Exposed data access functions
    	}

    	AbstractRepository.extend(Ctor);
    	return Ctor;
    	function getDoctorSpecialization() {
    	    var self = this;
    	    //return self.get('api/Provider/DoctorSpecialization');
    	    return self.getDataFromCache('api/Provider/DoctorSpecialization');
    	}
    	function getSearchedDoctors(term) {
           
            var term = { 
                searchParam: term, 
                specializationID: searchCriteria.specializationId,
                cityID:searchCriteria.cityId};
    	    var self = this;
    	    return self.getwithparm('api/Search/GetAutoCompleteSearch', term);
    	   
    	}    	
    	function getExactGeolocation(latitude, longitude) {
    	    var self = this;
    	    return self.googleApi(latitude, longitude);

    	}

    }
})();