﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'repository.vaccination';

    angular.module('app').factory(serviceId, ['repository.abstract', 'config', RepositoryVaccination]);

    function RepositoryVaccination(AbstractRepository, config) {

        var selectedVaccine;
        //var vac="";

        // Define the functions and properties to reveal.
        function Ctor() {
            this.serviceId = serviceId;
            // Exposed data access functions
            this.getChildrenForVaccination = getChildrenForVaccination;
            this.GetVaccinationList = GetVaccinationList;
            this.CreateVaccinationChart = CreateVaccinationChart;
            this.UpdateVaccinationData = UpdateVaccinationData;
            this.getVaccDoctors = getVaccDoctors;
            this.getVaccHospitals = getVaccHospitals;
        }

        AbstractRepository.extend(Ctor);
        return Ctor;

        //////Block Started for Vaccination
        
        function getChildrenForVaccination() {
            var self = this;
            //var data = {
            //    ConsumerID: ConsumerID
            //}
            return self.getwithparm('api/ConsumerPHR/getChildrenForVaccination', config.localStorageNames.childrenList);
        }

        function GetVaccinationList(childId) {
            var self = this;
            var data = {
                consumerID: childId
            }
            return self.getwithparm('api/ConsumerPHR/GetVaccinationList', data);
        }

        function UpdateVaccinationData(data) {
            var self = this;
            return self.saveNew('api/ConsumerPHR/UpdateVaccinationData', data);
        }

        function CreateVaccinationChart(consumerId) {
            var self = this;
            var data = {
                ConsumerID: consumerId
            };
            //console.log(data);
            return self.saveNew('api/ConsumerPHR/CreateVaccinationDetails', data);
        }

        function getVaccDoctors(term) {
            var term = { term: term };
            var self = this;
            return self.getwithparm('api/Utility/GetRegisteredDoctors', term);

        }

        function getVaccHospitals(term) {
            var term = { term: term };
            var self = this;
            return self.getwithparm('api/Utility/GetRegisteredHospitals', term);
        }

    }
})();