﻿(function () {
    'use strict';

    // Factory name is handy for logging
    var serviceId = 'routeMediator';

    // Define the factory on the module.
    // Inject the dependencies. 
    // Point to the factory definition function.
    // TODO: replace app with your module name
    angular.module('app').factory(serviceId, ['$rootScope', '$location', 'userService','activeMenu', routeMediator]);

    function routeMediator($rootScope, $location, userService, activeMenu) {
        // Define the functions and properties to reveal.
        var service = {
            setRoutingHandlers: setRoutingHandlers
        };

        return service;

        function setRoutingHandlers() {
            handleRouting();
            //handleRoutingErrors();
        }

        //#region Internal Methods        
        function handleRouting() {
            $rootScope.$on('$routeChangeStart', function (event, currRoute, prevRoute) {
                //For some reason when the back button gets fired, the app hangs; as a safety measure close all the modals
                $('.modal').modal('hide');
                jQuery.datepicker._hideDatepicker;
                activeMenu.menuName = currRoute.title;
                /*Handling of history functionality*/
                if (currRoute.originalPath == '/dashboard') {
                    activeMenu.isHome = true;
                }
                else {
                    activeMenu.isHome = false;
                }
                console.log(activeMenu);
                if ((currRoute.canViewWithoutLogin == undefined || currRoute.canViewWithoutLogin == false) && !userService.isLogged) {
                   //It might be that this is because of refresh; In that case, check with the server
                    event.preventDefault();
                    $location.url('/registration');
                }

            });
        }
        //#endregion
    }
})();