﻿(function () {
    'use strict';
    var controllerId = 'myFavourite';
    angular.module('app').controller(controllerId, ['common', 'datacontext', '$scope', '$location', '$rootScope', 'datarepo','$route', myFavourite]);

    function myFavourite(common, datacontext, $scope, $location, $rootScope, datarepo, $route) {
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');

        var vm = this;
        vm.title = 'My Favourites';
        vm.doctorsInfo = [];
        vm.favouriteDoctors = [];
        $scope.otpbtn = true;
        $scope.otptext = true;
        $scope.userRate = 0;
        $scope.selectedDoctorName = '';
        $scope.selectedDoctorSpecialization = '';
        $scope.selectedDoctorID = '';
        vm.noFavouriteDoctors = false;
        vm.scheduleAvailable = false;

        //Rating configuration
        vm.rateDoctorName = "";
        vm.myRating = '';
        vm.max = 5;

        $scope.toggleDetail = function ($index) {
            $scope.activePosition = $scope.activePosition == $index ? -1 : $index;
            console.log(vm.favouriteDoctors[$index]);
            $scope.selectedDoctorName = vm.favouriteDoctors[$index].providerName; 
            $scope.selectedDoctorID = vm.favouriteDoctors[$index].providerID;
            vm.rateDoctorName = $scope.selectedDoctorName;
            $scope.selectedDoctorSpecialization = vm.favouriteDoctors[$index].specializationName;
        };

        var date = new Date();
        var date = date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
        $scope.slotdate = date;

        var hospitalRebookClick;

        $scope.hospitalRebookClick = function (id) {
            hospitalRebookClick = id;
        };

        $scope.hospitalRebookToShowHide = function (id) {

            return hospitalRebookClick == id;
        };


        var timeRebookSlotClick;

        $scope.timeRebookSlotClick = function (id) {
            timeRebookSlotClick = id;
        };

        $scope.timeRebookSlotToShowHide = function (id) {

            return timeRebookSlotClick == id;
        };

        vm.deletemyfavourite = function (index) {
            var providerID = vm.favouriteDoctors[index].providerID;
            var favouriteDoctorsID = vm.favouriteDoctors[index].myFavouriteDoctorsID;
            vm.favouriteDoctors.splice(vm.favouriteDoctors.indexOf(vm.favouriteDoctors[index]), 1);
            return datacontext.appointment.deletefavouriteDoctor(providerID, favouriteDoctorsID).then(function (response) {
                if (response.myFavouriteDoctors.length == 0) {
                    vm.noFavouriteDoctors = true;
                }
                logSuccess(response.message, '', true);
                vm.favouriteDoctors = response.myFavouriteDoctors;
            }, function (response) {
                logError(response.message, '', true);
            });

        }

        vm.saveRating = function () {
            return datacontext.appointment.saveMyFavouriteDoctorRating($scope.selectedDoctorID, vm.myRating).then(function (response) {
                logSuccess("Rating added successfully", '', true);
                $('#doctorRatingModal').modal('hide');
                getFavouriteDoctors();
            }, function (response) {
                logError(response.message, '', true);
                $('#doctorRatingModal').modal('hide');              
             });
        }

        $scope.shareDoctor = function () {
            $scope.share = confirm("Do you wish to share this doctor ?");
            if ($scope.share == true) {
                return datacontext.appointment.GetScheduleForProvider($scope.selectedDoctorID).then(function (result) {
                    console.log(result);
                    var message = "";
                    for (var i = 0; i < result.length; i++) {                        
                        for (var j = 0; j < result[i].scheduleForMobile.length; j++) {
                            if (i == 0 && j == 0) {
                                message = message + "Dr." + $scope.selectedDoctorName + " (" + $scope.selectedDoctorSpecialization + ")" + " will be available in " + result[i].hospitalName + ", " + result[i].hospitalLocation + " on " + result[i].scheduleForMobile[j].day + " between " + result[i].scheduleForMobile[j].startTime + "-" + result[i].scheduleForMobile[j].endTime;                                
                            }
                            else {
                                message = message + "; in " + result[i].hospitalName + ", " + result[i].hospitalLocation + " on " + result[i].scheduleForMobile[j].day + " between " + result[i].scheduleForMobile[j].startTime + "-" + result[i].scheduleForMobile[j].endTime;
                            }
                        }
                    }
                    message = message + ".";
                    console.log(message);
                    common.shareSocially(message);
                    return true;
                });
               
            }
        }

        vm.bookAnAppointment = function (index) {
            var providerID = vm.favouriteDoctors[index].providerID;
            var providerName = vm.favouriteDoctors[index].providerName;
            datarepo.commonrepo.saveProviderID(providerID, providerName);
            $location.path('/book_appointment');
            $scope.selectedDoctorName = vm.favouriteDoctors[index].providerName;
            $scope.selectedDocName = vm.favouriteDoctors[index].providerName;
            $scope.selectedDocId = vm.favouriteDoctors[index].providerID;
            $scope.hosName = vm.favouriteDoctors[index].specializationName;var date = new Date();
            var date = date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate();
            datarepo.commonrepo.saveProviderID($scope.selectedDocId, $scope.selectedDoctorName);

            getListOfTimeSlot(date, $scope.selectedDocId);
            $('#favorite-book-modal').modal('show');
        }




        function getFavouriteDoctors() {
            return datacontext.registration.getFavouriteDoctors().then(function (data) {
                vm.favouriteDoctors = data;
                if (vm.favouriteDoctors.length == 0) {
                    vm.noFavouriteDoctors = true;
                }
                else {
                    vm.noFavouriteDoctors = false;
                }
                console.log(vm.favouriteDoctors);
                return vm.favouriteDoctors;

            });
        }
        activate();

        function activate() {
            var promises = [getFavouriteDoctors()];
            common.activateController(promises, controllerId);
            //.then(function () { log('Favourites View'); });
        }



    }
})();