﻿(function () {
    'use strict';
    var controllerId = 'suggestDoctor';
    angular.module('app').controller(controllerId, ['common', '$scope', '$location', '$rootScope', 'datacontext', 'datarepo','searchCriteria', suggestDoctor ]);

    function suggestDoctor(common, $scope, $location, $rootScope, datacontext, datarepo, searchCriteria) {
        var vm = this;
        var getLogFn = common.logger.getLogFn;
        var log = getLogFn(controllerId);
        var logSuccess = getLogFn(controllerId, 'success');
        var logError = getLogFn(controllerId, 'error');
        vm.suggestedDoctorName = '';
        vm.suggestedDoctorSpecialization = '';
        vm.suggestedDoctorLocation = '';
        vm.responseMessage = '';
        vm.prevSuggestionInfo = '';
        vm.selecteDoctorSpecialization = '';
        vm.DoctorName = '';
        var commonDropdowntwoListSpec = [];
        vm.commonSpecializations = [];
        var commonSpec = [];
        $scope.flag = false;
        $scope.commonSpecializationsListOptionsText = "SHOW ALL";
        $scope.showAll = false;

        vm.hideAllSelection = false;

        $scope.toggleAll = function () {
            $scope.showAll = !$scope.showAll;
            if ($scope.flag == false) {
                getDoctorSpecialization();
            }
            $scope.flag = true;
            if ($scope.commonSpecializationsListOptionsText == "SHOW ALL") {
                $scope.commonSpecializationsListOptionsText = "HIDE ALL";
            }
            else if ($scope.commonSpecializationsListOptionsText == "HIDE ALL") {
                $scope.commonSpecializationsListOptionsText = "SHOW ALL";
            }
        }

        vm.commonDropDownTwoOption = function (specializationList) {
            $('#common-Drop-Down-Two-modal').modal('hide');
            vm.hideDropdown = true;

            vm.selectedSpecializationName = specializationList.value;
            vm.selectedSpecializationId = specializationList.key;
        }

        activate();

        function getDoctorSpecialization() {

            //return datacontext.cacheservice.getDropDownValues('DoctorSpecialization').then(function (data) {
            //    var commonDropdownListSpec = [];
            //    for (var i = 0; i < data.length; i++) {
            //        commonDropdownListSpec.push({ key: data[i].value, value: data[i].displayText, Type: "Specialization" });
            //    }

            //    return vm.commonDropDownList = commonDropdownListSpec;
            //});
            return datacontext.cacheservice.getDropDownValues('DoctorSpecialization').then(function (data) {
                vm.selectedSpecializationName = "";
                vm.selectedSpecializationId = 0;
                for (var i = 0; i < data.length; i++) {
                    commonDropdowntwoListSpec.push({ key: data[i].value, value: data[i].displayText, Type: "Specialization" });
                }

                vm.commonDropDownTwoList = commonDropdowntwoListSpec;
                //console.log(vm.commonDropDownTwoList);
                if (!IsLowEndPhone) { $('#common-Drop-Down-Two-modal').modal('show'); }
                return vm.commonDropDownTwoList;
            });
        }

        function getAvailableCities() {

            return datacontext.cacheservice.getAvailableCities().then(function (data) {
                var commonDropdownListCity = [];
                for (var i = 0; i < data[0].citiesAvailable.length; i++) {
                    commonDropdownListCity.push({ key: data[0].citiesAvailable[i].demographyCode, value: data[0].citiesAvailable[i].demographyName, Type: "City" });
                }

               return vm.commonDropDownList = commonDropdownListCity;
            });
        }

        function setSearchedInfo() {
            if (searchCriteria.cityId > 0) {
                vm.selectedDemographyId = searchCriteria.cityId;
                vm.selectedDemographyname = searchCriteria.cityName;
            }
            else {
                vm.selectedDemographyId = 0;
                vm.selectedDemographyname = '';
            }
            if (searchCriteria.locationname == "Location not available (Choose a location)") {
                vm.selectedDemographyId = "";
                vm.selectedDemographyname = "";
            }
           

            vm.selectedSpecializationName = searchCriteria.specializationName;
            vm.selectedSpecializationId = searchCriteria.specializationId

            vm.DoctorName = searchCriteria.doctorName;
        }
        vm.commonDropDownOption = function (cityList) {
            $('#common-drop-down-modal').modal('hide');
            if (cityList.Type == "City") {
                vm.selectedDemographyId = cityList.key;
                vm.selectedDemographyname = cityList.value;
            }
            else {
                vm.selectedSpecializationName = cityList.value;
                vm.selectedSpecializationId = cityList.key;
            }
        }

        vm.submit = function () {

            if (vm.DoctorName == '' && vm.selectedSpecializationId == '' && vm.selectedDemographyId == '') {
                logError("Please fill up all the fields", '', true);
            }
            else if (vm.DoctorName == '') {
                logError("Please enter the doctor name", '', true);
            }
            else if (vm.selectedSpecializationId == '') {
                logError("Please choose the doctor's specialization", '', true);
            }
            else if (vm.selectedDemographyId == '') {
                logError("Please choose the doctor's location", '', true);
            }
            else {
                return datacontext.appointment.submitSuggestionInfo(vm.DoctorName, vm.selectedSpecializationId, vm.selectedSpecializationName, vm.selectedDemographyId, vm.selectedDemographyname).then(function (httpResponse) {
                    logSuccess(httpResponse.message, '', true);
                    $location.path('/previousRecommendations');
                });
            }

        }

        $scope.openSpecModal = function () {

            //getDoctorSpecialization();
            //vm.commonDropDownHeader = "Choose Specialization";
            //vm.commonDropDownFilterDisplay = true;
            //vm.commonDropDownFilteredValue = "";
            //vm.commonDropDownPlaceHoldertext = "Fiter Specialization";
            //$('#common-drop-down-modal').modal('show');
           // getCommonSpecializations();
            vm.commonDropDownTwoHeader = "Choose Specialization";
            vm.commonDropDownTwoFilterDisplay = true;
            vm.commonDropDownTwoFilteredValue = "";
            vm.commonDropDownTwoPlaceHoldertext = "Filter Specialization";
            $('#common-Drop-Down-Two-modal').modal('show');

        }


        $scope.selectSpecialization = function (doctorSpec) {
            console.log(doctorSpec.value);
            $scope.selectedSpecialization = doctorSpec;
            $('#sugDocSpecModal').modal('hide');
        }

        $scope.openCityModal = function () {
            getAvailableCities();
            vm.commonDropDownHeader = "Choose City";
            vm.commonDropDownFilterDisplay = false;
            vm.commonDropDownFilteredValue = "";
            vm.commonDropDownPlaceHoldertext = "Fiter City";
            $('#common-drop-down-modal').modal('show');
        }
        $scope.selectCity = function (cityDetails) {
            console.log(cityDetails.value);
            $scope.selectedCity = cityDetails;
            $('#sugDocCityModal').modal('hide');
        }

        function getCommonSpecializations() {
            commonSpec = [];
            return datacontext.cacheservice.getCommonSpecializations().then(function (data) {
                for (var i = 0; i < data.length; i++) {
                    commonSpec.push({ key: data[i].value, value: data[i].displayText, Type: "Specialization" });
                }
                vm.commonSpecializations = commonSpec;

                return vm.commonSpecializations;

            });
        }

        function activate() {
            var promises = [getCommonSpecializations(), getAvailableCities(), setSearchedInfo()];
            common.activateController(promises, controllerId);
        }

    }
})();